/* datepicker.c generated by valac 0.56.18, the Vala compiler
 * generated from datepicker.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2021 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_DATE_PICKER_0_PROPERTY,
	SEAHORSE_DATE_PICKER_DATETIME_PROPERTY,
	SEAHORSE_DATE_PICKER_NUM_PROPERTIES
};
static GParamSpec* seahorse_date_picker_properties[SEAHORSE_DATE_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SeahorseDatePickerPrivate {
	GtkEntry* date_entry;
	GtkPopover* calendar_popover;
	GtkCalendar* calendar;
	GDateTime* _datetime;
};

static gint SeahorseDatePicker_private_offset;
static gpointer seahorse_date_picker_parent_class = NULL;

static void seahorse_date_picker_on_date_entry_activated (SeahorseDatePicker* self,
                                                   GtkEntry* date_entry);
static void seahorse_date_picker_on_calendar_day_selected (SeahorseDatePicker* self,
                                                    GtkCalendar* calendar);
static void seahorse_date_picker_on_calendar_primary_click (SeahorseDatePicker* self,
                                                     GtkGestureClick* gesture,
                                                     gint n_press,
                                                     gdouble x,
                                                     gdouble y);
static GObject * seahorse_date_picker_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static void _seahorse_date_picker_on_date_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                       gpointer self);
static void _seahorse_date_picker_on_calendar_day_selected_gtk_calendar_day_selected (GtkCalendar* _sender,
                                                                               gpointer self);
static void _seahorse_date_picker_on_calendar_primary_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                                gint n_press,
                                                                                gdouble x,
                                                                                gdouble y,
                                                                                gpointer self);
static void seahorse_date_picker_finalize (GObject * obj);
static GType seahorse_date_picker_get_type_once (void);
static void _vala_seahorse_date_picker_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_seahorse_date_picker_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
seahorse_date_picker_get_instance_private (SeahorseDatePicker* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseDatePicker_private_offset);
}

static void
seahorse_date_picker_on_date_entry_activated (SeahorseDatePicker* self,
                                              GtkEntry* date_entry)
{
	gint y = 0;
	gint m = 0;
	gint d = 0;
	const gchar* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_;
	GDateTime* parsed_date = NULL;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
#line 79 "../common/datepicker.vala"
	g_return_if_fail (self != NULL);
#line 79 "../common/datepicker.vala"
	g_return_if_fail (date_entry != NULL);
#line 83 "../common/datepicker.vala"
	_tmp0_ = gtk_editable_get_text ((GtkEditable*) date_entry);
#line 83 "../common/datepicker.vala"
	_tmp4_ = sscanf (_tmp0_, "%d-%d-%d", &_tmp1_, &_tmp2_, &_tmp3_);
#line 83 "../common/datepicker.vala"
	y = _tmp1_;
#line 83 "../common/datepicker.vala"
	m = _tmp2_;
#line 83 "../common/datepicker.vala"
	d = _tmp3_;
#line 83 "../common/datepicker.vala"
	if (_tmp4_ != 3) {
#line 84 "../common/datepicker.vala"
		return;
#line 138 "datepicker.c"
	}
#line 86 "../common/datepicker.vala"
	_tmp5_ = g_date_time_new_utc (y, m, d, 0, 0, (gdouble) 0);
#line 86 "../common/datepicker.vala"
	parsed_date = _tmp5_;
#line 88 "../common/datepicker.vala"
	_tmp6_ = parsed_date;
#line 88 "../common/datepicker.vala"
	if (_tmp6_ == NULL) {
#line 89 "../common/datepicker.vala"
		_g_date_time_unref0 (parsed_date);
#line 89 "../common/datepicker.vala"
		return;
#line 152 "datepicker.c"
	}
#line 91 "../common/datepicker.vala"
	_tmp7_ = parsed_date;
#line 91 "../common/datepicker.vala"
	seahorse_date_picker_set_datetime (self, _tmp7_);
#line 79 "../common/datepicker.vala"
	_g_date_time_unref0 (parsed_date);
#line 160 "datepicker.c"
}

static void
seahorse_date_picker_on_calendar_day_selected (SeahorseDatePicker* self,
                                               GtkCalendar* calendar)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GDateTime* _tmp6_;
	GDateTime* _tmp7_;
#line 94 "../common/datepicker.vala"
	g_return_if_fail (self != NULL);
#line 94 "../common/datepicker.vala"
	g_return_if_fail (calendar != NULL);
#line 98 "../common/datepicker.vala"
	g_object_get (calendar, "year", &_tmp0_, NULL);
#line 98 "../common/datepicker.vala"
	_tmp1_ = _tmp0_;
#line 98 "../common/datepicker.vala"
	g_object_get (calendar, "month", &_tmp2_, NULL);
#line 98 "../common/datepicker.vala"
	_tmp3_ = _tmp2_;
#line 98 "../common/datepicker.vala"
	g_object_get (calendar, "day", &_tmp4_, NULL);
#line 98 "../common/datepicker.vala"
	_tmp5_ = _tmp4_;
#line 98 "../common/datepicker.vala"
	_tmp6_ = g_date_time_new_utc (_tmp1_, _tmp3_, _tmp5_, 0, 0, (gdouble) 0);
#line 98 "../common/datepicker.vala"
	_tmp7_ = _tmp6_;
#line 98 "../common/datepicker.vala"
	seahorse_date_picker_set_datetime (self, _tmp7_);
#line 98 "../common/datepicker.vala"
	_g_date_time_unref0 (_tmp7_);
#line 199 "datepicker.c"
}

static void
seahorse_date_picker_on_calendar_primary_click (SeahorseDatePicker* self,
                                                GtkGestureClick* gesture,
                                                gint n_press,
                                                gdouble x,
                                                gdouble y)
{
	GDateTime* selected_date = NULL;
	GtkCalendar* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 102 "../common/datepicker.vala"
	g_return_if_fail (self != NULL);
#line 102 "../common/datepicker.vala"
	g_return_if_fail (gesture != NULL);
#line 103 "../common/datepicker.vala"
	if (n_press != 2) {
#line 104 "../common/datepicker.vala"
		return;
#line 221 "datepicker.c"
	}
#line 106 "../common/datepicker.vala"
	_tmp0_ = self->priv->calendar;
#line 106 "../common/datepicker.vala"
	_tmp1_ = gtk_calendar_get_date (_tmp0_);
#line 106 "../common/datepicker.vala"
	selected_date = _tmp1_;
#line 107 "../common/datepicker.vala"
	_tmp2_ = selected_date;
#line 107 "../common/datepicker.vala"
	if (_tmp2_ != NULL) {
#line 233 "datepicker.c"
		GtkPopover* _tmp3_;
#line 108 "../common/datepicker.vala"
		_tmp3_ = self->priv->calendar_popover;
#line 108 "../common/datepicker.vala"
		gtk_popover_popdown (_tmp3_);
#line 239 "datepicker.c"
	}
#line 102 "../common/datepicker.vala"
	_g_date_time_unref0 (selected_date);
#line 243 "datepicker.c"
}

SeahorseDatePicker*
seahorse_date_picker_construct (GType object_type)
{
	SeahorseDatePicker * self = NULL;
#line 25 "../common/datepicker.vala"
	self = (SeahorseDatePicker*) g_object_new (object_type, NULL);
#line 25 "../common/datepicker.vala"
	return self;
#line 254 "datepicker.c"
}

SeahorseDatePicker*
seahorse_date_picker_new (void)
{
#line 25 "../common/datepicker.vala"
	return seahorse_date_picker_construct (SEAHORSE_TYPE_DATE_PICKER);
#line 262 "datepicker.c"
}

GDateTime*
seahorse_date_picker_get_datetime (SeahorseDatePicker* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 33 "../common/datepicker.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../common/datepicker.vala"
	_tmp0_ = self->priv->_datetime;
#line 33 "../common/datepicker.vala"
	result = _tmp0_;
#line 33 "../common/datepicker.vala"
	return result;
#line 278 "datepicker.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 38 "../common/datepicker.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 286 "datepicker.c"
}

void
seahorse_date_picker_set_datetime (SeahorseDatePicker* self,
                                   GDateTime* value)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GtkEntry* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GtkCalendar* _tmp5_;
#line 34 "../common/datepicker.vala"
	g_return_if_fail (self != NULL);
#line 35 "../common/datepicker.vala"
	_tmp0_ = self->priv->_datetime;
#line 35 "../common/datepicker.vala"
	if (g_date_time_equal (_tmp0_, value)) {
#line 36 "../common/datepicker.vala"
		return;
#line 307 "datepicker.c"
	}
#line 38 "../common/datepicker.vala"
	_tmp1_ = _g_date_time_ref0 (value);
#line 38 "../common/datepicker.vala"
	_g_date_time_unref0 (self->priv->_datetime);
#line 38 "../common/datepicker.vala"
	self->priv->_datetime = _tmp1_;
#line 39 "../common/datepicker.vala"
	_tmp2_ = self->priv->date_entry;
#line 39 "../common/datepicker.vala"
	_tmp3_ = g_date_time_format (value, "%F");
#line 39 "../common/datepicker.vala"
	_tmp4_ = _tmp3_;
#line 39 "../common/datepicker.vala"
	gtk_editable_set_text ((GtkEditable*) _tmp2_, _tmp4_);
#line 39 "../common/datepicker.vala"
	_g_free0 (_tmp4_);
#line 40 "../common/datepicker.vala"
	_tmp5_ = self->priv->calendar;
#line 40 "../common/datepicker.vala"
	gtk_calendar_select_day (_tmp5_, value);
#line 34 "../common/datepicker.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_date_picker_properties[SEAHORSE_DATE_PICKER_DATETIME_PROPERTY]);
#line 331 "datepicker.c"
}

static void
_seahorse_date_picker_on_date_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                  gpointer self)
{
#line 53 "../common/datepicker.vala"
	seahorse_date_picker_on_date_entry_activated ((SeahorseDatePicker*) self, _sender);
#line 340 "datepicker.c"
}

static void
_seahorse_date_picker_on_calendar_day_selected_gtk_calendar_day_selected (GtkCalendar* _sender,
                                                                          gpointer self)
{
#line 69 "../common/datepicker.vala"
	seahorse_date_picker_on_calendar_day_selected ((SeahorseDatePicker*) self, _sender);
#line 349 "datepicker.c"
}

static void
_seahorse_date_picker_on_calendar_primary_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                           gint n_press,
                                                                           gdouble x,
                                                                           gdouble y,
                                                                           gpointer self)
{
#line 75 "../common/datepicker.vala"
	seahorse_date_picker_on_calendar_primary_click ((SeahorseDatePicker*) self, _sender, n_press, x, y);
#line 361 "datepicker.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../common/datepicker.vala"
	return self ? g_object_ref (self) : NULL;
#line 369 "datepicker.c"
}

static GObject *
seahorse_date_picker_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseDatePicker * self;
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	GtkEntry* _tmp4_;
	GtkEntry* _tmp5_;
	GtkMenuButton* calendar_button = NULL;
	GtkMenuButton* _tmp6_;
	GtkMenuButton* _tmp7_;
	GtkMenuButton* _tmp8_;
	GtkPopover* _tmp9_;
	GtkMenuButton* _tmp10_;
	GtkPopover* _tmp11_;
	GtkCalendar* _tmp12_;
	GtkCalendar* _tmp13_;
	GtkCalendar* _tmp14_;
	GtkCalendar* _tmp15_;
	GtkPopover* _tmp16_;
	GtkCalendar* _tmp17_;
	GtkGestureClick* gesture = NULL;
	GtkGestureClick* _tmp18_;
	GtkGestureClick* _tmp19_;
	GtkGestureClick* _tmp20_;
	GtkCalendar* _tmp21_;
	GtkGestureClick* _tmp22_;
	GtkEventController* _tmp23_;
#line 44 "../common/datepicker.vala"
	parent_class = G_OBJECT_CLASS (seahorse_date_picker_parent_class);
#line 44 "../common/datepicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../common/datepicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_DATE_PICKER, SeahorseDatePicker);
#line 45 "../common/datepicker.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_HORIZONTAL);
#line 46 "../common/datepicker.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, "linked");
#line 49 "../common/datepicker.vala"
	_tmp0_ = (GtkEntry*) gtk_entry_new ();
#line 49 "../common/datepicker.vala"
	g_object_ref_sink (_tmp0_);
#line 49 "../common/datepicker.vala"
	_g_object_unref0 (self->priv->date_entry);
#line 49 "../common/datepicker.vala"
	self->priv->date_entry = _tmp0_;
#line 50 "../common/datepicker.vala"
	_tmp1_ = self->priv->date_entry;
#line 50 "../common/datepicker.vala"
	gtk_entry_set_max_length (_tmp1_, 10);
#line 51 "../common/datepicker.vala"
	_tmp2_ = self->priv->date_entry;
#line 51 "../common/datepicker.vala"
	gtk_editable_set_max_width_chars ((GtkEditable*) _tmp2_, 10);
#line 52 "../common/datepicker.vala"
	_tmp3_ = self->priv->date_entry;
#line 52 "../common/datepicker.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Enter the date directly"));
#line 53 "../common/datepicker.vala"
	_tmp4_ = self->priv->date_entry;
#line 53 "../common/datepicker.vala"
	g_signal_connect_object (_tmp4_, "activate", (GCallback) _seahorse_date_picker_on_date_entry_activated_gtk_entry_activate, self, 0);
#line 54 "../common/datepicker.vala"
	_tmp5_ = self->priv->date_entry;
#line 54 "../common/datepicker.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp5_);
#line 57 "../common/datepicker.vala"
	_tmp6_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 57 "../common/datepicker.vala"
	g_object_ref_sink (_tmp6_);
#line 57 "../common/datepicker.vala"
	calendar_button = _tmp6_;
#line 58 "../common/datepicker.vala"
	_tmp7_ = calendar_button;
#line 58 "../common/datepicker.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Select the date from a calendar"));
#line 59 "../common/datepicker.vala"
	_tmp8_ = calendar_button;
#line 59 "../common/datepicker.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp8_);
#line 62 "../common/datepicker.vala"
	_tmp9_ = (GtkPopover*) gtk_popover_new ();
#line 62 "../common/datepicker.vala"
	g_object_ref_sink (_tmp9_);
#line 62 "../common/datepicker.vala"
	_g_object_unref0 (self->priv->calendar_popover);
#line 62 "../common/datepicker.vala"
	self->priv->calendar_popover = _tmp9_;
#line 63 "../common/datepicker.vala"
	_tmp10_ = calendar_button;
#line 63 "../common/datepicker.vala"
	_tmp11_ = self->priv->calendar_popover;
#line 63 "../common/datepicker.vala"
	gtk_menu_button_set_popover (_tmp10_, _tmp11_);
#line 66 "../common/datepicker.vala"
	_tmp12_ = (GtkCalendar*) gtk_calendar_new ();
#line 66 "../common/datepicker.vala"
	g_object_ref_sink (_tmp12_);
#line 66 "../common/datepicker.vala"
	_g_object_unref0 (self->priv->calendar);
#line 66 "../common/datepicker.vala"
	self->priv->calendar = _tmp12_;
#line 67 "../common/datepicker.vala"
	_tmp13_ = self->priv->calendar;
#line 67 "../common/datepicker.vala"
	gtk_calendar_set_show_day_names (_tmp13_, TRUE);
#line 68 "../common/datepicker.vala"
	_tmp14_ = self->priv->calendar;
#line 68 "../common/datepicker.vala"
	gtk_calendar_set_show_heading (_tmp14_, TRUE);
#line 69 "../common/datepicker.vala"
	_tmp15_ = self->priv->calendar;
#line 69 "../common/datepicker.vala"
	g_signal_connect_object (_tmp15_, "day-selected", (GCallback) _seahorse_date_picker_on_calendar_day_selected_gtk_calendar_day_selected, self, 0);
#line 70 "../common/datepicker.vala"
	_tmp16_ = self->priv->calendar_popover;
#line 70 "../common/datepicker.vala"
	_tmp17_ = self->priv->calendar;
#line 70 "../common/datepicker.vala"
	gtk_popover_set_child (_tmp16_, (GtkWidget*) _tmp17_);
#line 73 "../common/datepicker.vala"
	_tmp18_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 73 "../common/datepicker.vala"
	gesture = _tmp18_;
#line 74 "../common/datepicker.vala"
	_tmp19_ = gesture;
#line 74 "../common/datepicker.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp19_, (guint) GDK_BUTTON_PRIMARY);
#line 75 "../common/datepicker.vala"
	_tmp20_ = gesture;
#line 75 "../common/datepicker.vala"
	g_signal_connect_object (_tmp20_, "pressed", (GCallback) _seahorse_date_picker_on_calendar_primary_click_gtk_gesture_click_pressed, self, 0);
#line 76 "../common/datepicker.vala"
	_tmp21_ = self->priv->calendar;
#line 76 "../common/datepicker.vala"
	_tmp22_ = gesture;
#line 76 "../common/datepicker.vala"
	_tmp23_ = _g_object_ref0 ((GtkEventController*) _tmp22_);
#line 76 "../common/datepicker.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp21_, _tmp23_);
#line 44 "../common/datepicker.vala"
	_g_object_unref0 (gesture);
#line 44 "../common/datepicker.vala"
	_g_object_unref0 (calendar_button);
#line 44 "../common/datepicker.vala"
	return obj;
#line 524 "datepicker.c"
}

static void
seahorse_date_picker_class_init (SeahorseDatePickerClass * klass,
                                 gpointer klass_data)
{
#line 25 "../common/datepicker.vala"
	seahorse_date_picker_parent_class = g_type_class_peek_parent (klass);
#line 25 "../common/datepicker.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseDatePicker_private_offset);
#line 25 "../common/datepicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_date_picker_get_property;
#line 25 "../common/datepicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_date_picker_set_property;
#line 25 "../common/datepicker.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_date_picker_constructor;
#line 25 "../common/datepicker.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_date_picker_finalize;
#line 25 "../common/datepicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_DATE_PICKER_DATETIME_PROPERTY, seahorse_date_picker_properties[SEAHORSE_DATE_PICKER_DATETIME_PROPERTY] = g_param_spec_boxed ("datetime", "datetime", "datetime", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 545 "datepicker.c"
}

static void
seahorse_date_picker_instance_init (SeahorseDatePicker * self,
                                    gpointer klass)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
#line 25 "../common/datepicker.vala"
	self->priv = seahorse_date_picker_get_instance_private (self);
#line 31 "../common/datepicker.vala"
	_tmp0_ = g_time_zone_new_local ();
#line 31 "../common/datepicker.vala"
	_tmp1_ = _tmp0_;
#line 31 "../common/datepicker.vala"
	_tmp2_ = g_date_time_new_now (_tmp1_);
#line 31 "../common/datepicker.vala"
	self->priv->_datetime = _tmp2_;
#line 31 "../common/datepicker.vala"
	_g_time_zone_unref0 (_tmp1_);
#line 567 "datepicker.c"
}

static void
seahorse_date_picker_finalize (GObject * obj)
{
	SeahorseDatePicker * self;
#line 25 "../common/datepicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_DATE_PICKER, SeahorseDatePicker);
#line 27 "../common/datepicker.vala"
	_g_object_unref0 (self->priv->date_entry);
#line 28 "../common/datepicker.vala"
	_g_object_unref0 (self->priv->calendar_popover);
#line 29 "../common/datepicker.vala"
	_g_object_unref0 (self->priv->calendar);
#line 31 "../common/datepicker.vala"
	_g_date_time_unref0 (self->priv->_datetime);
#line 25 "../common/datepicker.vala"
	G_OBJECT_CLASS (seahorse_date_picker_parent_class)->finalize (obj);
#line 586 "datepicker.c"
}

/**
 * Shows a configurable date. A user can configure it by either manually
 * changing a {@link Gtk.Entry} or by opening up a popover with a
 * {@link Gtk.Calendar} and finding the right date there.
 */
 G_GNUC_NO_INLINE static GType
seahorse_date_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseDatePickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_date_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseDatePicker), 0, (GInstanceInitFunc) seahorse_date_picker_instance_init, NULL };
	GType seahorse_date_picker_type_id;
	seahorse_date_picker_type_id = g_type_register_static (gtk_box_get_type (), "SeahorseDatePicker", &g_define_type_info, 0);
	SeahorseDatePicker_private_offset = g_type_add_instance_private (seahorse_date_picker_type_id, sizeof (SeahorseDatePickerPrivate));
	return seahorse_date_picker_type_id;
}

GType
seahorse_date_picker_get_type (void)
{
	static gsize seahorse_date_picker_type_id__once = 0;
	if (g_once_init_enter (&seahorse_date_picker_type_id__once)) {
		GType seahorse_date_picker_type_id;
		seahorse_date_picker_type_id = seahorse_date_picker_get_type_once ();
		g_once_init_leave (&seahorse_date_picker_type_id__once, seahorse_date_picker_type_id);
	}
	return seahorse_date_picker_type_id__once;
}

static void
_vala_seahorse_date_picker_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	SeahorseDatePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_DATE_PICKER, SeahorseDatePicker);
#line 25 "../common/datepicker.vala"
	switch (property_id) {
#line 25 "../common/datepicker.vala"
		case SEAHORSE_DATE_PICKER_DATETIME_PROPERTY:
#line 25 "../common/datepicker.vala"
		g_value_set_boxed (value, seahorse_date_picker_get_datetime (self));
#line 25 "../common/datepicker.vala"
		break;
#line 632 "datepicker.c"
		default:
#line 25 "../common/datepicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../common/datepicker.vala"
		break;
#line 638 "datepicker.c"
	}
}

static void
_vala_seahorse_date_picker_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	SeahorseDatePicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_DATE_PICKER, SeahorseDatePicker);
#line 25 "../common/datepicker.vala"
	switch (property_id) {
#line 25 "../common/datepicker.vala"
		case SEAHORSE_DATE_PICKER_DATETIME_PROPERTY:
#line 25 "../common/datepicker.vala"
		seahorse_date_picker_set_datetime (self, g_value_get_boxed (value));
#line 25 "../common/datepicker.vala"
		break;
#line 658 "datepicker.c"
		default:
#line 25 "../common/datepicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../common/datepicker.vala"
		break;
#line 664 "datepicker.c"
	}
}

