/* deletable.c generated by valac 0.56.18, the Vala compiler
 * generated from deletable.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004,2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <glib-object.h>
#include <glib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

static GType seahorse_deletable_get_type_once (void);

gboolean
seahorse_deletable_can_delete (GObject* object)
{
	gboolean result;
#line 33 "../common/deletable.vala"
	g_return_val_if_fail (object != NULL, FALSE);
#line 34 "../common/deletable.vala"
	if (SEAHORSE_IS_DELETABLE (object)) {
#line 48 "deletable.c"
		gboolean _tmp0_;
		gboolean _tmp1_;
#line 35 "../common/deletable.vala"
		_tmp0_ = seahorse_deletable_get_deletable (G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_DELETABLE, SeahorseDeletable));
#line 35 "../common/deletable.vala"
		_tmp1_ = _tmp0_;
#line 35 "../common/deletable.vala"
		result = _tmp1_;
#line 35 "../common/deletable.vala"
		return result;
#line 59 "deletable.c"
	}
#line 36 "../common/deletable.vala"
	result = FALSE;
#line 36 "../common/deletable.vala"
	return result;
#line 65 "deletable.c"
}

/**
     * Creates a {@link DeleteOperation} that will perform the actual deletion
     * of this object.
     */
SeahorseDeleteOperation*
seahorse_deletable_create_delete_operation (SeahorseDeletable* self)
{
	SeahorseDeletableIface* _iface_;
#line 43 "../common/deletable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../common/deletable.vala"
	_iface_ = SEAHORSE_DELETABLE_GET_INTERFACE (self);
#line 43 "../common/deletable.vala"
	if (_iface_->create_delete_operation) {
#line 43 "../common/deletable.vala"
		return _iface_->create_delete_operation (self);
#line 84 "deletable.c"
	}
#line 43 "../common/deletable.vala"
	return NULL;
#line 88 "deletable.c"
}

gboolean
seahorse_deletable_get_deletable (SeahorseDeletable* self)
{
	SeahorseDeletableIface* _iface_;
#line 31 "../common/deletable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../common/deletable.vala"
	_iface_ = SEAHORSE_DELETABLE_GET_INTERFACE (self);
#line 31 "../common/deletable.vala"
	if (_iface_->get_deletable) {
#line 31 "../common/deletable.vala"
		return _iface_->get_deletable (self);
#line 103 "deletable.c"
	}
#line 31 "../common/deletable.vala"
	return FALSE;
#line 107 "deletable.c"
}

static void
seahorse_deletable_default_init (SeahorseDeletableIface * iface,
                                 gpointer iface_data)
{
	/** Returns whether this object is actually deletable */
#line 28 "../common/deletable.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("deletable", "deletable", "deletable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 117 "deletable.c"
}

/**
 * An interface for items that can be deleted (note however that specific
 * instances might not be, so use the deletable property).
 *
 * To actually delete the object, you'll have to call create_delete_operation()
 * which can then take care of it (possibly with others).
 */
 G_GNUC_NO_INLINE static GType
seahorse_deletable_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseDeletableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_deletable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType seahorse_deletable_type_id;
	seahorse_deletable_type_id = g_type_register_static (G_TYPE_INTERFACE, "SeahorseDeletable", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (seahorse_deletable_type_id, G_TYPE_OBJECT);
	return seahorse_deletable_type_id;
}

GType
seahorse_deletable_get_type (void)
{
	static gsize seahorse_deletable_type_id__once = 0;
	if (g_once_init_enter (&seahorse_deletable_type_id__once)) {
		GType seahorse_deletable_type_id;
		seahorse_deletable_type_id = seahorse_deletable_get_type_once ();
		g_once_init_leave (&seahorse_deletable_type_id__once, seahorse_deletable_type_id);
	}
	return seahorse_deletable_type_id__once;
}

