/* object.c generated by valac 0.56.18, the Vala compiler
 * generated from object.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2017 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_OBJECT_0_PROPERTY,
	SEAHORSE_OBJECT_PLACE_PROPERTY,
	SEAHORSE_OBJECT_ICON_PROPERTY,
	SEAHORSE_OBJECT_LABEL_PROPERTY,
	SEAHORSE_OBJECT_MARKUP_PROPERTY,
	SEAHORSE_OBJECT_NICKNAME_PROPERTY,
	SEAHORSE_OBJECT_IDENTIFIER_PROPERTY,
	SEAHORSE_OBJECT_USAGE_PROPERTY,
	SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY,
	SEAHORSE_OBJECT_NUM_PROPERTIES
};
static GParamSpec* seahorse_object_properties[SEAHORSE_OBJECT_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _SeahorseObjectPrivate {
	SeahorsePlace* _place;
	GIcon* _icon;
	gchar* _label;
	gchar* _markup;
	gboolean markup_explicit;
	gchar* _nickname;
	gboolean nickname_explicit;
	gchar* _identifier;
	SeahorseUsage _usage;
	SeahorseFlags _object_flags;
};

static gint SeahorseObject_private_offset;
static gpointer seahorse_object_parent_class = NULL;

static void seahorse_object_recalculate_label (SeahorseObject* self);
static void seahorse_object_finalize (GObject * obj);
static GType seahorse_object_get_type_once (void);
static void _vala_seahorse_object_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_seahorse_object_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
seahorse_object_get_instance_private (SeahorseObject* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseObject_private_offset);
}

SeahorseObject*
seahorse_object_construct (GType object_type)
{
	SeahorseObject * self = NULL;
#line 101 "../common/object.vala"
	self = (SeahorseObject*) g_object_new (object_type, NULL);
#line 101 "../common/object.vala"
	return self;
#line 101 "object.c"
}

SeahorseObject*
seahorse_object_new (void)
{
#line 101 "../common/object.vala"
	return seahorse_object_construct (SEAHORSE_TYPE_OBJECT);
#line 109 "object.c"
}

SeahorseFlags
seahorse_object_get_flags (SeahorseObject* self)
{
	SeahorseFlags _tmp0_;
	SeahorseFlags result;
#line 104 "../common/object.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 105 "../common/object.vala"
	_tmp0_ = self->priv->_object_flags;
#line 105 "../common/object.vala"
	result = _tmp0_;
#line 105 "../common/object.vala"
	return result;
#line 125 "object.c"
}

void
seahorse_object_set_flags (SeahorseObject* self,
                           SeahorseFlags flags)
{
#line 108 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 109 "../common/object.vala"
	seahorse_object_set_object_flags (self, flags);
#line 136 "object.c"
}

static void
seahorse_object_recalculate_label (SeahorseObject* self)
{
#line 113 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 114 "../common/object.vala"
	if (!self->priv->markup_explicit) {
#line 146 "object.c"
		const gchar* _tmp0_ = NULL;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 115 "../common/object.vala"
		_tmp1_ = seahorse_object_get_label (self);
#line 115 "../common/object.vala"
		_tmp2_ = _tmp1_;
#line 115 "../common/object.vala"
		_tmp0_ = _tmp2_;
#line 115 "../common/object.vala"
		if (_tmp0_ == NULL) {
#line 115 "../common/object.vala"
			_tmp0_ = "";
#line 162 "object.c"
		}
#line 115 "../common/object.vala"
		_tmp3_ = g_markup_escape_text (_tmp0_, (gssize) -1);
#line 115 "../common/object.vala"
		_tmp4_ = _tmp3_;
#line 115 "../common/object.vala"
		seahorse_object_set_markup (self, _tmp4_);
#line 115 "../common/object.vala"
		_g_free0 (_tmp4_);
#line 116 "../common/object.vala"
		g_object_notify ((GObject*) self, "markup");
#line 174 "object.c"
	}
#line 119 "../common/object.vala"
	if (!self->priv->nickname_explicit) {
#line 178 "object.c"
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 120 "../common/object.vala"
		_tmp6_ = seahorse_object_get_label (self);
#line 120 "../common/object.vala"
		_tmp7_ = _tmp6_;
#line 120 "../common/object.vala"
		_tmp5_ = _tmp7_;
#line 120 "../common/object.vala"
		if (_tmp5_ == NULL) {
#line 120 "../common/object.vala"
			_tmp5_ = "";
#line 192 "object.c"
		}
#line 120 "../common/object.vala"
		seahorse_object_set_nickname (self, _tmp5_);
#line 121 "../common/object.vala"
		g_object_notify ((GObject*) self, "nickname");
#line 198 "object.c"
	}
}

SeahorsePlace*
seahorse_object_get_place (SeahorseObject* self)
{
	SeahorsePlace* result;
	SeahorsePlace* _tmp0_;
#line 31 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../common/object.vala"
	_tmp0_ = self->priv->_place;
#line 31 "../common/object.vala"
	result = _tmp0_;
#line 31 "../common/object.vala"
	return result;
#line 215 "object.c"
}

void
seahorse_object_set_place (SeahorseObject* self,
                           SeahorsePlace* value)
{
	SeahorsePlace* old_value;
#line 31 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 31 "../common/object.vala"
	old_value = seahorse_object_get_place (self);
#line 31 "../common/object.vala"
	if (old_value != value) {
#line 31 "../common/object.vala"
		self->priv->_place = value;
#line 31 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_PLACE_PROPERTY]);
#line 233 "object.c"
	}
}

GIcon*
seahorse_object_get_icon (SeahorseObject* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 36 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../common/object.vala"
	_tmp0_ = self->priv->_icon;
#line 36 "../common/object.vala"
	result = _tmp0_;
#line 36 "../common/object.vala"
	return result;
#line 250 "object.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../common/object.vala"
	return self ? g_object_ref (self) : NULL;
#line 258 "object.c"
}

void
seahorse_object_set_icon (SeahorseObject* self,
                          GIcon* value)
{
	GIcon* old_value;
#line 36 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 36 "../common/object.vala"
	old_value = seahorse_object_get_icon (self);
#line 36 "../common/object.vala"
	if (old_value != value) {
#line 272 "object.c"
		GIcon* _tmp0_;
#line 36 "../common/object.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 36 "../common/object.vala"
		_g_object_unref0 (self->priv->_icon);
#line 36 "../common/object.vala"
		self->priv->_icon = _tmp0_;
#line 36 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_ICON_PROPERTY]);
#line 282 "object.c"
	}
}

const gchar*
seahorse_object_get_label (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 42 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 42 "../common/object.vala"
	_tmp0_ = self->priv->_label;
#line 42 "../common/object.vala"
	result = _tmp0_;
#line 42 "../common/object.vala"
	return result;
#line 299 "object.c"
}

void
seahorse_object_set_label (SeahorseObject* self,
                           const gchar* value)
{
	gchar* _tmp0_;
#line 43 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 44 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 44 "../common/object.vala"
	_g_free0 (self->priv->_label);
#line 44 "../common/object.vala"
	self->priv->_label = _tmp0_;
#line 45 "../common/object.vala"
	seahorse_object_recalculate_label (self);
#line 43 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_LABEL_PROPERTY]);
#line 319 "object.c"
}

const gchar*
seahorse_object_get_markup (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 54 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 54 "../common/object.vala"
	_tmp0_ = self->priv->_markup;
#line 54 "../common/object.vala"
	result = _tmp0_;
#line 54 "../common/object.vala"
	return result;
#line 335 "object.c"
}

void
seahorse_object_set_markup (SeahorseObject* self,
                            const gchar* value)
{
	gchar* _tmp0_;
#line 55 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 56 "../common/object.vala"
	self->priv->markup_explicit = TRUE;
#line 57 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 57 "../common/object.vala"
	_g_free0 (self->priv->_markup);
#line 57 "../common/object.vala"
	self->priv->_markup = _tmp0_;
#line 55 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_MARKUP_PROPERTY]);
#line 355 "object.c"
}

const gchar*
seahorse_object_get_nickname (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 69 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../common/object.vala"
	_tmp0_ = self->priv->_nickname;
#line 69 "../common/object.vala"
	result = _tmp0_;
#line 69 "../common/object.vala"
	return result;
#line 371 "object.c"
}

void
seahorse_object_set_nickname (SeahorseObject* self,
                              const gchar* value)
{
	gchar* _tmp0_;
#line 70 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 71 "../common/object.vala"
	self->priv->nickname_explicit = TRUE;
#line 72 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 72 "../common/object.vala"
	_g_free0 (self->priv->_nickname);
#line 72 "../common/object.vala"
	self->priv->_nickname = _tmp0_;
#line 70 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_NICKNAME_PROPERTY]);
#line 391 "object.c"
}

const gchar*
seahorse_object_get_identifier (SeahorseObject* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 84 "../common/object.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../common/object.vala"
	_tmp0_ = self->priv->_identifier;
#line 84 "../common/object.vala"
	result = _tmp0_;
#line 84 "../common/object.vala"
	return result;
#line 407 "object.c"
}

void
seahorse_object_set_identifier (SeahorseObject* self,
                                const gchar* value)
{
	gchar* _tmp0_;
#line 85 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 86 "../common/object.vala"
	_tmp0_ = g_strdup (value);
#line 86 "../common/object.vala"
	_g_free0 (self->priv->_identifier);
#line 86 "../common/object.vala"
	self->priv->_identifier = _tmp0_;
#line 85 "../common/object.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_IDENTIFIER_PROPERTY]);
#line 425 "object.c"
}

SeahorseUsage
seahorse_object_get_usage (SeahorseObject* self)
{
	SeahorseUsage result;
#line 94 "../common/object.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 94 "../common/object.vala"
	result = self->priv->_usage;
#line 94 "../common/object.vala"
	return result;
#line 438 "object.c"
}

void
seahorse_object_set_usage (SeahorseObject* self,
                           SeahorseUsage value)
{
	SeahorseUsage old_value;
#line 94 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 94 "../common/object.vala"
	old_value = seahorse_object_get_usage (self);
#line 94 "../common/object.vala"
	if (old_value != value) {
#line 94 "../common/object.vala"
		self->priv->_usage = value;
#line 94 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_USAGE_PROPERTY]);
#line 456 "object.c"
	}
}

SeahorseFlags
seahorse_object_get_object_flags (SeahorseObject* self)
{
	SeahorseFlags result;
#line 99 "../common/object.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 99 "../common/object.vala"
	result = self->priv->_object_flags;
#line 99 "../common/object.vala"
	return result;
#line 470 "object.c"
}

void
seahorse_object_set_object_flags (SeahorseObject* self,
                                  SeahorseFlags value)
{
	SeahorseFlags old_value;
#line 99 "../common/object.vala"
	g_return_if_fail (self != NULL);
#line 99 "../common/object.vala"
	old_value = seahorse_object_get_object_flags (self);
#line 99 "../common/object.vala"
	if (old_value != value) {
#line 99 "../common/object.vala"
		self->priv->_object_flags = value;
#line 99 "../common/object.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_object_properties[SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY]);
#line 488 "object.c"
	}
}

static void
seahorse_object_class_init (SeahorseObjectClass * klass,
                            gpointer klass_data)
{
#line 26 "../common/object.vala"
	seahorse_object_parent_class = g_type_class_peek_parent (klass);
#line 26 "../common/object.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseObject_private_offset);
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_object_get_property;
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_object_set_property;
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_object_finalize;
#line 506 "object.c"
	/**
	     * The place this Object came from.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_PLACE_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_PLACE_PROPERTY] = g_param_spec_object ("place", "place", "place", SEAHORSE_TYPE_PLACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 512 "object.c"
	/**
	     * Stock ID for this Object.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_ICON_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 518 "object.c"
	/**
	     * This object's displayable label.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_LABEL_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 524 "object.c"
	/**
	     * This object's displayable markup.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_MARKUP_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_MARKUP_PROPERTY] = g_param_spec_string ("markup", "markup", "markup", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 530 "object.c"
	/**
	     * This object's short name.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_NICKNAME_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_NICKNAME_PROPERTY] = g_param_spec_string ("nickname", "nickname", "nickname", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 536 "object.c"
	/**
	     * Displayable ID for the object.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_IDENTIFIER_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_IDENTIFIER_PROPERTY] = g_param_spec_string ("identifier", "identifier", "identifier", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 542 "object.c"
	/**
	     * How this object is used.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_USAGE_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_USAGE_PROPERTY] = g_param_spec_enum ("usage", "usage", "usage", SEAHORSE_TYPE_USAGE, SEAHORSE_USAGE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 548 "object.c"
	/**
	     * This object's flags.
	     */
#line 26 "../common/object.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY, seahorse_object_properties[SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY] = g_param_spec_flags ("object-flags", "object-flags", "object-flags", SEAHORSE_TYPE_FLAGS, SEAHORSE_FLAG_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 554 "object.c"
}

static void
seahorse_object_instance_init (SeahorseObject * self,
                               gpointer klass)
{
	GThemedIcon* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 26 "../common/object.vala"
	self->priv = seahorse_object_get_instance_private (self);
#line 31 "../common/object.vala"
	self->priv->_place = NULL;
#line 36 "../common/object.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("gtk-missing-image");
#line 36 "../common/object.vala"
	self->priv->_icon = (GIcon*) _tmp0_;
#line 48 "../common/object.vala"
	_tmp1_ = g_strdup ("");
#line 48 "../common/object.vala"
	self->priv->_label = _tmp1_;
#line 60 "../common/object.vala"
	_tmp2_ = g_strdup ("");
#line 60 "../common/object.vala"
	self->priv->_markup = _tmp2_;
#line 75 "../common/object.vala"
	_tmp3_ = g_strdup ("");
#line 75 "../common/object.vala"
	self->priv->_nickname = _tmp3_;
#line 89 "../common/object.vala"
	_tmp4_ = g_strdup ("");
#line 89 "../common/object.vala"
	self->priv->_identifier = _tmp4_;
#line 94 "../common/object.vala"
	self->priv->_usage = SEAHORSE_USAGE_NONE;
#line 99 "../common/object.vala"
	self->priv->_object_flags = SEAHORSE_FLAG_NONE;
#line 594 "object.c"
}

static void
seahorse_object_finalize (GObject * obj)
{
	SeahorseObject * self;
#line 26 "../common/object.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_OBJECT, SeahorseObject);
#line 36 "../common/object.vala"
	_g_object_unref0 (self->priv->_icon);
#line 48 "../common/object.vala"
	_g_free0 (self->priv->_label);
#line 60 "../common/object.vala"
	_g_free0 (self->priv->_markup);
#line 75 "../common/object.vala"
	_g_free0 (self->priv->_nickname);
#line 89 "../common/object.vala"
	_g_free0 (self->priv->_identifier);
#line 26 "../common/object.vala"
	G_OBJECT_CLASS (seahorse_object_parent_class)->finalize (obj);
#line 615 "object.c"
}

/**
 * The base class for passwords/keys and others that are handled by Seahorse.
 */
 G_GNUC_NO_INLINE static GType
seahorse_object_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseObject), 0, (GInstanceInitFunc) seahorse_object_instance_init, NULL };
	GType seahorse_object_type_id;
	seahorse_object_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseObject", &g_define_type_info, 0);
	SeahorseObject_private_offset = g_type_add_instance_private (seahorse_object_type_id, sizeof (SeahorseObjectPrivate));
	return seahorse_object_type_id;
}

GType
seahorse_object_get_type (void)
{
	static gsize seahorse_object_type_id__once = 0;
	if (g_once_init_enter (&seahorse_object_type_id__once)) {
		GType seahorse_object_type_id;
		seahorse_object_type_id = seahorse_object_get_type_once ();
		g_once_init_leave (&seahorse_object_type_id__once, seahorse_object_type_id);
	}
	return seahorse_object_type_id__once;
}

static void
_vala_seahorse_object_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	SeahorseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_OBJECT, SeahorseObject);
#line 26 "../common/object.vala"
	switch (property_id) {
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_PLACE_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_object (value, seahorse_object_get_place (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_ICON_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_object (value, seahorse_object_get_icon (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_LABEL_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_label (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_MARKUP_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_markup (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_NICKNAME_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_nickname (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_IDENTIFIER_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_string (value, seahorse_object_get_identifier (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_USAGE_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_enum (value, seahorse_object_get_usage (self));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY:
#line 26 "../common/object.vala"
		g_value_set_flags (value, seahorse_object_get_object_flags (self));
#line 26 "../common/object.vala"
		break;
#line 701 "object.c"
		default:
#line 26 "../common/object.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../common/object.vala"
		break;
#line 707 "object.c"
	}
}

static void
_vala_seahorse_object_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	SeahorseObject * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_OBJECT, SeahorseObject);
#line 26 "../common/object.vala"
	switch (property_id) {
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_PLACE_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_place (self, g_value_get_object (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_ICON_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_icon (self, g_value_get_object (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_LABEL_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_label (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_MARKUP_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_markup (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_NICKNAME_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_nickname (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_IDENTIFIER_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_identifier (self, g_value_get_string (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_USAGE_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_usage (self, g_value_get_enum (value));
#line 26 "../common/object.vala"
		break;
#line 26 "../common/object.vala"
		case SEAHORSE_OBJECT_OBJECT_FLAGS_PROPERTY:
#line 26 "../common/object.vala"
		seahorse_object_set_object_flags (self, g_value_get_flags (value));
#line 26 "../common/object.vala"
		break;
#line 769 "object.c"
		default:
#line 26 "../common/object.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../common/object.vala"
		break;
#line 775 "object.c"
	}
}

