/* qr-code-dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from qr-code-dialog.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2025 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 *
 * Author: Niels De Graef <nielsdegraef@gmail.com>
 */

#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <qrencode.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_QR_CODE_DIALOG_0_PROPERTY,
	SEAHORSE_QR_CODE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* seahorse_qr_code_dialog_properties[SEAHORSE_QR_CODE_DIALOG_NUM_PROPERTIES];
#define _QRcode_free0(var) ((var == NULL) ? NULL : (var = (QRcode_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))

struct _SeahorseQrCodeDialogPrivate {
	GtkPicture* qr_image;
};

static gint SeahorseQrCodeDialog_private_offset;
static gpointer seahorse_qr_code_dialog_parent_class = NULL;

static void seahorse_qr_code_dialog_create_qr_code (SeahorseQrCodeDialog* self,
                                             const gchar* content,
                                             gint size);
static void seahorse_qr_code_dialog_fill_pixel (SeahorseQrCodeDialog* self,
                                         GByteArray* array,
                                         guint8 val,
                                         gint pixel_size);
static void seahorse_qr_code_dialog_finalize (GObject * obj);
static GType seahorse_qr_code_dialog_get_type_once (void);

static inline gpointer
seahorse_qr_code_dialog_get_instance_private (SeahorseQrCodeDialog* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseQrCodeDialog_private_offset);
}

SeahorseQrCodeDialog*
seahorse_qr_code_dialog_construct (GType object_type,
                                   const gchar* content)
{
	SeahorseQrCodeDialog * self = NULL;
	gint QR_IMAGE_SIZE = 0;
	gint scale = 0;
	GtkPicture* _tmp0_;
#line 27 "../common/qr-code-dialog.vala"
	g_return_val_if_fail (content != NULL, NULL);
#line 27 "../common/qr-code-dialog.vala"
	self = (SeahorseQrCodeDialog*) g_object_new (object_type, NULL);
#line 28 "../common/qr-code-dialog.vala"
	QR_IMAGE_SIZE = 300;
#line 29 "../common/qr-code-dialog.vala"
	_tmp0_ = self->priv->qr_image;
#line 29 "../common/qr-code-dialog.vala"
	scale = gtk_widget_get_scale_factor ((GtkWidget*) _tmp0_);
#line 30 "../common/qr-code-dialog.vala"
	seahorse_qr_code_dialog_create_qr_code (self, content, QR_IMAGE_SIZE * scale);
#line 27 "../common/qr-code-dialog.vala"
	return self;
#line 100 "qr-code-dialog.c"
}

SeahorseQrCodeDialog*
seahorse_qr_code_dialog_new (const gchar* content)
{
#line 27 "../common/qr-code-dialog.vala"
	return seahorse_qr_code_dialog_construct (SEAHORSE_TYPE_QR_CODE_DIALOG, content);
#line 108 "qr-code-dialog.c"
}

static gpointer
_g_byte_array_ref0 (gpointer self)
{
#line 67 "../common/qr-code-dialog.vala"
	return self ? g_byte_array_ref (self) : NULL;
#line 116 "qr-code-dialog.c"
}

static void
seahorse_qr_code_dialog_create_qr_code (SeahorseQrCodeDialog* self,
                                        const gchar* content,
                                        gint size)
{
	QRcode* _result_ = NULL;
	QRcode* _tmp0_;
	QRcode* _tmp1_;
	gint qr_size = 0;
	QRcode* _tmp2_;
	gint pixel_size = 0;
	gint total_size = 0;
	gint BYTES_PER_R8G8B8 = 0;
	GByteArray* qr_matrix = NULL;
	GByteArray* _tmp3_;
	GBytes* bytes = NULL;
	GByteArray* _tmp15_;
	GByteArray* _tmp16_;
	GBytes* _tmp17_;
	GdkMemoryTexture* paintable = NULL;
	GBytes* _tmp18_;
	GdkMemoryTexture* _tmp19_;
	GtkPicture* _tmp20_;
	GdkMemoryTexture* _tmp21_;
#line 33 "../common/qr-code-dialog.vala"
	g_return_if_fail (self != NULL);
#line 33 "../common/qr-code-dialog.vala"
	g_return_if_fail (content != NULL);
#line 34 "../common/qr-code-dialog.vala"
	if (g_strcmp0 (content, "") == 0) {
#line 35 "../common/qr-code-dialog.vala"
		g_warning ("qr-code-dialog.vala:35: Failed to create QR code: no content");
#line 36 "../common/qr-code-dialog.vala"
		return;
#line 153 "qr-code-dialog.c"
	}
#line 39 "../common/qr-code-dialog.vala"
	_tmp0_ = QRcode_encodeString (content, 0, QR_ECLEVEL_M, QR_MODE_8, 1);
#line 39 "../common/qr-code-dialog.vala"
	_result_ = _tmp0_;
#line 44 "../common/qr-code-dialog.vala"
	_tmp1_ = _result_;
#line 44 "../common/qr-code-dialog.vala"
	if (_tmp1_ == NULL) {
#line 45 "../common/qr-code-dialog.vala"
		g_warning ("qr-code-dialog.vala:45: Failed to create QR code: libqrencode error");
#line 46 "../common/qr-code-dialog.vala"
		_QRcode_free0 (_result_);
#line 46 "../common/qr-code-dialog.vala"
		return;
#line 169 "qr-code-dialog.c"
	}
#line 49 "../common/qr-code-dialog.vala"
	_tmp2_ = _result_;
#line 49 "../common/qr-code-dialog.vala"
	qr_size = _tmp2_->width;
#line 50 "../common/qr-code-dialog.vala"
	pixel_size = (gint) MAX ((gdouble) 1, (gdouble) (size / qr_size));
#line 51 "../common/qr-code-dialog.vala"
	total_size = qr_size * pixel_size;
#line 52 "../common/qr-code-dialog.vala"
	BYTES_PER_R8G8B8 = 3;
#line 53 "../common/qr-code-dialog.vala"
	_tmp3_ = g_byte_array_sized_new ((guint) (((total_size * total_size) * pixel_size) * BYTES_PER_R8G8B8));
#line 53 "../common/qr-code-dialog.vala"
	qr_matrix = _tmp3_;
#line 185 "qr-code-dialog.c"
	{
		gint column = 0;
#line 55 "../common/qr-code-dialog.vala"
		column = 0;
#line 190 "qr-code-dialog.c"
		{
			gboolean _tmp4_ = FALSE;
#line 55 "../common/qr-code-dialog.vala"
			_tmp4_ = TRUE;
#line 55 "../common/qr-code-dialog.vala"
			while (TRUE) {
#line 55 "../common/qr-code-dialog.vala"
				if (!_tmp4_) {
#line 199 "qr-code-dialog.c"
					gint _tmp5_;
#line 55 "../common/qr-code-dialog.vala"
					_tmp5_ = column;
#line 55 "../common/qr-code-dialog.vala"
					column = _tmp5_ + 1;
#line 205 "qr-code-dialog.c"
				}
#line 55 "../common/qr-code-dialog.vala"
				_tmp4_ = FALSE;
#line 55 "../common/qr-code-dialog.vala"
				if (!(column < total_size)) {
#line 55 "../common/qr-code-dialog.vala"
					break;
#line 213 "qr-code-dialog.c"
				}
				{
					gint i = 0;
#line 56 "../common/qr-code-dialog.vala"
					i = 0;
#line 219 "qr-code-dialog.c"
					{
						gboolean _tmp6_ = FALSE;
#line 56 "../common/qr-code-dialog.vala"
						_tmp6_ = TRUE;
#line 56 "../common/qr-code-dialog.vala"
						while (TRUE) {
#line 56 "../common/qr-code-dialog.vala"
							if (!_tmp6_) {
#line 228 "qr-code-dialog.c"
								gint _tmp7_;
#line 56 "../common/qr-code-dialog.vala"
								_tmp7_ = i;
#line 56 "../common/qr-code-dialog.vala"
								i = _tmp7_ + 1;
#line 234 "qr-code-dialog.c"
							}
#line 56 "../common/qr-code-dialog.vala"
							_tmp6_ = FALSE;
#line 56 "../common/qr-code-dialog.vala"
							if (!(i < pixel_size)) {
#line 56 "../common/qr-code-dialog.vala"
								break;
#line 242 "qr-code-dialog.c"
							}
							{
								gint row = 0;
#line 57 "../common/qr-code-dialog.vala"
								row = 0;
#line 248 "qr-code-dialog.c"
								{
									gboolean _tmp8_ = FALSE;
#line 57 "../common/qr-code-dialog.vala"
									_tmp8_ = TRUE;
#line 57 "../common/qr-code-dialog.vala"
									while (TRUE) {
#line 255 "qr-code-dialog.c"
										QRcode* _tmp10_;
										guint8* _tmp11_;
										gint _tmp11__length1;
										guint8 _tmp12_;
#line 57 "../common/qr-code-dialog.vala"
										if (!_tmp8_) {
#line 262 "qr-code-dialog.c"
											gint _tmp9_;
#line 57 "../common/qr-code-dialog.vala"
											_tmp9_ = row;
#line 57 "../common/qr-code-dialog.vala"
											row = _tmp9_ + 1;
#line 268 "qr-code-dialog.c"
										}
#line 57 "../common/qr-code-dialog.vala"
										_tmp8_ = FALSE;
#line 57 "../common/qr-code-dialog.vala"
										if (!(row < (total_size / pixel_size))) {
#line 57 "../common/qr-code-dialog.vala"
											break;
#line 276 "qr-code-dialog.c"
										}
#line 58 "../common/qr-code-dialog.vala"
										_tmp10_ = _result_;
#line 58 "../common/qr-code-dialog.vala"
										_tmp11_ = _tmp10_->data;
#line 58 "../common/qr-code-dialog.vala"
										_tmp11__length1 = -1;
#line 58 "../common/qr-code-dialog.vala"
										_tmp12_ = _tmp11_[(qr_size * row) + column];
#line 58 "../common/qr-code-dialog.vala"
										if (((gint) (_tmp12_ & 0x01)) > 0) {
#line 288 "qr-code-dialog.c"
											GByteArray* _tmp13_;
#line 59 "../common/qr-code-dialog.vala"
											_tmp13_ = qr_matrix;
#line 59 "../common/qr-code-dialog.vala"
											seahorse_qr_code_dialog_fill_pixel (self, _tmp13_, (guint8) 0x00, pixel_size);
#line 294 "qr-code-dialog.c"
										} else {
											GByteArray* _tmp14_;
#line 61 "../common/qr-code-dialog.vala"
											_tmp14_ = qr_matrix;
#line 61 "../common/qr-code-dialog.vala"
											seahorse_qr_code_dialog_fill_pixel (self, _tmp14_, (guint8) 0xff, pixel_size);
#line 301 "qr-code-dialog.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 67 "../common/qr-code-dialog.vala"
	_tmp15_ = qr_matrix;
#line 67 "../common/qr-code-dialog.vala"
	_tmp16_ = _g_byte_array_ref0 (_tmp15_);
#line 67 "../common/qr-code-dialog.vala"
	_tmp17_ = g_byte_array_free_to_bytes (_tmp16_);
#line 67 "../common/qr-code-dialog.vala"
	bytes = _tmp17_;
#line 68 "../common/qr-code-dialog.vala"
	_tmp18_ = bytes;
#line 68 "../common/qr-code-dialog.vala"
	_tmp19_ = (GdkMemoryTexture*) gdk_memory_texture_new (total_size, total_size, GDK_MEMORY_R8G8B8, _tmp18_, (gsize) (total_size * BYTES_PER_R8G8B8));
#line 68 "../common/qr-code-dialog.vala"
	paintable = _tmp19_;
#line 72 "../common/qr-code-dialog.vala"
	_tmp20_ = self->priv->qr_image;
#line 72 "../common/qr-code-dialog.vala"
	_tmp21_ = paintable;
#line 72 "../common/qr-code-dialog.vala"
	gtk_picture_set_paintable (_tmp20_, (GdkPaintable*) _tmp21_);
#line 33 "../common/qr-code-dialog.vala"
	_g_object_unref0 (paintable);
#line 33 "../common/qr-code-dialog.vala"
	_g_bytes_unref0 (bytes);
#line 33 "../common/qr-code-dialog.vala"
	_g_byte_array_unref0 (qr_matrix);
#line 33 "../common/qr-code-dialog.vala"
	_QRcode_free0 (_result_);
#line 340 "qr-code-dialog.c"
}

static void
seahorse_qr_code_dialog_fill_pixel (SeahorseQrCodeDialog* self,
                                    GByteArray* array,
                                    guint8 val,
                                    gint pixel_size)
{
#line 75 "../common/qr-code-dialog.vala"
	g_return_if_fail (self != NULL);
#line 75 "../common/qr-code-dialog.vala"
	g_return_if_fail (array != NULL);
#line 353 "qr-code-dialog.c"
	{
		guint i = 0U;
#line 76 "../common/qr-code-dialog.vala"
		i = (guint) 0;
#line 358 "qr-code-dialog.c"
		{
			gboolean _tmp0_ = FALSE;
#line 76 "../common/qr-code-dialog.vala"
			_tmp0_ = TRUE;
#line 76 "../common/qr-code-dialog.vala"
			while (TRUE) {
#line 365 "qr-code-dialog.c"
				guint8* _tmp2_;
				guint8* _tmp3_;
				gint _tmp3__length1;
				guint8* _tmp4_;
				guint8* _tmp5_;
				gint _tmp5__length1;
				guint8* _tmp6_;
				guint8* _tmp7_;
				gint _tmp7__length1;
#line 76 "../common/qr-code-dialog.vala"
				if (!_tmp0_) {
#line 377 "qr-code-dialog.c"
					guint _tmp1_;
#line 76 "../common/qr-code-dialog.vala"
					_tmp1_ = i;
#line 76 "../common/qr-code-dialog.vala"
					i = _tmp1_ + 1;
#line 383 "qr-code-dialog.c"
				}
#line 76 "../common/qr-code-dialog.vala"
				_tmp0_ = FALSE;
#line 76 "../common/qr-code-dialog.vala"
				if (!(i < ((guint) pixel_size))) {
#line 76 "../common/qr-code-dialog.vala"
					break;
#line 391 "qr-code-dialog.c"
				}
#line 77 "../common/qr-code-dialog.vala"
				_tmp2_ = g_new0 (guint8, 1);
#line 77 "../common/qr-code-dialog.vala"
				_tmp2_[0] = val;
#line 77 "../common/qr-code-dialog.vala"
				_tmp3_ = _tmp2_;
#line 77 "../common/qr-code-dialog.vala"
				_tmp3__length1 = 1;
#line 77 "../common/qr-code-dialog.vala"
				g_byte_array_append (array, _tmp3_, (gint) 1);
#line 77 "../common/qr-code-dialog.vala"
				_tmp3_ = (g_free (_tmp3_), NULL);
#line 78 "../common/qr-code-dialog.vala"
				_tmp4_ = g_new0 (guint8, 1);
#line 78 "../common/qr-code-dialog.vala"
				_tmp4_[0] = val;
#line 78 "../common/qr-code-dialog.vala"
				_tmp5_ = _tmp4_;
#line 78 "../common/qr-code-dialog.vala"
				_tmp5__length1 = 1;
#line 78 "../common/qr-code-dialog.vala"
				g_byte_array_append (array, _tmp5_, (gint) 1);
#line 78 "../common/qr-code-dialog.vala"
				_tmp5_ = (g_free (_tmp5_), NULL);
#line 79 "../common/qr-code-dialog.vala"
				_tmp6_ = g_new0 (guint8, 1);
#line 79 "../common/qr-code-dialog.vala"
				_tmp6_[0] = val;
#line 79 "../common/qr-code-dialog.vala"
				_tmp7_ = _tmp6_;
#line 79 "../common/qr-code-dialog.vala"
				_tmp7__length1 = 1;
#line 79 "../common/qr-code-dialog.vala"
				g_byte_array_append (array, _tmp7_, (gint) 1);
#line 79 "../common/qr-code-dialog.vala"
				_tmp7_ = (g_free (_tmp7_), NULL);
#line 429 "qr-code-dialog.c"
			}
		}
	}
}

static void
seahorse_qr_code_dialog_class_init (SeahorseQrCodeDialogClass * klass,
                                    gpointer klass_data)
{
#line 22 "../common/qr-code-dialog.vala"
	seahorse_qr_code_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "../common/qr-code-dialog.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseQrCodeDialog_private_offset);
#line 22 "../common/qr-code-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_qr_code_dialog_finalize;
#line 22 "../common/qr-code-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/qr-code-dialog.ui");
#line 22 "../common/qr-code-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "qr_image", FALSE, SeahorseQrCodeDialog_private_offset + G_STRUCT_OFFSET (SeahorseQrCodeDialogPrivate, qr_image));
#line 449 "qr-code-dialog.c"
}

static void
seahorse_qr_code_dialog_instance_init (SeahorseQrCodeDialog * self,
                                       gpointer klass)
{
#line 22 "../common/qr-code-dialog.vala"
	self->priv = seahorse_qr_code_dialog_get_instance_private (self);
#line 22 "../common/qr-code-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 460 "qr-code-dialog.c"
}

static void
seahorse_qr_code_dialog_finalize (GObject * obj)
{
	SeahorseQrCodeDialog * self;
#line 22 "../common/qr-code-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_QR_CODE_DIALOG, SeahorseQrCodeDialog);
#line 22 "../common/qr-code-dialog.vala"
	G_OBJECT_CLASS (seahorse_qr_code_dialog_parent_class)->finalize (obj);
#line 471 "qr-code-dialog.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_qr_code_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseQrCodeDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_qr_code_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseQrCodeDialog), 0, (GInstanceInitFunc) seahorse_qr_code_dialog_instance_init, NULL };
	GType seahorse_qr_code_dialog_type_id;
	seahorse_qr_code_dialog_type_id = g_type_register_static (adw_dialog_get_type (), "SeahorseQrCodeDialog", &g_define_type_info, 0);
	SeahorseQrCodeDialog_private_offset = g_type_add_instance_private (seahorse_qr_code_dialog_type_id, sizeof (SeahorseQrCodeDialogPrivate));
	return seahorse_qr_code_dialog_type_id;
}

GType
seahorse_qr_code_dialog_get_type (void)
{
	static gsize seahorse_qr_code_dialog_type_id__once = 0;
	if (g_once_init_enter (&seahorse_qr_code_dialog_type_id__once)) {
		GType seahorse_qr_code_dialog_type_id;
		seahorse_qr_code_dialog_type_id = seahorse_qr_code_dialog_get_type_once ();
		g_once_init_leave (&seahorse_qr_code_dialog_type_id__once, seahorse_qr_code_dialog_type_id);
	}
	return seahorse_qr_code_dialog_type_id__once;
}

