/* util.c generated by valac 0.56.18, the Vala compiler
 * generated from util.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2004-2005 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2020 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include "seahorse-common.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <adwaita.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../common/util.vala"
	return self ? g_object_ref (self) : NULL;
#line 52 "util.c"
}

void
seahorse_util_show_error (GtkWidget* parent,
                          const gchar* heading,
                          const gchar* message)
{
	GtkWindow* window = NULL;
	gboolean _tmp0_ = FALSE;
	AdwAlertDialog* dialog = NULL;
	AdwAlertDialog* _tmp3_;
#line 28 "../common/util.vala"
	if (message == NULL) {
#line 29 "../common/util.vala"
		message = "";
#line 68 "util.c"
	}
#line 31 "../common/util.vala"
	window = NULL;
#line 32 "../common/util.vala"
	if (parent != NULL) {
#line 32 "../common/util.vala"
		_tmp0_ = !G_TYPE_CHECK_INSTANCE_TYPE (parent, gtk_window_get_type ());
#line 76 "util.c"
	} else {
#line 32 "../common/util.vala"
		_tmp0_ = FALSE;
#line 80 "util.c"
	}
#line 32 "../common/util.vala"
	if (_tmp0_) {
#line 84 "util.c"
		GtkRoot* _tmp1_;
		GtkWindow* _tmp2_;
#line 33 "../common/util.vala"
		_tmp1_ = gtk_widget_get_root (parent);
#line 33 "../common/util.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp1_) : NULL);
#line 33 "../common/util.vala"
		_g_object_unref0 (window);
#line 33 "../common/util.vala"
		window = _tmp2_;
#line 95 "util.c"
	}
#line 36 "../common/util.vala"
	_tmp3_ = (AdwAlertDialog*) adw_alert_dialog_new (heading, message);
#line 36 "../common/util.vala"
	g_object_ref_sink (_tmp3_);
#line 36 "../common/util.vala"
	dialog = _tmp3_;
#line 37 "../common/util.vala"
	adw_alert_dialog_add_response (dialog, "close", _ ("_Close"));
#line 38 "../common/util.vala"
	adw_alert_dialog_set_default_response (dialog, "close");
#line 39 "../common/util.vala"
	adw_dialog_present ((AdwDialog*) dialog, parent);
#line 24 "../common/util.vala"
	_g_object_unref0 (dialog);
#line 24 "../common/util.vala"
	_g_object_unref0 (window);
#line 113 "util.c"
}

void
seahorse_util_toggle_action (GSimpleAction* action,
                             GVariant* variant,
                             void* user_data)
{
	GVariant* old_state = NULL;
	GVariant* _tmp0_;
	GVariant* new_state = NULL;
	GVariant* _tmp1_;
#line 42 "../common/util.vala"
	g_return_if_fail (action != NULL);
#line 45 "../common/util.vala"
	_tmp0_ = g_action_get_state ((GAction*) action);
#line 45 "../common/util.vala"
	old_state = _tmp0_;
#line 46 "../common/util.vala"
	_tmp1_ = g_variant_new_boolean (!g_variant_get_boolean (old_state));
#line 46 "../common/util.vala"
	g_variant_ref_sink (_tmp1_);
#line 46 "../common/util.vala"
	new_state = _tmp1_;
#line 47 "../common/util.vala"
	g_signal_emit_by_name (action, "change-state", new_state);
#line 42 "../common/util.vala"
	_g_variant_unref0 (new_state);
#line 42 "../common/util.vala"
	_g_variant_unref0 (old_state);
#line 143 "util.c"
}

