/* pkcs11-cert-key-pair.c generated by valac 0.56.18, the Vala compiler
 * generated from pkcs11-cert-key-pair.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2024 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include "seahorse-pkcs11.h"
#include <gck/gck.h>
#include <glib.h>
#include <glib-object.h>
#include "seahorse-common.h"
#include "p11-kit/pkcs11.h"
#include <gcr/gcr.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_PKCS11_CERT_KEY_PAIR_0_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_ID_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_CERTIFICATE_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_PRIVATE_KEY_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_IS_PAIR_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_DELETABLE_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_EXPORTABLE_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_DESCRIPTION_PROPERTY,
	SEAHORSE_PKCS11_CERT_KEY_PAIR_NUM_PROPERTIES
};
static GParamSpec* seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _gck_attributes_unref0(var) ((var == NULL) ? NULL : (var = (gck_attributes_unref (var), NULL)))

struct _SeahorsePkcs11CertKeyPairPrivate {
	GckAttribute* _id;
	SeahorsePkcs11Certificate* _certificate;
	SeahorsePkcs11PrivateKey* _private_key;
};

static gint SeahorsePkcs11CertKeyPair_private_offset;
static gpointer seahorse_pkcs11_cert_key_pair_parent_class = NULL;
static SeahorseDeletableIface * seahorse_pkcs11_cert_key_pair_seahorse_deletable_parent_iface = NULL;
static SeahorseExportableIface * seahorse_pkcs11_cert_key_pair_seahorse_exportable_parent_iface = NULL;
static SeahorseViewableIface * seahorse_pkcs11_cert_key_pair_seahorse_viewable_parent_iface = NULL;

static SeahorsePanel* seahorse_pkcs11_cert_key_pair_real_create_panel (SeahorseViewable* base);
static gboolean seahorse_pkcs11_cert_key_pair_check_modifiable (SeahorsePkcs11CertKeyPair* self,
                                                         GckAttributes* attributes);
static SeahorseDeleteOperation* seahorse_pkcs11_cert_key_pair_real_create_delete_operation (SeahorseDeletable* base);
static SeahorseExportOperation* seahorse_pkcs11_cert_key_pair_real_create_export_operation (SeahorseExportable* base);
static void seahorse_pkcs11_cert_key_pair_update_label (SeahorsePkcs11CertKeyPair* self);
static void seahorse_pkcs11_cert_key_pair_update_flags (SeahorsePkcs11CertKeyPair* self);
static void seahorse_pkcs11_cert_key_pair_update_icon (SeahorsePkcs11CertKeyPair* self);
static void seahorse_pkcs11_cert_key_pair_finalize (GObject * obj);
static GType seahorse_pkcs11_cert_key_pair_get_type_once (void);
static void _vala_seahorse_pkcs11_cert_key_pair_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_seahorse_pkcs11_cert_key_pair_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
seahorse_pkcs11_cert_key_pair_get_instance_private (SeahorsePkcs11CertKeyPair* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePkcs11CertKeyPair_private_offset);
}

SeahorsePkcs11CertKeyPair*
seahorse_pkcs11_cert_key_pair_construct_for_cert (GType object_type,
                                                  SeahorsePkcs11Token* token,
                                                  SeahorsePkcs11Certificate* certificate)
{
	SeahorsePkcs11CertKeyPair * self = NULL;
#line 98 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (certificate != NULL, NULL);
#line 99 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) g_object_new (object_type, "place", token, "certificate", certificate, NULL);
#line 98 "../pkcs11/pkcs11-cert-key-pair.vala"
	return self;
#line 112 "pkcs11-cert-key-pair.c"
}

SeahorsePkcs11CertKeyPair*
seahorse_pkcs11_cert_key_pair_new_for_cert (SeahorsePkcs11Token* token,
                                            SeahorsePkcs11Certificate* certificate)
{
#line 98 "../pkcs11/pkcs11-cert-key-pair.vala"
	return seahorse_pkcs11_cert_key_pair_construct_for_cert (SEAHORSE_PKCS11_TYPE_CERT_KEY_PAIR, token, certificate);
#line 121 "pkcs11-cert-key-pair.c"
}

SeahorsePkcs11CertKeyPair*
seahorse_pkcs11_cert_key_pair_construct_for_private_key (GType object_type,
                                                         SeahorsePkcs11Token* token,
                                                         SeahorsePkcs11PrivateKey* key)
{
	SeahorsePkcs11CertKeyPair * self = NULL;
#line 102 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 103 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) g_object_new (object_type, "place", token, "private-key", key, NULL);
#line 102 "../pkcs11/pkcs11-cert-key-pair.vala"
	return self;
#line 136 "pkcs11-cert-key-pair.c"
}

SeahorsePkcs11CertKeyPair*
seahorse_pkcs11_cert_key_pair_new_for_private_key (SeahorsePkcs11Token* token,
                                                   SeahorsePkcs11PrivateKey* key)
{
#line 102 "../pkcs11/pkcs11-cert-key-pair.vala"
	return seahorse_pkcs11_cert_key_pair_construct_for_private_key (SEAHORSE_PKCS11_TYPE_CERT_KEY_PAIR, token, key);
#line 145 "pkcs11-cert-key-pair.c"
}

static SeahorsePanel*
seahorse_pkcs11_cert_key_pair_real_create_panel (SeahorseViewable* base)
{
	SeahorsePkcs11CertKeyPair * self;
	SeahorsePkcs11CertKeyPairPanel* _tmp0_;
	SeahorsePanel* result;
#line 106 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) base;
#line 107 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = seahorse_pkcs11_cert_key_pair_panel_new (self);
#line 107 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_ref_sink (_tmp0_);
#line 107 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = (SeahorsePanel*) _tmp0_;
#line 107 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 164 "pkcs11-cert-key-pair.c"
}

static gboolean
seahorse_pkcs11_cert_key_pair_check_modifiable (SeahorsePkcs11CertKeyPair* self,
                                                GckAttributes* attributes)
{
	gboolean result;
#line 110 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (attributes != NULL) {
#line 176 "pkcs11-cert-key-pair.c"
		gboolean ret = FALSE;
		gboolean _tmp0_ = FALSE;
#line 112 "../pkcs11/pkcs11-cert-key-pair.vala"
		ret = TRUE;
#line 113 "../pkcs11/pkcs11-cert-key-pair.vala"
		gck_attributes_find_boolean (attributes, CKA_MODIFIABLE, &_tmp0_);
#line 113 "../pkcs11/pkcs11-cert-key-pair.vala"
		ret = _tmp0_;
#line 114 "../pkcs11/pkcs11-cert-key-pair.vala"
		result = ret;
#line 114 "../pkcs11/pkcs11-cert-key-pair.vala"
		return result;
#line 189 "pkcs11-cert-key-pair.c"
	}
#line 117 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = FALSE;
#line 117 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 195 "pkcs11-cert-key-pair.c"
}

static SeahorseDeleteOperation*
seahorse_pkcs11_cert_key_pair_real_create_delete_operation (SeahorseDeletable* base)
{
	SeahorsePkcs11CertKeyPair * self;
	SeahorsePkcs11DeleteOperation* _tmp0_;
	SeahorseDeleteOperation* result;
#line 120 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) base;
#line 121 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = seahorse_pkcs11_delete_operation_new (self);
#line 121 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = (SeahorseDeleteOperation*) _tmp0_;
#line 121 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 212 "pkcs11-cert-key-pair.c"
}

static SeahorseExportOperation*
seahorse_pkcs11_cert_key_pair_real_create_export_operation (SeahorseExportable* base)
{
	SeahorsePkcs11CertKeyPair * self;
	SeahorsePkcs11Certificate* _tmp0_;
	SeahorsePkcs11Certificate* _tmp1_;
	SeahorsePkcs11CertificateDerExportOperation* _tmp2_;
	SeahorseExportOperation* result;
#line 124 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) base;
#line 126 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 126 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp1_ = _tmp0_;
#line 126 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp2_ = seahorse_pkcs11_certificate_der_export_operation_new ((GcrCertificate*) _tmp1_);
#line 126 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = (SeahorseExportOperation*) _tmp2_;
#line 126 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 235 "pkcs11-cert-key-pair.c"
}

static void
seahorse_pkcs11_cert_key_pair_update_label (SeahorsePkcs11CertKeyPair* self)
{
	SeahorsePkcs11Certificate* _tmp0_;
	SeahorsePkcs11Certificate* _tmp1_;
#line 129 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_if_fail (self != NULL);
#line 130 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 130 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp1_ = _tmp0_;
#line 130 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp1_ != NULL) {
#line 251 "pkcs11-cert-key-pair.c"
		gchar* sn = NULL;
		SeahorsePkcs11Certificate* _tmp2_;
		SeahorsePkcs11Certificate* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 131 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp2_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 131 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp3_ = _tmp2_;
#line 131 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp4_ = gcr_certificate_get_subject_name ((GcrCertificate*) _tmp3_);
#line 131 "../pkcs11/pkcs11-cert-key-pair.vala"
		sn = _tmp4_;
#line 132 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp5_ = sn;
#line 132 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (_tmp5_ != NULL) {
#line 269 "pkcs11-cert-key-pair.c"
			const gchar* _tmp6_;
#line 133 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp6_ = sn;
#line 133 "../pkcs11/pkcs11-cert-key-pair.vala"
			seahorse_object_set_label ((SeahorseObject*) self, _tmp6_);
#line 275 "pkcs11-cert-key-pair.c"
		}
#line 130 "../pkcs11/pkcs11-cert-key-pair.vala"
		_g_free0 (sn);
#line 279 "pkcs11-cert-key-pair.c"
	} else {
		SeahorsePkcs11PrivateKey* _tmp7_;
		SeahorsePkcs11PrivateKey* _tmp8_;
#line 134 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp7_ = seahorse_pkcs11_cert_key_pair_get_private_key (self);
#line 134 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp8_ = _tmp7_;
#line 134 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (_tmp8_ != NULL) {
#line 289 "pkcs11-cert-key-pair.c"
			gchar* cka_label = NULL;
			SeahorsePkcs11PrivateKey* _tmp9_;
			SeahorsePkcs11PrivateKey* _tmp10_;
			gchar* _tmp11_;
			const gchar* _tmp12_;
#line 135 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp9_ = seahorse_pkcs11_cert_key_pair_get_private_key (self);
#line 135 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp10_ = _tmp9_;
#line 135 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp11_ = seahorse_pkcs11_private_key_get_cka_label (_tmp10_);
#line 135 "../pkcs11/pkcs11-cert-key-pair.vala"
			cka_label = _tmp11_;
#line 136 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp12_ = cka_label;
#line 136 "../pkcs11/pkcs11-cert-key-pair.vala"
			if (_tmp12_ != NULL) {
#line 307 "pkcs11-cert-key-pair.c"
				const gchar* _tmp13_;
#line 137 "../pkcs11/pkcs11-cert-key-pair.vala"
				_tmp13_ = cka_label;
#line 137 "../pkcs11/pkcs11-cert-key-pair.vala"
				seahorse_object_set_label ((SeahorseObject*) self, _tmp13_);
#line 313 "pkcs11-cert-key-pair.c"
			}
#line 134 "../pkcs11/pkcs11-cert-key-pair.vala"
			_g_free0 (cka_label);
#line 317 "pkcs11-cert-key-pair.c"
		} else {
			SeahorsePkcs11Certificate* _tmp14_;
			SeahorsePkcs11Certificate* _tmp15_;
#line 139 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp14_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 139 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp15_ = _tmp14_;
#line 139 "../pkcs11/pkcs11-cert-key-pair.vala"
			if (_tmp15_ != NULL) {
#line 140 "../pkcs11/pkcs11-cert-key-pair.vala"
				seahorse_object_set_label ((SeahorseObject*) self, _ ("Unnamed Certificate"));
#line 329 "pkcs11-cert-key-pair.c"
			} else {
#line 142 "../pkcs11/pkcs11-cert-key-pair.vala"
				seahorse_object_set_label ((SeahorseObject*) self, _ ("Unnamed Private Key"));
#line 333 "pkcs11-cert-key-pair.c"
			}
		}
	}
}

static void
seahorse_pkcs11_cert_key_pair_update_flags (SeahorsePkcs11CertKeyPair* self)
{
	SeahorsePkcs11PrivateKey* _tmp0_;
	GckAttributes* cert_attributes = NULL;
	SeahorsePkcs11Certificate* _tmp1_;
	SeahorsePkcs11Certificate* _tmp2_;
	GckAttributes* _tmp3_;
	GckAttributes* _tmp4_;
	gulong category = 0UL;
	gboolean _tmp5_ = FALSE;
	GckAttributes* _tmp6_;
	gboolean is_ca = FALSE;
	SeahorsePkcs11Certificate* _tmp10_;
	SeahorsePkcs11Certificate* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_;
#line 147 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_if_fail (self != NULL);
#line 149 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = self->priv->_private_key;
#line 149 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp0_ != NULL) {
#line 150 "../pkcs11/pkcs11-cert-key-pair.vala"
		seahorse_object_set_object_flags ((SeahorseObject*) self, SEAHORSE_FLAG_PERSONAL | SEAHORSE_FLAG_TRUSTED);
#line 151 "../pkcs11/pkcs11-cert-key-pair.vala"
		return;
#line 366 "pkcs11-cert-key-pair.c"
	}
#line 154 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp1_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 154 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp2_ = _tmp1_;
#line 154 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_get ((GckObjectCache*) _tmp2_, "attributes", &_tmp3_, NULL);
#line 154 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp4_ = _tmp3_;
#line 154 "../pkcs11/pkcs11-cert-key-pair.vala"
	cert_attributes = _tmp4_;
#line 155 "../pkcs11/pkcs11-cert-key-pair.vala"
	category = (gulong) 0;
#line 156 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp6_ = cert_attributes;
#line 156 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp6_ != NULL) {
#line 384 "pkcs11-cert-key-pair.c"
		GckAttributes* _tmp7_;
		gulong _tmp8_ = 0UL;
		gboolean _tmp9_;
#line 157 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp7_ = cert_attributes;
#line 157 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp9_ = gck_attributes_find_ulong (_tmp7_, CKA_CERTIFICATE_CATEGORY, &_tmp8_);
#line 157 "../pkcs11/pkcs11-cert-key-pair.vala"
		category = _tmp8_;
#line 157 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp5_ = _tmp9_;
#line 396 "pkcs11-cert-key-pair.c"
	} else {
#line 156 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp5_ = FALSE;
#line 400 "pkcs11-cert-key-pair.c"
	}
#line 156 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp5_) {
#line 159 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (category == ((gulong) 2)) {
#line 160 "../pkcs11/pkcs11-cert-key-pair.vala"
			seahorse_object_set_object_flags ((SeahorseObject*) self, 0);
#line 161 "../pkcs11/pkcs11-cert-key-pair.vala"
			_gck_attributes_unref0 (cert_attributes);
#line 161 "../pkcs11/pkcs11-cert-key-pair.vala"
			return;
#line 412 "pkcs11-cert-key-pair.c"
		}
#line 163 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (category == ((gulong) 1)) {
#line 164 "../pkcs11/pkcs11-cert-key-pair.vala"
			seahorse_object_set_object_flags ((SeahorseObject*) self, SEAHORSE_FLAG_PERSONAL);
#line 165 "../pkcs11/pkcs11-cert-key-pair.vala"
			_gck_attributes_unref0 (cert_attributes);
#line 165 "../pkcs11/pkcs11-cert-key-pair.vala"
			return;
#line 422 "pkcs11-cert-key-pair.c"
		}
	}
#line 170 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp10_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 170 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp11_ = _tmp10_;
#line 170 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp13_ = gcr_certificate_get_basic_constraints ((GcrCertificate*) _tmp11_, &_tmp12_, NULL);
#line 170 "../pkcs11/pkcs11-cert-key-pair.vala"
	is_ca = _tmp12_;
#line 170 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp13_) {
#line 435 "pkcs11-cert-key-pair.c"
		SeahorseFlags _tmp14_ = 0U;
#line 171 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (is_ca) {
#line 171 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp14_ = SEAHORSE_FLAG_NONE;
#line 441 "pkcs11-cert-key-pair.c"
		} else {
#line 171 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp14_ = SEAHORSE_FLAG_PERSONAL;
#line 445 "pkcs11-cert-key-pair.c"
		}
#line 171 "../pkcs11/pkcs11-cert-key-pair.vala"
		seahorse_object_set_object_flags ((SeahorseObject*) self, _tmp14_);
#line 172 "../pkcs11/pkcs11-cert-key-pair.vala"
		_gck_attributes_unref0 (cert_attributes);
#line 172 "../pkcs11/pkcs11-cert-key-pair.vala"
		return;
#line 453 "pkcs11-cert-key-pair.c"
	}
#line 175 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_object_set_object_flags ((SeahorseObject*) self, SEAHORSE_FLAG_PERSONAL);
#line 147 "../pkcs11/pkcs11-cert-key-pair.vala"
	_gck_attributes_unref0 (cert_attributes);
#line 459 "pkcs11-cert-key-pair.c"
}

static void
seahorse_pkcs11_cert_key_pair_update_icon (SeahorsePkcs11CertKeyPair* self)
{
	SeahorsePkcs11Certificate* _tmp0_;
	SeahorsePkcs11Certificate* _tmp1_;
#line 178 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_if_fail (self != NULL);
#line 179 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 179 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp1_ = _tmp0_;
#line 179 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp1_ != NULL) {
#line 475 "pkcs11-cert-key-pair.c"
		GThemedIcon* icon = NULL;
		GThemedIcon* _tmp2_;
		SeahorsePkcs11PrivateKey* _tmp3_;
		SeahorsePkcs11PrivateKey* _tmp4_;
#line 180 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp2_ = (GThemedIcon*) g_themed_icon_new ("application-certificate-symbolic");
#line 180 "../pkcs11/pkcs11-cert-key-pair.vala"
		icon = _tmp2_;
#line 181 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp3_ = seahorse_pkcs11_cert_key_pair_get_private_key (self);
#line 181 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp4_ = _tmp3_;
#line 181 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (_tmp4_ != NULL) {
#line 490 "pkcs11-cert-key-pair.c"
			GThemedIcon* eicon = NULL;
			GThemedIcon* _tmp5_;
			GEmblem* emblem = NULL;
			GThemedIcon* _tmp6_;
			GEmblem* _tmp7_;
			GThemedIcon* _tmp8_;
			GEmblem* _tmp9_;
			GEmblemedIcon* _tmp10_;
			GEmblemedIcon* _tmp11_;
#line 182 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp5_ = (GThemedIcon*) g_themed_icon_new ("key-item-symbolic");
#line 182 "../pkcs11/pkcs11-cert-key-pair.vala"
			eicon = _tmp5_;
#line 183 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp6_ = eicon;
#line 183 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp7_ = g_emblem_new ((GIcon*) _tmp6_);
#line 183 "../pkcs11/pkcs11-cert-key-pair.vala"
			emblem = _tmp7_;
#line 184 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp8_ = icon;
#line 184 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp9_ = emblem;
#line 184 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp10_ = (GEmblemedIcon*) g_emblemed_icon_new ((GIcon*) _tmp8_, _tmp9_);
#line 184 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp11_ = _tmp10_;
#line 184 "../pkcs11/pkcs11-cert-key-pair.vala"
			seahorse_object_set_icon ((SeahorseObject*) self, (GIcon*) _tmp11_);
#line 184 "../pkcs11/pkcs11-cert-key-pair.vala"
			_g_object_unref0 (_tmp11_);
#line 181 "../pkcs11/pkcs11-cert-key-pair.vala"
			_g_object_unref0 (emblem);
#line 181 "../pkcs11/pkcs11-cert-key-pair.vala"
			_g_object_unref0 (eicon);
#line 526 "pkcs11-cert-key-pair.c"
		} else {
			GThemedIcon* _tmp12_;
#line 186 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp12_ = icon;
#line 186 "../pkcs11/pkcs11-cert-key-pair.vala"
			seahorse_object_set_icon ((SeahorseObject*) self, (GIcon*) _tmp12_);
#line 533 "pkcs11-cert-key-pair.c"
		}
#line 179 "../pkcs11/pkcs11-cert-key-pair.vala"
		_g_object_unref0 (icon);
#line 537 "pkcs11-cert-key-pair.c"
	} else {
		SeahorsePkcs11PrivateKey* _tmp13_;
		SeahorsePkcs11PrivateKey* _tmp14_;
#line 188 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp13_ = seahorse_pkcs11_cert_key_pair_get_private_key (self);
#line 188 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp14_ = _tmp13_;
#line 188 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (_tmp14_ != NULL) {
#line 547 "pkcs11-cert-key-pair.c"
			GThemedIcon* _tmp15_;
			GThemedIcon* _tmp16_;
#line 189 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp15_ = (GThemedIcon*) g_themed_icon_new ("key-item-symbolic");
#line 189 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp16_ = _tmp15_;
#line 189 "../pkcs11/pkcs11-cert-key-pair.vala"
			seahorse_object_set_icon ((SeahorseObject*) self, (GIcon*) _tmp16_);
#line 189 "../pkcs11/pkcs11-cert-key-pair.vala"
			_g_object_unref0 (_tmp16_);
#line 558 "pkcs11-cert-key-pair.c"
		} else {
#line 191 "../pkcs11/pkcs11-cert-key-pair.vala"
			g_warning ("pkcs11-cert-key-pair.vala:191: Can't update icon for cert/key pair wit" \
"hout either set");
#line 562 "pkcs11-cert-key-pair.c"
		}
	}
}

SeahorsePkcs11CertKeyPair*
seahorse_pkcs11_cert_key_pair_construct (GType object_type)
{
	SeahorsePkcs11CertKeyPair * self = NULL;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) seahorse_object_construct (object_type);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	return self;
#line 575 "pkcs11-cert-key-pair.c"
}

SeahorsePkcs11CertKeyPair*
seahorse_pkcs11_cert_key_pair_new (void)
{
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	return seahorse_pkcs11_cert_key_pair_construct (SEAHORSE_PKCS11_TYPE_CERT_KEY_PAIR);
#line 583 "pkcs11-cert-key-pair.c"
}

GckAttribute*
seahorse_pkcs11_cert_key_pair_get_id (SeahorsePkcs11CertKeyPair* self)
{
	GckAttribute* result;
	GckAttribute* _tmp0_;
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = self->priv->_id;
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = _tmp0_;
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 599 "pkcs11-cert-key-pair.c"
}

void
seahorse_pkcs11_cert_key_pair_set_id (SeahorsePkcs11CertKeyPair* self,
                                      GckAttribute* value)
{
	GckAttribute* old_value;
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_if_fail (self != NULL);
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	old_value = seahorse_pkcs11_cert_key_pair_get_id (self);
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (old_value != value) {
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
		self->priv->_id = value;
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_ID_PROPERTY]);
#line 617 "pkcs11-cert-key-pair.c"
	}
}

SeahorsePkcs11Certificate*
seahorse_pkcs11_cert_key_pair_get_certificate (SeahorsePkcs11CertKeyPair* self)
{
	SeahorsePkcs11Certificate* result;
	SeahorsePkcs11Certificate* _tmp0_;
#line 28 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = self->priv->_certificate;
#line 28 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = _tmp0_;
#line 28 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 634 "pkcs11-cert-key-pair.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 30 "../pkcs11/pkcs11-cert-key-pair.vala"
	return self ? g_object_ref (self) : NULL;
#line 642 "pkcs11-cert-key-pair.c"
}

void
seahorse_pkcs11_cert_key_pair_set_certificate (SeahorsePkcs11CertKeyPair* self,
                                               SeahorsePkcs11Certificate* value)
{
	SeahorsePkcs11Certificate* _tmp0_;
#line 29 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_if_fail (self != NULL);
#line 30 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 30 "../pkcs11/pkcs11-cert-key-pair.vala"
	_g_object_unref0 (self->priv->_certificate);
#line 30 "../pkcs11/pkcs11-cert-key-pair.vala"
	self->priv->_certificate = _tmp0_;
#line 31 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_update_flags (self);
#line 32 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_update_label (self);
#line 33 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_update_icon (self);
#line 34 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "certificate");
#line 35 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "label");
#line 36 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "icon");
#line 37 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "description");
#line 38 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "is-pair");
#line 29 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_CERTIFICATE_PROPERTY]);
#line 676 "pkcs11-cert-key-pair.c"
}

SeahorsePkcs11PrivateKey*
seahorse_pkcs11_cert_key_pair_get_private_key (SeahorsePkcs11CertKeyPair* self)
{
	SeahorsePkcs11PrivateKey* result;
	SeahorsePkcs11PrivateKey* _tmp0_;
#line 44 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = self->priv->_private_key;
#line 44 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = _tmp0_;
#line 44 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 692 "pkcs11-cert-key-pair.c"
}

void
seahorse_pkcs11_cert_key_pair_set_private_key (SeahorsePkcs11CertKeyPair* self,
                                               SeahorsePkcs11PrivateKey* value)
{
	SeahorsePkcs11PrivateKey* _tmp0_;
#line 45 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_if_fail (self != NULL);
#line 46 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 46 "../pkcs11/pkcs11-cert-key-pair.vala"
	_g_object_unref0 (self->priv->_private_key);
#line 46 "../pkcs11/pkcs11-cert-key-pair.vala"
	self->priv->_private_key = _tmp0_;
#line 47 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_update_flags (self);
#line 48 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_update_label (self);
#line 49 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_update_icon (self);
#line 50 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "private-key");
#line 51 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "label");
#line 52 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "icon");
#line 53 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "description");
#line 54 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify ((GObject*) self, "is-pair");
#line 45 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_PRIVATE_KEY_PROPERTY]);
#line 726 "pkcs11-cert-key-pair.c"
}

gboolean
seahorse_pkcs11_cert_key_pair_get_is_pair (SeahorsePkcs11CertKeyPair* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	SeahorsePkcs11Certificate* _tmp1_;
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp1_ = self->priv->_certificate;
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp1_ != NULL) {
#line 741 "pkcs11-cert-key-pair.c"
		SeahorsePkcs11PrivateKey* _tmp2_;
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp2_ = self->priv->_private_key;
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 747 "pkcs11-cert-key-pair.c"
	} else {
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp0_ = FALSE;
#line 751 "pkcs11-cert-key-pair.c"
	}
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = _tmp0_;
#line 59 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 757 "pkcs11-cert-key-pair.c"
}

static gboolean
seahorse_pkcs11_cert_key_pair_real_get_deletable (SeahorseDeletable* base)
{
	gboolean result;
	SeahorsePkcs11CertKeyPair* self;
	SeahorsePkcs11Token* token = NULL;
	SeahorsePlace* _tmp0_;
	SeahorsePlace* _tmp1_;
	gboolean _tmp2_ = FALSE;
	SeahorsePkcs11Token* _tmp3_;
	gboolean _tmp5_ = FALSE;
	SeahorsePkcs11Certificate* _tmp6_;
	gboolean cert_deletable = FALSE;
	gboolean _tmp11_ = FALSE;
	SeahorsePkcs11PrivateKey* _tmp12_;
	gboolean key_deletable = FALSE;
	gboolean _tmp17_ = FALSE;
#line 63 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) base;
#line 64 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = seahorse_object_get_place ((SeahorseObject*) self);
#line 64 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp1_ = _tmp0_;
#line 64 "../pkcs11/pkcs11-cert-key-pair.vala"
	token = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, SEAHORSE_PKCS11_TYPE_TOKEN, SeahorsePkcs11Token);
#line 65 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp3_ = token;
#line 65 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp3_ == NULL) {
#line 65 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp2_ = TRUE;
#line 791 "pkcs11-cert-key-pair.c"
	} else {
		SeahorsePkcs11Token* _tmp4_;
#line 65 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp4_ = token;
#line 65 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp2_ = seahorse_pkcs11_token_is_write_protected (_tmp4_);
#line 798 "pkcs11-cert-key-pair.c"
	}
#line 65 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp2_) {
#line 66 "../pkcs11/pkcs11-cert-key-pair.vala"
		result = FALSE;
#line 66 "../pkcs11/pkcs11-cert-key-pair.vala"
		return result;
#line 806 "pkcs11-cert-key-pair.c"
	}
#line 68 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp6_ = self->priv->_certificate;
#line 68 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp6_ == NULL) {
#line 68 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp5_ = TRUE;
#line 814 "pkcs11-cert-key-pair.c"
	} else {
		SeahorsePkcs11Certificate* _tmp7_;
		GckAttributes* _tmp8_;
		GckAttributes* _tmp9_;
		GckAttributes* _tmp10_;
#line 69 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp7_ = self->priv->_certificate;
#line 69 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_object_get ((GckObjectCache*) _tmp7_, "attributes", &_tmp8_, NULL);
#line 69 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp9_ = _tmp8_;
#line 69 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp10_ = _tmp9_;
#line 69 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp5_ = seahorse_pkcs11_cert_key_pair_check_modifiable (self, _tmp10_);
#line 69 "../pkcs11/pkcs11-cert-key-pair.vala"
		_gck_attributes_unref0 (_tmp10_);
#line 832 "pkcs11-cert-key-pair.c"
	}
#line 68 "../pkcs11/pkcs11-cert-key-pair.vala"
	cert_deletable = _tmp5_;
#line 70 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp12_ = self->priv->_private_key;
#line 70 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp12_ == NULL) {
#line 70 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp11_ = TRUE;
#line 842 "pkcs11-cert-key-pair.c"
	} else {
		SeahorsePkcs11PrivateKey* _tmp13_;
		GckAttributes* _tmp14_;
		GckAttributes* _tmp15_;
		GckAttributes* _tmp16_;
#line 71 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp13_ = self->priv->_private_key;
#line 71 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_object_get ((GckObjectCache*) _tmp13_, "attributes", &_tmp14_, NULL);
#line 71 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp15_ = _tmp14_;
#line 71 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp16_ = _tmp15_;
#line 71 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp11_ = seahorse_pkcs11_cert_key_pair_check_modifiable (self, _tmp16_);
#line 71 "../pkcs11/pkcs11-cert-key-pair.vala"
		_gck_attributes_unref0 (_tmp16_);
#line 860 "pkcs11-cert-key-pair.c"
	}
#line 70 "../pkcs11/pkcs11-cert-key-pair.vala"
	key_deletable = _tmp11_;
#line 72 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (cert_deletable) {
#line 72 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp17_ = TRUE;
#line 868 "pkcs11-cert-key-pair.c"
	} else {
#line 72 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp17_ = key_deletable;
#line 872 "pkcs11-cert-key-pair.c"
	}
#line 72 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = _tmp17_;
#line 72 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 878 "pkcs11-cert-key-pair.c"
}

static gboolean
seahorse_pkcs11_cert_key_pair_real_get_exportable (SeahorseExportable* base)
{
	gboolean result;
	SeahorsePkcs11CertKeyPair* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	SeahorsePkcs11Certificate* _tmp2_;
	SeahorsePkcs11Certificate* _tmp3_;
#line 77 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = (SeahorsePkcs11CertKeyPair*) base;
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp2_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp3_ = _tmp2_;
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp3_ != NULL) {
#line 898 "pkcs11-cert-key-pair.c"
		SeahorsePkcs11Certificate* _tmp4_;
		SeahorsePkcs11Certificate* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp4_ = seahorse_pkcs11_cert_key_pair_get_certificate (self);
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp5_ = _tmp4_;
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp6_ = seahorse_pkcs11_certificate_get_exportable (_tmp5_);
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp7_ = _tmp6_;
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp1_ = _tmp7_;
#line 913 "pkcs11-cert-key-pair.c"
	} else {
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp1_ = FALSE;
#line 917 "pkcs11-cert-key-pair.c"
	}
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp1_) {
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp0_ = TRUE;
#line 923 "pkcs11-cert-key-pair.c"
	} else {
		gboolean _tmp8_ = FALSE;
		SeahorsePkcs11PrivateKey* _tmp9_;
		SeahorsePkcs11PrivateKey* _tmp10_;
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp9_ = seahorse_pkcs11_cert_key_pair_get_private_key (self);
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp10_ = _tmp9_;
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (_tmp10_ != NULL) {
#line 934 "pkcs11-cert-key-pair.c"
			SeahorsePkcs11PrivateKey* _tmp11_;
			SeahorsePkcs11PrivateKey* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp11_ = seahorse_pkcs11_cert_key_pair_get_private_key (self);
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp12_ = _tmp11_;
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp13_ = seahorse_pkcs11_private_key_get_exportable (_tmp12_);
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp14_ = _tmp13_;
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp8_ = _tmp14_;
#line 949 "pkcs11-cert-key-pair.c"
		} else {
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp8_ = FALSE;
#line 953 "pkcs11-cert-key-pair.c"
		}
#line 79 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp0_ = _tmp8_;
#line 957 "pkcs11-cert-key-pair.c"
	}
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
	result = _tmp0_;
#line 78 "../pkcs11/pkcs11-cert-key-pair.vala"
	return result;
#line 963 "pkcs11-cert-key-pair.c"
}

gchar*
seahorse_pkcs11_cert_key_pair_get_description (SeahorsePkcs11CertKeyPair* self)
{
	gchar* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 84 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 85 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp0_ = seahorse_pkcs11_cert_key_pair_get_is_pair (self);
#line 85 "../pkcs11/pkcs11-cert-key-pair.vala"
	_tmp1_ = _tmp0_;
#line 85 "../pkcs11/pkcs11-cert-key-pair.vala"
	if (_tmp1_) {
#line 980 "pkcs11-cert-key-pair.c"
		gchar* _tmp2_;
#line 86 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp2_ = g_strdup (_ ("Personal certificate and key"));
#line 86 "../pkcs11/pkcs11-cert-key-pair.vala"
		result = _tmp2_;
#line 86 "../pkcs11/pkcs11-cert-key-pair.vala"
		return result;
#line 988 "pkcs11-cert-key-pair.c"
	} else {
		SeahorsePkcs11Certificate* _tmp3_;
#line 87 "../pkcs11/pkcs11-cert-key-pair.vala"
		_tmp3_ = self->priv->_certificate;
#line 87 "../pkcs11/pkcs11-cert-key-pair.vala"
		if (_tmp3_ != NULL) {
#line 995 "pkcs11-cert-key-pair.c"
			SeahorseFlags _tmp4_;
			SeahorseFlags _tmp5_;
#line 88 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp4_ = seahorse_object_get_object_flags ((SeahorseObject*) self);
#line 88 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp5_ = _tmp4_;
#line 88 "../pkcs11/pkcs11-cert-key-pair.vala"
			if ((_tmp5_ & SEAHORSE_FLAG_PERSONAL) == SEAHORSE_FLAG_PERSONAL) {
#line 1004 "pkcs11-cert-key-pair.c"
				gchar* _tmp6_;
#line 89 "../pkcs11/pkcs11-cert-key-pair.vala"
				_tmp6_ = g_strdup (_ ("Personal certificate"));
#line 89 "../pkcs11/pkcs11-cert-key-pair.vala"
				result = _tmp6_;
#line 89 "../pkcs11/pkcs11-cert-key-pair.vala"
				return result;
#line 1012 "pkcs11-cert-key-pair.c"
			} else {
				gchar* _tmp7_;
#line 91 "../pkcs11/pkcs11-cert-key-pair.vala"
				_tmp7_ = g_strdup (_ ("Certificate"));
#line 91 "../pkcs11/pkcs11-cert-key-pair.vala"
				result = _tmp7_;
#line 91 "../pkcs11/pkcs11-cert-key-pair.vala"
				return result;
#line 1021 "pkcs11-cert-key-pair.c"
			}
		} else {
			gchar* _tmp8_;
#line 93 "../pkcs11/pkcs11-cert-key-pair.vala"
			_tmp8_ = g_strdup (_ ("Private key"));
#line 93 "../pkcs11/pkcs11-cert-key-pair.vala"
			result = _tmp8_;
#line 93 "../pkcs11/pkcs11-cert-key-pair.vala"
			return result;
#line 1031 "pkcs11-cert-key-pair.c"
		}
	}
}

static void
seahorse_pkcs11_cert_key_pair_class_init (SeahorsePkcs11CertKeyPairClass * klass,
                                          gpointer klass_data)
{
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_parent_class = g_type_class_peek_parent (klass);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePkcs11CertKeyPair_private_offset);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_pkcs11_cert_key_pair_get_property;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_pkcs11_cert_key_pair_set_property;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_pkcs11_cert_key_pair_finalize;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERT_KEY_PAIR_ID_PROPERTY, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_ID_PROPERTY] = g_param_spec_pointer ("id", "id", "id", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERT_KEY_PAIR_CERTIFICATE_PROPERTY, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_CERTIFICATE_PROPERTY] = g_param_spec_object ("certificate", "certificate", "certificate", SEAHORSE_PKCS11_TYPE_CERTIFICATE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERT_KEY_PAIR_PRIVATE_KEY_PROPERTY, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_PRIVATE_KEY_PROPERTY] = g_param_spec_object ("private-key", "private-key", "private-key", SEAHORSE_PKCS11_TYPE_PRIVATE_KEY, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERT_KEY_PAIR_IS_PAIR_PROPERTY, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_IS_PAIR_PROPERTY] = g_param_spec_boolean ("is-pair", "is-pair", "is-pair", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERT_KEY_PAIR_DELETABLE_PROPERTY, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_DELETABLE_PROPERTY] = g_param_spec_boolean ("deletable", "deletable", "deletable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERT_KEY_PAIR_EXPORTABLE_PROPERTY, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_EXPORTABLE_PROPERTY] = g_param_spec_boolean ("exportable", "exportable", "exportable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_CERT_KEY_PAIR_DESCRIPTION_PROPERTY, seahorse_pkcs11_cert_key_pair_properties[SEAHORSE_PKCS11_CERT_KEY_PAIR_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1064 "pkcs11-cert-key-pair.c"
}

static void
seahorse_pkcs11_cert_key_pair_seahorse_deletable_interface_init (SeahorseDeletableIface * iface,
                                                                 gpointer iface_data)
{
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_seahorse_deletable_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	iface->create_delete_operation = (SeahorseDeleteOperation* (*) (SeahorseDeletable*)) seahorse_pkcs11_cert_key_pair_real_create_delete_operation;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	iface->get_deletable = seahorse_pkcs11_cert_key_pair_real_get_deletable;
#line 1077 "pkcs11-cert-key-pair.c"
}

static void
seahorse_pkcs11_cert_key_pair_seahorse_exportable_interface_init (SeahorseExportableIface * iface,
                                                                  gpointer iface_data)
{
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_seahorse_exportable_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	iface->create_export_operation = (SeahorseExportOperation* (*) (SeahorseExportable*)) seahorse_pkcs11_cert_key_pair_real_create_export_operation;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	iface->get_exportable = seahorse_pkcs11_cert_key_pair_real_get_exportable;
#line 1090 "pkcs11-cert-key-pair.c"
}

static void
seahorse_pkcs11_cert_key_pair_seahorse_viewable_interface_init (SeahorseViewableIface * iface,
                                                                gpointer iface_data)
{
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	seahorse_pkcs11_cert_key_pair_seahorse_viewable_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	iface->create_panel = (SeahorsePanel* (*) (SeahorseViewable*)) seahorse_pkcs11_cert_key_pair_real_create_panel;
#line 1101 "pkcs11-cert-key-pair.c"
}

static void
seahorse_pkcs11_cert_key_pair_instance_init (SeahorsePkcs11CertKeyPair * self,
                                             gpointer klass)
{
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	self->priv = seahorse_pkcs11_cert_key_pair_get_instance_private (self);
#line 24 "../pkcs11/pkcs11-cert-key-pair.vala"
	self->priv->_id = NULL;
#line 1112 "pkcs11-cert-key-pair.c"
}

static void
seahorse_pkcs11_cert_key_pair_finalize (GObject * obj)
{
	SeahorsePkcs11CertKeyPair * self;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_CERT_KEY_PAIR, SeahorsePkcs11CertKeyPair);
#line 26 "../pkcs11/pkcs11-cert-key-pair.vala"
	_g_object_unref0 (self->priv->_certificate);
#line 42 "../pkcs11/pkcs11-cert-key-pair.vala"
	_g_object_unref0 (self->priv->_private_key);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	G_OBJECT_CLASS (seahorse_pkcs11_cert_key_pair_parent_class)->finalize (obj);
#line 1127 "pkcs11-cert-key-pair.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_pkcs11_cert_key_pair_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePkcs11CertKeyPairClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_pkcs11_cert_key_pair_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePkcs11CertKeyPair), 0, (GInstanceInitFunc) seahorse_pkcs11_cert_key_pair_instance_init, NULL };
	static const GInterfaceInfo seahorse_deletable_info = { (GInterfaceInitFunc) seahorse_pkcs11_cert_key_pair_seahorse_deletable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_exportable_info = { (GInterfaceInitFunc) seahorse_pkcs11_cert_key_pair_seahorse_exportable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_viewable_info = { (GInterfaceInitFunc) seahorse_pkcs11_cert_key_pair_seahorse_viewable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType seahorse_pkcs11_cert_key_pair_type_id;
	seahorse_pkcs11_cert_key_pair_type_id = g_type_register_static (SEAHORSE_TYPE_OBJECT, "SeahorsePkcs11CertKeyPair", &g_define_type_info, 0);
	g_type_add_interface_static (seahorse_pkcs11_cert_key_pair_type_id, SEAHORSE_TYPE_DELETABLE, &seahorse_deletable_info);
	g_type_add_interface_static (seahorse_pkcs11_cert_key_pair_type_id, SEAHORSE_TYPE_EXPORTABLE, &seahorse_exportable_info);
	g_type_add_interface_static (seahorse_pkcs11_cert_key_pair_type_id, SEAHORSE_TYPE_VIEWABLE, &seahorse_viewable_info);
	SeahorsePkcs11CertKeyPair_private_offset = g_type_add_instance_private (seahorse_pkcs11_cert_key_pair_type_id, sizeof (SeahorsePkcs11CertKeyPairPrivate));
	return seahorse_pkcs11_cert_key_pair_type_id;
}

GType
seahorse_pkcs11_cert_key_pair_get_type (void)
{
	static gsize seahorse_pkcs11_cert_key_pair_type_id__once = 0;
	if (g_once_init_enter (&seahorse_pkcs11_cert_key_pair_type_id__once)) {
		GType seahorse_pkcs11_cert_key_pair_type_id;
		seahorse_pkcs11_cert_key_pair_type_id = seahorse_pkcs11_cert_key_pair_get_type_once ();
		g_once_init_leave (&seahorse_pkcs11_cert_key_pair_type_id__once, seahorse_pkcs11_cert_key_pair_type_id);
	}
	return seahorse_pkcs11_cert_key_pair_type_id__once;
}

static void
_vala_seahorse_pkcs11_cert_key_pair_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	SeahorsePkcs11CertKeyPair * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_CERT_KEY_PAIR, SeahorsePkcs11CertKeyPair);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	switch (property_id) {
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_ID_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_value_set_pointer (value, seahorse_pkcs11_cert_key_pair_get_id (self));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_CERTIFICATE_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_value_set_object (value, seahorse_pkcs11_cert_key_pair_get_certificate (self));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_PRIVATE_KEY_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_value_set_object (value, seahorse_pkcs11_cert_key_pair_get_private_key (self));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_IS_PAIR_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_value_set_boolean (value, seahorse_pkcs11_cert_key_pair_get_is_pair (self));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_DELETABLE_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_value_set_boolean (value, seahorse_deletable_get_deletable ((SeahorseDeletable*) self));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_EXPORTABLE_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_value_set_boolean (value, seahorse_exportable_get_exportable ((SeahorseExportable*) self));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_DESCRIPTION_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		g_value_take_string (value, seahorse_pkcs11_cert_key_pair_get_description (self));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 1210 "pkcs11-cert-key-pair.c"
		default:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 1216 "pkcs11-cert-key-pair.c"
	}
}

static void
_vala_seahorse_pkcs11_cert_key_pair_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	SeahorsePkcs11CertKeyPair * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_TYPE_CERT_KEY_PAIR, SeahorsePkcs11CertKeyPair);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
	switch (property_id) {
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_ID_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		seahorse_pkcs11_cert_key_pair_set_id (self, g_value_get_pointer (value));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_CERTIFICATE_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		seahorse_pkcs11_cert_key_pair_set_certificate (self, g_value_get_object (value));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		case SEAHORSE_PKCS11_CERT_KEY_PAIR_PRIVATE_KEY_PROPERTY:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		seahorse_pkcs11_cert_key_pair_set_private_key (self, g_value_get_object (value));
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 1248 "pkcs11-cert-key-pair.c"
		default:
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../pkcs11/pkcs11-cert-key-pair.vala"
		break;
#line 1254 "pkcs11-cert-key-pair.c"
	}
}

