/* pkcs11-generate.c generated by valac 0.56.18, the Vala compiler
 * generated from pkcs11-generate.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2008 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-pkcs11.h"
#include <adwaita.h>
#include <gck/gck.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include "p11-kit/pkcs11.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include "seahorse-common.h"
#include "libseahorse/seahorse-progress.h"
#include "pkcs11/seahorse-pkcs11-backend.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_PKCS11_GENERATE_0_PROPERTY,
	SEAHORSE_PKCS11_GENERATE_NUM_PROPERTIES
};
static GParamSpec* seahorse_pkcs11_generate_properties[SEAHORSE_PKCS11_GENERATE_NUM_PROPERTIES];

#define SEAHORSE_PKCS11_GENERATE_TYPE_MECHANISM_ENTRY (seahorse_pkcs11_generate_mechanism_entry_get_type ())
typedef struct _SeahorsePkcs11GenerateMechanismEntry SeahorsePkcs11GenerateMechanismEntry;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _gck_attributes_unref0(var) ((var == NULL) ? NULL : (var = (gck_attributes_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define __vala_GckMechanismInfo_free0(var) ((var == NULL) ? NULL : (var = (_vala_GckMechanismInfo_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SeahorsePkcs11GenerateCreateData SeahorsePkcs11GenerateCreateData;
#define _gck_builder_unref0(var) ((var == NULL) ? NULL : (var = (gck_builder_unref (var), NULL)))
enum  {
	SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_0_PROPERTY,
	SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_MECHANISM_TYPE_PROPERTY,
	SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_LABEL_PROPERTY,
	SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_NUM_PROPERTIES
};
static GParamSpec* seahorse_pkcs11_generate_mechanism_list_item_properties[SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_NUM_PROPERTIES];
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SeahorsePkcs11GeneratePrivate {
	AdwEntryRow* label_row;
	AdwComboRow* token_row;
	GckMechanism* mechanism;
	AdwComboRow* mechanism_row;
	GListStore* mechanism_items;
	AdwSpinRow* key_size_row;
	GCancellable* cancellable;
	GckAttributes* pub_attrs;
	GckAttributes* prv_attrs;
};

struct _SeahorsePkcs11GenerateMechanismEntry {
	gulong mechanism_type;
	gchar* label;
};

struct _SeahorsePkcs11GenerateCreateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorsePkcs11Generate* self;
	AdwComboRow* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	SeahorsePkcs11Token* token;
	AdwComboRow* _tmp3_;
	GObject* _tmp4_;
	GObject* _tmp5_;
	SeahorsePkcs11Token* _tmp6_;
	SeahorseInteraction* interaction;
	GtkWindow* _tmp7_;
	GtkWindow* _tmp8_;
	SeahorseInteraction* _tmp9_;
	GCancellable* _tmp10_;
	GckSession* session;
	SeahorsePkcs11Token* _tmp11_;
	GckSlot* _tmp12_;
	GckSlot* _tmp13_;
	SeahorseInteraction* _tmp14_;
	GCancellable* _tmp15_;
	GckSession* _tmp16_;
	GckObject* pub;
	GckObject* priv;
	GckSession* _tmp17_;
	GckMechanism* _tmp18_;
	GckAttributes* _tmp19_;
	GckAttributes* _tmp20_;
	GCancellable* _tmp21_;
	GckMechanism _tmp22_;
	GckObject* _tmp23_;
	GckObject* _tmp24_;
	SeahorsePkcs11Token* _tmp25_;
	GCancellable* _tmp26_;
	GckAttributes* _tmp27_;
	GckAttributes* _tmp28_;
	GError* e;
	GError* _tmp29_;
	const gchar* _tmp30_;
	GError* _inner_error0_;
};

struct _SeahorsePkcs11GenerateMechanismListItemPrivate {
	gulong _mechanism_type;
	gchar* _label;
};

static gint SeahorsePkcs11Generate_private_offset;
static gpointer seahorse_pkcs11_generate_parent_class = NULL;
static gint SeahorsePkcs11GenerateMechanismListItem_private_offset;
static gpointer seahorse_pkcs11_generate_mechanism_list_item_parent_class = NULL;

static GType seahorse_pkcs11_generate_mechanism_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SeahorsePkcs11GenerateMechanismEntry* seahorse_pkcs11_generate_mechanism_entry_dup (const SeahorsePkcs11GenerateMechanismEntry* self);
static void seahorse_pkcs11_generate_mechanism_entry_free (SeahorsePkcs11GenerateMechanismEntry* self);
static void seahorse_pkcs11_generate_mechanism_entry_copy (const SeahorsePkcs11GenerateMechanismEntry* self,
                                                    SeahorsePkcs11GenerateMechanismEntry* dest);
static void seahorse_pkcs11_generate_mechanism_entry_destroy (SeahorsePkcs11GenerateMechanismEntry* self);
static void seahorse_pkcs11_generate_validate_input (SeahorsePkcs11Generate* self);
static void seahorse_pkcs11_generate_on_selected_token_changed (SeahorsePkcs11Generate* self,
                                                         GObject* object,
                                                         GParamSpec* spec);
static void _g_object_unref0_ (gpointer var);
static const gchar* seahorse_pkcs11_generate_get_available_mechanism_label (SeahorsePkcs11Generate* self,
                                                                     gulong type);
static void seahorse_pkcs11_generate_on_mechanism_selected (SeahorsePkcs11Generate* self,
                                                     GObject* object,
                                                     GParamSpec* pspec);
static GckMechanism* _gck_mechanism_dup (GckMechanism* self);
static void _vala_GckMechanismInfo_free (GckMechanismInfo* self);
static void _seahorse_pkcs11_generate_on_mechanism_selected_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void seahorse_pkcs11_generate_create_action (SeahorsePkcs11Generate* self,
                                             const gchar* action_name,
                                             GVariant* param);
static void seahorse_pkcs11_generate_create (SeahorsePkcs11Generate* self,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void seahorse_pkcs11_generate_create_finish (SeahorsePkcs11Generate* self,
                                             GAsyncResult* _res_);
static void seahorse_pkcs11_generate_create_data_free (gpointer _data);
static gboolean seahorse_pkcs11_generate_create_co (SeahorsePkcs11GenerateCreateData* _data_);
static void seahorse_pkcs11_generate_prepare_generate (SeahorsePkcs11Generate* self);
static void seahorse_pkcs11_generate_create_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void seahorse_pkcs11_generate_mechanism_list_item_finalize (GObject * obj);
static GType seahorse_pkcs11_generate_mechanism_list_item_get_type_once (void);
static void _vala_seahorse_pkcs11_generate_mechanism_list_item_get_property (GObject * object,
                                                                      guint property_id,
                                                                      GValue * value,
                                                                      GParamSpec * pspec);
static void _vala_seahorse_pkcs11_generate_mechanism_list_item_set_property (GObject * object,
                                                                      guint property_id,
                                                                      const GValue * value,
                                                                      GParamSpec * pspec);
static GObject * seahorse_pkcs11_generate_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _seahorse_pkcs11_generate___lambda12_ (SeahorsePkcs11Generate* self,
                                            GListModel* model,
                                            guint pos,
                                            guint removed,
                                            guint added);
static void __seahorse_pkcs11_generate___lambda12__g_list_model_items_changed (GListModel* _sender,
                                                                        guint position,
                                                                        guint removed,
                                                                        guint added,
                                                                        gpointer self);
static void _seahorse_pkcs11_generate_on_selected_token_changed_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self);
static void seahorse_pkcs11_generate_finalize (GObject * obj);
static GType seahorse_pkcs11_generate_get_type_once (void);

static const SeahorsePkcs11GenerateMechanismEntry SEAHORSE_PKCS11_GENERATE_AVAILABLE_MECHANISMS[1] = {{CKM_RSA_PKCS_KEY_PAIR_GEN, N_ ("RSA")}};

static inline gpointer
seahorse_pkcs11_generate_get_instance_private (SeahorsePkcs11Generate* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePkcs11Generate_private_offset);
}

SeahorsePkcs11Generate*
seahorse_pkcs11_generate_construct (GType object_type,
                                    GtkWindow* parent)
{
	SeahorsePkcs11Generate * self = NULL;
#line 86 "../pkcs11/pkcs11-generate.vala"
	self = (SeahorsePkcs11Generate*) g_object_new (object_type, "transient-for", parent, NULL);
#line 85 "../pkcs11/pkcs11-generate.vala"
	return self;
#line 234 "pkcs11-generate.c"
}

SeahorsePkcs11Generate*
seahorse_pkcs11_generate_new (GtkWindow* parent)
{
#line 85 "../pkcs11/pkcs11-generate.vala"
	return seahorse_pkcs11_generate_construct (SEAHORSE_PKCS11_TYPE_GENERATE, parent);
#line 242 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_validate_input (SeahorsePkcs11Generate* self)
{
	gboolean _tmp0_ = FALSE;
	AdwComboRow* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_;
#line 89 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 91 "../pkcs11/pkcs11-generate.vala"
	_tmp1_ = self->priv->token_row;
#line 91 "../pkcs11/pkcs11-generate.vala"
	_tmp2_ = adw_combo_row_get_selected_item (_tmp1_);
#line 91 "../pkcs11/pkcs11-generate.vala"
	_tmp3_ = _tmp2_;
#line 91 "../pkcs11/pkcs11-generate.vala"
	if (_tmp3_ != NULL) {
#line 262 "pkcs11-generate.c"
		AdwComboRow* _tmp4_;
		GObject* _tmp5_;
		GObject* _tmp6_;
#line 92 "../pkcs11/pkcs11-generate.vala"
		_tmp4_ = self->priv->mechanism_row;
#line 92 "../pkcs11/pkcs11-generate.vala"
		_tmp5_ = adw_combo_row_get_selected_item (_tmp4_);
#line 92 "../pkcs11/pkcs11-generate.vala"
		_tmp6_ = _tmp5_;
#line 92 "../pkcs11/pkcs11-generate.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 274 "pkcs11-generate.c"
	} else {
#line 91 "../pkcs11/pkcs11-generate.vala"
		_tmp0_ = FALSE;
#line 278 "pkcs11-generate.c"
	}
#line 90 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "create", _tmp0_);
#line 282 "pkcs11-generate.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 96 "../pkcs11/pkcs11-generate.vala"
	return self ? g_object_ref (self) : NULL;
#line 290 "pkcs11-generate.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 98 "../pkcs11/pkcs11-generate.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 298 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_on_selected_token_changed (SeahorsePkcs11Generate* self,
                                                    GObject* object,
                                                    GParamSpec* spec)
{
	SeahorsePkcs11Token* token = NULL;
	AdwComboRow* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	SeahorsePkcs11Token* _tmp3_;
	GPtrArray* new_tokens = NULL;
	GPtrArray* _tmp4_;
	SeahorsePkcs11Token* _tmp5_;
	GListStore* _tmp19_;
	GListStore* _tmp20_;
	GPtrArray* _tmp21_;
	gpointer* _tmp22_;
	gint _tmp22__length1;
#line 95 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 95 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (object != NULL);
#line 96 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = self->priv->token_row;
#line 96 "../pkcs11/pkcs11-generate.vala"
	_tmp1_ = adw_combo_row_get_selected_item (_tmp0_);
#line 96 "../pkcs11/pkcs11-generate.vala"
	_tmp2_ = _tmp1_;
#line 96 "../pkcs11/pkcs11-generate.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, SEAHORSE_PKCS11_TYPE_TOKEN, SeahorsePkcs11Token));
#line 96 "../pkcs11/pkcs11-generate.vala"
	token = _tmp3_;
#line 98 "../pkcs11/pkcs11-generate.vala"
	_tmp4_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 98 "../pkcs11/pkcs11-generate.vala"
	new_tokens = _tmp4_;
#line 100 "../pkcs11/pkcs11-generate.vala"
	_tmp5_ = token;
#line 100 "../pkcs11/pkcs11-generate.vala"
	if (_tmp5_ != NULL) {
#line 341 "pkcs11-generate.c"
		{
			guint i = 0U;
#line 101 "../pkcs11/pkcs11-generate.vala"
			i = (guint) 0;
#line 346 "pkcs11-generate.c"
			{
				gboolean _tmp6_ = FALSE;
#line 101 "../pkcs11/pkcs11-generate.vala"
				_tmp6_ = TRUE;
#line 101 "../pkcs11/pkcs11-generate.vala"
				while (TRUE) {
#line 353 "pkcs11-generate.c"
					SeahorsePkcs11Token* _tmp8_;
					GArray* _tmp9_;
					GArray* _tmp10_;
					gulong type = 0UL;
					SeahorsePkcs11Token* _tmp11_;
					GArray* _tmp12_;
					GArray* _tmp13_;
					const gchar* label = NULL;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					GPtrArray* _tmp16_;
					const gchar* _tmp17_;
					SeahorsePkcs11GenerateMechanismListItem* _tmp18_;
#line 101 "../pkcs11/pkcs11-generate.vala"
					if (!_tmp6_) {
#line 369 "pkcs11-generate.c"
						guint _tmp7_;
#line 101 "../pkcs11/pkcs11-generate.vala"
						_tmp7_ = i;
#line 101 "../pkcs11/pkcs11-generate.vala"
						i = _tmp7_ + 1;
#line 375 "pkcs11-generate.c"
					}
#line 101 "../pkcs11/pkcs11-generate.vala"
					_tmp6_ = FALSE;
#line 101 "../pkcs11/pkcs11-generate.vala"
					_tmp8_ = token;
#line 101 "../pkcs11/pkcs11-generate.vala"
					_tmp9_ = seahorse_pkcs11_token_get_mechanisms (_tmp8_);
#line 101 "../pkcs11/pkcs11-generate.vala"
					_tmp10_ = _tmp9_;
#line 101 "../pkcs11/pkcs11-generate.vala"
					if (!(i < _tmp10_->len)) {
#line 101 "../pkcs11/pkcs11-generate.vala"
						break;
#line 389 "pkcs11-generate.c"
					}
#line 102 "../pkcs11/pkcs11-generate.vala"
					_tmp11_ = token;
#line 102 "../pkcs11/pkcs11-generate.vala"
					_tmp12_ = seahorse_pkcs11_token_get_mechanisms (_tmp11_);
#line 102 "../pkcs11/pkcs11-generate.vala"
					_tmp13_ = _tmp12_;
#line 102 "../pkcs11/pkcs11-generate.vala"
					type = g_array_index (_tmp13_, gulong, i);
#line 105 "../pkcs11/pkcs11-generate.vala"
					_tmp14_ = seahorse_pkcs11_generate_get_available_mechanism_label (self, type);
#line 105 "../pkcs11/pkcs11-generate.vala"
					label = _tmp14_;
#line 106 "../pkcs11/pkcs11-generate.vala"
					_tmp15_ = label;
#line 106 "../pkcs11/pkcs11-generate.vala"
					if (_tmp15_ == NULL) {
#line 107 "../pkcs11/pkcs11-generate.vala"
						continue;
#line 409 "pkcs11-generate.c"
					}
#line 109 "../pkcs11/pkcs11-generate.vala"
					_tmp16_ = new_tokens;
#line 109 "../pkcs11/pkcs11-generate.vala"
					_tmp17_ = label;
#line 109 "../pkcs11/pkcs11-generate.vala"
					_tmp18_ = seahorse_pkcs11_generate_mechanism_list_item_new (type, _tmp17_);
#line 109 "../pkcs11/pkcs11-generate.vala"
					g_ptr_array_add (_tmp16_, _tmp18_);
#line 419 "pkcs11-generate.c"
				}
			}
		}
	}
#line 113 "../pkcs11/pkcs11-generate.vala"
	_tmp19_ = self->priv->mechanism_items;
#line 113 "../pkcs11/pkcs11-generate.vala"
	_tmp20_ = self->priv->mechanism_items;
#line 113 "../pkcs11/pkcs11-generate.vala"
	_tmp21_ = new_tokens;
#line 113 "../pkcs11/pkcs11-generate.vala"
	_tmp22_ = _tmp21_->pdata;
#line 113 "../pkcs11/pkcs11-generate.vala"
	_tmp22__length1 = _tmp21_->len;
#line 113 "../pkcs11/pkcs11-generate.vala"
	g_list_store_splice (_tmp19_, (guint) 0, g_list_model_get_n_items ((GListModel*) _tmp20_), _tmp22_, (guint) _tmp22__length1);
#line 115 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_validate_input (self);
#line 95 "../pkcs11/pkcs11-generate.vala"
	_g_ptr_array_unref0 (new_tokens);
#line 95 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (token);
#line 442 "pkcs11-generate.c"
}

static const gchar*
seahorse_pkcs11_generate_get_available_mechanism_label (SeahorsePkcs11Generate* self,
                                                        gulong type)
{
	const gchar* result;
#line 118 "../pkcs11/pkcs11-generate.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 452 "pkcs11-generate.c"
	{
		SeahorsePkcs11GenerateMechanismEntry* mechanism_collection = NULL;
		gint mechanism_collection_length1 = 0;
		gint _mechanism_collection_size_ = 0;
		gint mechanism_it = 0;
#line 119 "../pkcs11/pkcs11-generate.vala"
		mechanism_collection = SEAHORSE_PKCS11_GENERATE_AVAILABLE_MECHANISMS;
#line 119 "../pkcs11/pkcs11-generate.vala"
		mechanism_collection_length1 = G_N_ELEMENTS (SEAHORSE_PKCS11_GENERATE_AVAILABLE_MECHANISMS);
#line 119 "../pkcs11/pkcs11-generate.vala"
		for (mechanism_it = 0; mechanism_it < mechanism_collection_length1; mechanism_it = mechanism_it + 1) {
#line 464 "pkcs11-generate.c"
			SeahorsePkcs11GenerateMechanismEntry mechanism = {0};
#line 119 "../pkcs11/pkcs11-generate.vala"
			mechanism = mechanism_collection[mechanism_it];
#line 468 "pkcs11-generate.c"
			{
				SeahorsePkcs11GenerateMechanismEntry _tmp0_;
#line 120 "../pkcs11/pkcs11-generate.vala"
				_tmp0_ = mechanism;
#line 120 "../pkcs11/pkcs11-generate.vala"
				if (_tmp0_.mechanism_type == type) {
#line 475 "pkcs11-generate.c"
					SeahorsePkcs11GenerateMechanismEntry _tmp1_;
					const gchar* _tmp2_;
#line 121 "../pkcs11/pkcs11-generate.vala"
					_tmp1_ = mechanism;
#line 121 "../pkcs11/pkcs11-generate.vala"
					_tmp2_ = _tmp1_.label;
#line 121 "../pkcs11/pkcs11-generate.vala"
					result = _tmp2_;
#line 121 "../pkcs11/pkcs11-generate.vala"
					return result;
#line 486 "pkcs11-generate.c"
				}
			}
		}
	}
#line 124 "../pkcs11/pkcs11-generate.vala"
	result = NULL;
#line 124 "../pkcs11/pkcs11-generate.vala"
	return result;
#line 495 "pkcs11-generate.c"
}

static GckMechanism*
_gck_mechanism_dup (GckMechanism* self)
{
	GckMechanism* dup;
#line 135 "../pkcs11/pkcs11-generate.vala"
	dup = g_new0 (GckMechanism, 1);
#line 135 "../pkcs11/pkcs11-generate.vala"
	memcpy (dup, self, sizeof (GckMechanism));
#line 135 "../pkcs11/pkcs11-generate.vala"
	return dup;
#line 508 "pkcs11-generate.c"
}

static gpointer
__gck_mechanism_dup0 (gpointer self)
{
#line 135 "../pkcs11/pkcs11-generate.vala"
	return self ? _gck_mechanism_dup (self) : NULL;
#line 516 "pkcs11-generate.c"
}

static void
_vala_GckMechanismInfo_free (GckMechanismInfo* self)
{
#line 134 "../pkcs11/pkcs11-generate.vala"
	g_boxed_free (gck_mechanism_info_get_type (), self);
#line 524 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_on_mechanism_selected (SeahorsePkcs11Generate* self,
                                                GObject* object,
                                                GParamSpec* pspec)
{
	AdwComboRow* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	SeahorsePkcs11Token* token = NULL;
	AdwComboRow* _tmp3_;
	GObject* _tmp4_;
	GObject* _tmp5_;
	SeahorsePkcs11Token* _tmp6_;
	SeahorsePkcs11GenerateMechanismListItem* selected = NULL;
	AdwComboRow* _tmp7_;
	GObject* _tmp8_;
	GObject* _tmp9_;
	SeahorsePkcs11GenerateMechanismListItem* _tmp10_;
	SeahorsePkcs11GenerateMechanismListItem* _tmp11_;
	AdwSpinRow* _tmp30_;
	GckMechanism* _tmp31_;
#line 128 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 128 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (object != NULL);
#line 128 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (pspec != NULL);
#line 128 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = self->priv->token_row;
#line 128 "../pkcs11/pkcs11-generate.vala"
	_tmp1_ = adw_combo_row_get_selected_item (_tmp0_);
#line 128 "../pkcs11/pkcs11-generate.vala"
	_tmp2_ = _tmp1_;
#line 128 "../pkcs11/pkcs11-generate.vala"
	_vala_return_if_fail (_tmp2_ != NULL, "this.token_row.selected_item != null");
#line 130 "../pkcs11/pkcs11-generate.vala"
	_tmp3_ = self->priv->token_row;
#line 130 "../pkcs11/pkcs11-generate.vala"
	_tmp4_ = adw_combo_row_get_selected_item (_tmp3_);
#line 130 "../pkcs11/pkcs11-generate.vala"
	_tmp5_ = _tmp4_;
#line 130 "../pkcs11/pkcs11-generate.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, SEAHORSE_PKCS11_TYPE_TOKEN, SeahorsePkcs11Token));
#line 130 "../pkcs11/pkcs11-generate.vala"
	token = _tmp6_;
#line 131 "../pkcs11/pkcs11-generate.vala"
	_g_free0 (self->priv->mechanism);
#line 131 "../pkcs11/pkcs11-generate.vala"
	self->priv->mechanism = NULL;
#line 133 "../pkcs11/pkcs11-generate.vala"
	_tmp7_ = self->priv->mechanism_row;
#line 133 "../pkcs11/pkcs11-generate.vala"
	_tmp8_ = adw_combo_row_get_selected_item (_tmp7_);
#line 133 "../pkcs11/pkcs11-generate.vala"
	_tmp9_ = _tmp8_;
#line 133 "../pkcs11/pkcs11-generate.vala"
	_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, SEAHORSE_PKCS11_GENERATE_TYPE_MECHANISM_LIST_ITEM, SeahorsePkcs11GenerateMechanismListItem));
#line 133 "../pkcs11/pkcs11-generate.vala"
	selected = _tmp10_;
#line 134 "../pkcs11/pkcs11-generate.vala"
	_tmp11_ = selected;
#line 134 "../pkcs11/pkcs11-generate.vala"
	if (_tmp11_ != NULL) {
#line 590 "pkcs11-generate.c"
		GckMechanism _tmp12_ = {0};
		GckMechanism* _tmp13_;
		GckMechanism* _tmp14_;
		SeahorsePkcs11GenerateMechanismListItem* _tmp15_;
		gulong _tmp16_;
		gulong _tmp17_;
		GckSlot* slot = NULL;
		SeahorsePkcs11Token* _tmp18_;
		GckSlot* _tmp19_;
		GckSlot* _tmp20_;
		GckSlot* _tmp21_;
		GckMechanismInfo* info = NULL;
		GckSlot* _tmp22_;
		GckMechanism* _tmp23_;
		GckMechanismInfo* _tmp24_;
		gulong min = 0UL;
		GckMechanismInfo* _tmp25_;
		gulong max = 0UL;
		GckMechanismInfo* _tmp26_;
		gboolean _tmp27_ = FALSE;
		gboolean _tmp28_ = FALSE;
		AdwSpinRow* _tmp29_;
#line 135 "../pkcs11/pkcs11-generate.vala"
		memset (&_tmp12_, 0, sizeof (GckMechanism));
#line 135 "../pkcs11/pkcs11-generate.vala"
		_tmp13_ = __gck_mechanism_dup0 (&_tmp12_);
#line 135 "../pkcs11/pkcs11-generate.vala"
		_g_free0 (self->priv->mechanism);
#line 135 "../pkcs11/pkcs11-generate.vala"
		self->priv->mechanism = _tmp13_;
#line 136 "../pkcs11/pkcs11-generate.vala"
		_tmp14_ = self->priv->mechanism;
#line 136 "../pkcs11/pkcs11-generate.vala"
		_tmp15_ = selected;
#line 136 "../pkcs11/pkcs11-generate.vala"
		_tmp16_ = seahorse_pkcs11_generate_mechanism_list_item_get_mechanism_type (_tmp15_);
#line 136 "../pkcs11/pkcs11-generate.vala"
		_tmp17_ = _tmp16_;
#line 136 "../pkcs11/pkcs11-generate.vala"
		(*_tmp14_).type = _tmp17_;
#line 138 "../pkcs11/pkcs11-generate.vala"
		_tmp18_ = token;
#line 138 "../pkcs11/pkcs11-generate.vala"
		_tmp19_ = seahorse_pkcs11_token_get_slot (_tmp18_);
#line 138 "../pkcs11/pkcs11-generate.vala"
		_tmp20_ = _tmp19_;
#line 138 "../pkcs11/pkcs11-generate.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 138 "../pkcs11/pkcs11-generate.vala"
		slot = _tmp21_;
#line 139 "../pkcs11/pkcs11-generate.vala"
		_tmp22_ = slot;
#line 139 "../pkcs11/pkcs11-generate.vala"
		_tmp23_ = self->priv->mechanism;
#line 139 "../pkcs11/pkcs11-generate.vala"
		_tmp24_ = gck_slot_get_mechanism_info (_tmp22_, (*_tmp23_).type);
#line 139 "../pkcs11/pkcs11-generate.vala"
		info = _tmp24_;
#line 141 "../pkcs11/pkcs11-generate.vala"
		_tmp25_ = info;
#line 141 "../pkcs11/pkcs11-generate.vala"
		min = _tmp25_->min_key_size;
#line 142 "../pkcs11/pkcs11-generate.vala"
		_tmp26_ = info;
#line 142 "../pkcs11/pkcs11-generate.vala"
		max = _tmp26_->max_key_size;
#line 144 "../pkcs11/pkcs11-generate.vala"
		if (min < ((gulong) 512)) {
#line 144 "../pkcs11/pkcs11-generate.vala"
			_tmp27_ = max >= ((gulong) 512);
#line 661 "pkcs11-generate.c"
		} else {
#line 144 "../pkcs11/pkcs11-generate.vala"
			_tmp27_ = FALSE;
#line 665 "pkcs11-generate.c"
		}
#line 144 "../pkcs11/pkcs11-generate.vala"
		if (_tmp27_) {
#line 145 "../pkcs11/pkcs11-generate.vala"
			min = (gulong) 512;
#line 671 "pkcs11-generate.c"
		}
#line 146 "../pkcs11/pkcs11-generate.vala"
		if (max > ((gulong) 16384)) {
#line 146 "../pkcs11/pkcs11-generate.vala"
			_tmp28_ = min <= ((gulong) 16384);
#line 677 "pkcs11-generate.c"
		} else {
#line 146 "../pkcs11/pkcs11-generate.vala"
			_tmp28_ = FALSE;
#line 681 "pkcs11-generate.c"
		}
#line 146 "../pkcs11/pkcs11-generate.vala"
		if (_tmp28_) {
#line 147 "../pkcs11/pkcs11-generate.vala"
			max = (gulong) 16384;
#line 687 "pkcs11-generate.c"
		}
#line 148 "../pkcs11/pkcs11-generate.vala"
		_tmp29_ = self->priv->key_size_row;
#line 148 "../pkcs11/pkcs11-generate.vala"
		adw_spin_row_set_range (_tmp29_, (gdouble) min, (gdouble) max);
#line 134 "../pkcs11/pkcs11-generate.vala"
		__vala_GckMechanismInfo_free0 (info);
#line 134 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (slot);
#line 697 "pkcs11-generate.c"
	}
#line 151 "../pkcs11/pkcs11-generate.vala"
	_tmp30_ = self->priv->key_size_row;
#line 151 "../pkcs11/pkcs11-generate.vala"
	_tmp31_ = self->priv->mechanism;
#line 151 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp30_, _tmp31_ != NULL);
#line 153 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_validate_input (self);
#line 128 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (selected);
#line 128 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (token);
#line 711 "pkcs11-generate.c"
}

static void
_seahorse_pkcs11_generate_on_mechanism_selected_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
#line 23 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_on_mechanism_selected ((SeahorsePkcs11Generate*) self, _sender, pspec);
#line 721 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_create_action (SeahorsePkcs11Generate* self,
                                        const gchar* action_name,
                                        GVariant* param)
{
#line 156 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 156 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (action_name != NULL);
#line 157 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_create (self, NULL, NULL);
#line 735 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_create_data_free (gpointer _data)
{
	SeahorsePkcs11GenerateCreateData* _data_;
	_data_ = _data;
#line 23 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../pkcs11/pkcs11-generate.vala"
	g_slice_free (SeahorsePkcs11GenerateCreateData, _data_);
#line 747 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_create (SeahorsePkcs11Generate* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	SeahorsePkcs11GenerateCreateData* _data_;
	SeahorsePkcs11Generate* _tmp0_;
#line 23 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 23 "../pkcs11/pkcs11-generate.vala"
	_data_ = g_slice_new0 (SeahorsePkcs11GenerateCreateData);
#line 23 "../pkcs11/pkcs11-generate.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../pkcs11/pkcs11-generate.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_pkcs11_generate_create_data_free);
#line 23 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../pkcs11/pkcs11-generate.vala"
	_data_->self = _tmp0_;
#line 23 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_create_co (_data_);
#line 771 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_create_finish (SeahorsePkcs11Generate* self,
                                        GAsyncResult* _res_)
{
	SeahorsePkcs11GenerateCreateData* _data_;
#line 23 "../pkcs11/pkcs11-generate.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 781 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_create_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	SeahorsePkcs11GenerateCreateData* _data_;
#line 172 "../pkcs11/pkcs11-generate.vala"
	_data_ = _user_data_;
#line 172 "../pkcs11/pkcs11-generate.vala"
	_data_->_source_object_ = source_object;
#line 172 "../pkcs11/pkcs11-generate.vala"
	_data_->_res_ = _res_;
#line 172 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_create_co (_data_);
#line 798 "pkcs11-generate.c"
}

static gpointer
_gck_attributes_ref0 (gpointer self)
{
#line 180 "../pkcs11/pkcs11-generate.vala"
	return self ? gck_attributes_ref (self) : NULL;
#line 806 "pkcs11-generate.c"
}

static gboolean
seahorse_pkcs11_generate_create_co (SeahorsePkcs11GenerateCreateData* _data_)
{
#line 160 "../pkcs11/pkcs11-generate.vala"
	switch (_data_->_state_) {
#line 160 "../pkcs11/pkcs11-generate.vala"
		case 0:
#line 816 "pkcs11-generate.c"
		goto _state_0;
#line 160 "../pkcs11/pkcs11-generate.vala"
		case 1:
#line 820 "pkcs11-generate.c"
		goto _state_1;
#line 160 "../pkcs11/pkcs11-generate.vala"
		case 2:
#line 824 "pkcs11-generate.c"
		goto _state_2;
#line 160 "../pkcs11/pkcs11-generate.vala"
		case 3:
#line 828 "pkcs11-generate.c"
		goto _state_3;
		default:
#line 160 "../pkcs11/pkcs11-generate.vala"
		g_assert_not_reached ();
#line 833 "pkcs11-generate.c"
	}
	_state_0:
#line 160 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp0_ = _data_->self->priv->token_row;
#line 160 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp1_ = adw_combo_row_get_selected_item (_data_->_tmp0_);
#line 160 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 160 "../pkcs11/pkcs11-generate.vala"
	_vala_return_val_if_fail (_data_->_tmp2_ != NULL, "this.token_row.selected_item != null", FALSE);
#line 162 "../pkcs11/pkcs11-generate.vala"
	gtk_window_close ((GtkWindow*) _data_->self);
#line 164 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp3_ = _data_->self->priv->token_row;
#line 164 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp4_ = adw_combo_row_get_selected_item (_data_->_tmp3_);
#line 164 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 164 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp5_, SEAHORSE_PKCS11_TYPE_TOKEN, SeahorsePkcs11Token));
#line 164 "../pkcs11/pkcs11-generate.vala"
	_data_->token = _data_->_tmp6_;
#line 166 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_prepare_generate (_data_->self);
#line 168 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp7_ = gtk_window_get_transient_for ((GtkWindow*) _data_->self);
#line 168 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 168 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp9_ = seahorse_interaction_new (_data_->_tmp8_);
#line 168 "../pkcs11/pkcs11-generate.vala"
	_data_->interaction = _data_->_tmp9_;
#line 169 "../pkcs11/pkcs11-generate.vala"
	_data_->_tmp10_ = _data_->self->priv->cancellable;
#line 169 "../pkcs11/pkcs11-generate.vala"
	seahorse_progress_show (_data_->_tmp10_, _ ("Generating key"), FALSE);
#line 870 "pkcs11-generate.c"
	{
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp11_ = _data_->token;
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp12_ = seahorse_pkcs11_token_get_slot (_data_->_tmp11_);
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp13_ = _data_->_tmp12_;
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp14_ = _data_->interaction;
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp15_ = _data_->self->priv->cancellable;
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->_state_ = 1;
#line 172 "../pkcs11/pkcs11-generate.vala"
		gck_session_open_async (_data_->_tmp13_, GCK_SESSION_READ_WRITE | GCK_SESSION_LOGIN_USER, (GTlsInteraction*) _data_->_tmp14_, _data_->_tmp15_, seahorse_pkcs11_generate_create_ready, _data_);
#line 172 "../pkcs11/pkcs11-generate.vala"
		return FALSE;
#line 888 "pkcs11-generate.c"
		_state_1:
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp16_ = gck_session_open_finish (_data_->_res_, &_data_->_inner_error0_);
#line 172 "../pkcs11/pkcs11-generate.vala"
		_data_->session = _data_->_tmp16_;
#line 172 "../pkcs11/pkcs11-generate.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 896 "pkcs11-generate.c"
			goto __catch0_g_error;
		}
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp17_ = _data_->session;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp18_ = _data_->self->priv->mechanism;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp19_ = _data_->self->priv->pub_attrs;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp20_ = _data_->self->priv->prv_attrs;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp21_ = _data_->self->priv->cancellable;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp22_ = *_data_->_tmp18_;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp23_ = NULL;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp24_ = NULL;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->_state_ = 2;
#line 176 "../pkcs11/pkcs11-generate.vala"
		gck_session_generate_key_pair_async (_data_->_tmp17_, &_data_->_tmp22_, _data_->_tmp19_, _data_->_tmp20_, _data_->_tmp21_, seahorse_pkcs11_generate_create_ready, _data_);
#line 176 "../pkcs11/pkcs11-generate.vala"
		return FALSE;
#line 921 "pkcs11-generate.c"
		_state_2:
#line 176 "../pkcs11/pkcs11-generate.vala"
		gck_session_generate_key_pair_finish (_data_->_tmp17_, _data_->_res_, &_data_->_tmp23_, &_data_->_tmp24_, &_data_->_inner_error0_);
#line 176 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->pub);
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->pub = _data_->_tmp23_;
#line 176 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->priv);
#line 176 "../pkcs11/pkcs11-generate.vala"
		_data_->priv = _data_->_tmp24_;
#line 176 "../pkcs11/pkcs11-generate.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 176 "../pkcs11/pkcs11-generate.vala"
			_g_object_unref0 (_data_->priv);
#line 176 "../pkcs11/pkcs11-generate.vala"
			_g_object_unref0 (_data_->pub);
#line 176 "../pkcs11/pkcs11-generate.vala"
			_g_object_unref0 (_data_->session);
#line 941 "pkcs11-generate.c"
			goto __catch0_g_error;
		}
#line 178 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp25_ = _data_->token;
#line 178 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp26_ = _data_->self->priv->cancellable;
#line 178 "../pkcs11/pkcs11-generate.vala"
		_data_->_state_ = 3;
#line 178 "../pkcs11/pkcs11-generate.vala"
		seahorse_place_load ((SeahorsePlace*) _data_->_tmp25_, _data_->_tmp26_, seahorse_pkcs11_generate_create_ready, _data_);
#line 178 "../pkcs11/pkcs11-generate.vala"
		return FALSE;
#line 954 "pkcs11-generate.c"
		_state_3:
#line 178 "../pkcs11/pkcs11-generate.vala"
		seahorse_place_load_finish ((SeahorsePlace*) _data_->_tmp25_, _data_->_res_, &_data_->_inner_error0_);
#line 178 "../pkcs11/pkcs11-generate.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 178 "../pkcs11/pkcs11-generate.vala"
			_g_object_unref0 (_data_->priv);
#line 178 "../pkcs11/pkcs11-generate.vala"
			_g_object_unref0 (_data_->pub);
#line 178 "../pkcs11/pkcs11-generate.vala"
			_g_object_unref0 (_data_->session);
#line 966 "pkcs11-generate.c"
			goto __catch0_g_error;
		}
#line 179 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->self->priv->cancellable);
#line 179 "../pkcs11/pkcs11-generate.vala"
		_data_->self->priv->cancellable = NULL;
#line 180 "../pkcs11/pkcs11-generate.vala"
		_gck_attributes_unref0 (_data_->self->priv->prv_attrs);
#line 180 "../pkcs11/pkcs11-generate.vala"
		_data_->self->priv->prv_attrs = NULL;
#line 180 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp27_ = _data_->self->priv->prv_attrs;
#line 180 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp28_ = _gck_attributes_ref0 (_data_->_tmp27_);
#line 180 "../pkcs11/pkcs11-generate.vala"
		_gck_attributes_unref0 (_data_->self->priv->pub_attrs);
#line 180 "../pkcs11/pkcs11-generate.vala"
		_data_->self->priv->pub_attrs = _data_->_tmp28_;
#line 171 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->priv);
#line 171 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->pub);
#line 171 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->session);
#line 991 "pkcs11-generate.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 171 "../pkcs11/pkcs11-generate.vala"
		_data_->e = _data_->_inner_error0_;
#line 171 "../pkcs11/pkcs11-generate.vala"
		_data_->_inner_error0_ = NULL;
#line 182 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp29_ = _data_->e;
#line 182 "../pkcs11/pkcs11-generate.vala"
		_data_->_tmp30_ = _data_->_tmp29_->message;
#line 182 "../pkcs11/pkcs11-generate.vala"
		seahorse_util_show_error (NULL, _ ("Couldn’t generate private key"), _data_->_tmp30_);
#line 171 "../pkcs11/pkcs11-generate.vala"
		_g_error_free0 (_data_->e);
#line 1008 "pkcs11-generate.c"
	}
	__finally0:
#line 171 "../pkcs11/pkcs11-generate.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 171 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->interaction);
#line 171 "../pkcs11/pkcs11-generate.vala"
		_g_object_unref0 (_data_->token);
#line 171 "../pkcs11/pkcs11-generate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 171 "../pkcs11/pkcs11-generate.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 171 "../pkcs11/pkcs11-generate.vala"
		g_object_unref (_data_->_async_result);
#line 171 "../pkcs11/pkcs11-generate.vala"
		return FALSE;
#line 1025 "pkcs11-generate.c"
	}
#line 160 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (_data_->interaction);
#line 160 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (_data_->token);
#line 160 "../pkcs11/pkcs11-generate.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 160 "../pkcs11/pkcs11-generate.vala"
	if (_data_->_state_ != 0) {
#line 160 "../pkcs11/pkcs11-generate.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 160 "../pkcs11/pkcs11-generate.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1039 "pkcs11-generate.c"
		}
	}
#line 160 "../pkcs11/pkcs11-generate.vala"
	g_object_unref (_data_->_async_result);
#line 160 "../pkcs11/pkcs11-generate.vala"
	return FALSE;
#line 1046 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_prepare_generate (SeahorsePkcs11Generate* self)
{
#line 187 "../pkcs11/pkcs11-generate.vala"
	static const guchar rsa_public_exponent[3] = {(guchar) 0x01, (guchar) 0x00, (guchar) 0x01};
#line 1054 "pkcs11-generate.c"
	GckBuilder* publi = NULL;
	GckBuilder* _tmp0_;
	GckBuilder* priva = NULL;
	GckBuilder* _tmp1_;
	GCancellable* _tmp2_;
	GckMechanism* _tmp3_;
	GckBuilder* _tmp4_;
	GckBuilder* _tmp5_;
	GckBuilder* _tmp6_;
	GckBuilder* _tmp7_;
	GckBuilder* _tmp8_;
	GckBuilder* _tmp9_;
	gchar* label = NULL;
	AdwEntryRow* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	GckBuilder* _tmp14_;
	const gchar* _tmp15_;
	GckBuilder* _tmp16_;
	const gchar* _tmp17_;
	GckMechanism* _tmp18_;
	GckBuilder* _tmp30_;
	GckAttributes* _tmp31_;
	GckBuilder* _tmp32_;
	GckAttributes* _tmp33_;
	GckBuilder* _tmp34_;
	GckBuilder* _tmp35_;
#line 186 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 189 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = gck_builder_new (GCK_BUILDER_SECURE_MEMORY);
#line 189 "../pkcs11/pkcs11-generate.vala"
	publi = _tmp0_;
#line 190 "../pkcs11/pkcs11-generate.vala"
	_tmp1_ = gck_builder_new (GCK_BUILDER_SECURE_MEMORY);
#line 190 "../pkcs11/pkcs11-generate.vala"
	priva = _tmp1_;
#line 192 "../pkcs11/pkcs11-generate.vala"
	_tmp2_ = self->priv->cancellable;
#line 192 "../pkcs11/pkcs11-generate.vala"
	_vala_assert (_tmp2_ == NULL, "this.cancellable == null");
#line 193 "../pkcs11/pkcs11-generate.vala"
	_tmp3_ = self->priv->mechanism;
#line 193 "../pkcs11/pkcs11-generate.vala"
	_vala_assert (_tmp3_ != NULL, "this.mechanism != null");
#line 195 "../pkcs11/pkcs11-generate.vala"
	_tmp4_ = publi;
#line 195 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_ulong (_tmp4_, CKA_CLASS, CKO_PUBLIC_KEY);
#line 196 "../pkcs11/pkcs11-generate.vala"
	_tmp5_ = priva;
#line 196 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_ulong (_tmp5_, CKA_CLASS, CKO_PRIVATE_KEY);
#line 198 "../pkcs11/pkcs11-generate.vala"
	_tmp6_ = publi;
#line 198 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_boolean (_tmp6_, CKA_TOKEN, TRUE);
#line 199 "../pkcs11/pkcs11-generate.vala"
	_tmp7_ = priva;
#line 199 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_boolean (_tmp7_, CKA_TOKEN, TRUE);
#line 201 "../pkcs11/pkcs11-generate.vala"
	_tmp8_ = priva;
#line 201 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_boolean (_tmp8_, CKA_PRIVATE, TRUE);
#line 202 "../pkcs11/pkcs11-generate.vala"
	_tmp9_ = priva;
#line 202 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_boolean (_tmp9_, CKA_SENSITIVE, TRUE);
#line 204 "../pkcs11/pkcs11-generate.vala"
	_tmp10_ = self->priv->label_row;
#line 204 "../pkcs11/pkcs11-generate.vala"
	_tmp11_ = gtk_editable_get_text ((GtkEditable*) _tmp10_);
#line 204 "../pkcs11/pkcs11-generate.vala"
	_tmp12_ = _tmp11_;
#line 204 "../pkcs11/pkcs11-generate.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 204 "../pkcs11/pkcs11-generate.vala"
	label = _tmp13_;
#line 205 "../pkcs11/pkcs11-generate.vala"
	_tmp14_ = publi;
#line 205 "../pkcs11/pkcs11-generate.vala"
	_tmp15_ = label;
#line 205 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_string (_tmp14_, CKA_LABEL, _tmp15_);
#line 206 "../pkcs11/pkcs11-generate.vala"
	_tmp16_ = priva;
#line 206 "../pkcs11/pkcs11-generate.vala"
	_tmp17_ = label;
#line 206 "../pkcs11/pkcs11-generate.vala"
	gck_builder_add_string (_tmp16_, CKA_LABEL, _tmp17_);
#line 208 "../pkcs11/pkcs11-generate.vala"
	_tmp18_ = self->priv->mechanism;
#line 208 "../pkcs11/pkcs11-generate.vala"
	if ((*_tmp18_).type == CKM_RSA_PKCS_KEY_PAIR_GEN) {
#line 1151 "pkcs11-generate.c"
		GckBuilder* _tmp19_;
		GckBuilder* _tmp20_;
		GckBuilder* _tmp21_;
		GckBuilder* _tmp22_;
		GckBuilder* _tmp23_;
		GckBuilder* _tmp24_;
		GckBuilder* _tmp25_;
		GckBuilder* _tmp26_;
		AdwSpinRow* _tmp27_;
		gdouble _tmp28_;
		gdouble _tmp29_;
#line 209 "../pkcs11/pkcs11-generate.vala"
		_tmp19_ = publi;
#line 209 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_boolean (_tmp19_, CKA_ENCRYPT, TRUE);
#line 210 "../pkcs11/pkcs11-generate.vala"
		_tmp20_ = publi;
#line 210 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_boolean (_tmp20_, CKA_VERIFY, TRUE);
#line 211 "../pkcs11/pkcs11-generate.vala"
		_tmp21_ = publi;
#line 211 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_boolean (_tmp21_, CKA_WRAP, TRUE);
#line 213 "../pkcs11/pkcs11-generate.vala"
		_tmp22_ = priva;
#line 213 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_boolean (_tmp22_, CKA_DECRYPT, TRUE);
#line 214 "../pkcs11/pkcs11-generate.vala"
		_tmp23_ = priva;
#line 214 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_boolean (_tmp23_, CKA_SIGN, TRUE);
#line 215 "../pkcs11/pkcs11-generate.vala"
		_tmp24_ = priva;
#line 215 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_boolean (_tmp24_, CKA_UNWRAP, TRUE);
#line 217 "../pkcs11/pkcs11-generate.vala"
		_tmp25_ = publi;
#line 217 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_data (_tmp25_, CKA_PUBLIC_EXPONENT, rsa_public_exponent, (gsize) G_N_ELEMENTS (rsa_public_exponent));
#line 218 "../pkcs11/pkcs11-generate.vala"
		_tmp26_ = publi;
#line 218 "../pkcs11/pkcs11-generate.vala"
		_tmp27_ = self->priv->key_size_row;
#line 218 "../pkcs11/pkcs11-generate.vala"
		_tmp28_ = adw_spin_row_get_value (_tmp27_);
#line 218 "../pkcs11/pkcs11-generate.vala"
		_tmp29_ = _tmp28_;
#line 218 "../pkcs11/pkcs11-generate.vala"
		gck_builder_add_ulong (_tmp26_, CKA_MODULUS_BITS, (gulong) ((gint) _tmp29_));
#line 1201 "pkcs11-generate.c"
	} else {
#line 220 "../pkcs11/pkcs11-generate.vala"
		g_warning ("pkcs11-generate.vala:220: currently no support for this mechanism");
#line 1205 "pkcs11-generate.c"
	}
#line 223 "../pkcs11/pkcs11-generate.vala"
	_tmp30_ = priva;
#line 223 "../pkcs11/pkcs11-generate.vala"
	_tmp31_ = gck_builder_end (_tmp30_);
#line 223 "../pkcs11/pkcs11-generate.vala"
	_gck_attributes_unref0 (self->priv->prv_attrs);
#line 223 "../pkcs11/pkcs11-generate.vala"
	self->priv->prv_attrs = _tmp31_;
#line 224 "../pkcs11/pkcs11-generate.vala"
	_tmp32_ = publi;
#line 224 "../pkcs11/pkcs11-generate.vala"
	_tmp33_ = gck_builder_end (_tmp32_);
#line 224 "../pkcs11/pkcs11-generate.vala"
	_gck_attributes_unref0 (self->priv->pub_attrs);
#line 224 "../pkcs11/pkcs11-generate.vala"
	self->priv->pub_attrs = _tmp33_;
#line 226 "../pkcs11/pkcs11-generate.vala"
	_tmp34_ = publi;
#line 226 "../pkcs11/pkcs11-generate.vala"
	gck_builder_clear (_tmp34_);
#line 227 "../pkcs11/pkcs11-generate.vala"
	_tmp35_ = priva;
#line 227 "../pkcs11/pkcs11-generate.vala"
	gck_builder_clear (_tmp35_);
#line 186 "../pkcs11/pkcs11-generate.vala"
	_g_free0 (label);
#line 186 "../pkcs11/pkcs11-generate.vala"
	_gck_builder_unref0 (priva);
#line 186 "../pkcs11/pkcs11-generate.vala"
	_gck_builder_unref0 (publi);
#line 1237 "pkcs11-generate.c"
}

static inline gpointer
seahorse_pkcs11_generate_mechanism_list_item_get_instance_private (SeahorsePkcs11GenerateMechanismListItem* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorsePkcs11GenerateMechanismListItem_private_offset);
}

SeahorsePkcs11GenerateMechanismListItem*
seahorse_pkcs11_generate_mechanism_list_item_construct (GType object_type,
                                                        gulong type,
                                                        const gchar* label)
{
	SeahorsePkcs11GenerateMechanismListItem * self = NULL;
#line 52 "../pkcs11/pkcs11-generate.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 53 "../pkcs11/pkcs11-generate.vala"
	self = (SeahorsePkcs11GenerateMechanismListItem*) g_object_new (object_type, "mechanism-type", type, "label", label, NULL);
#line 52 "../pkcs11/pkcs11-generate.vala"
	return self;
#line 1258 "pkcs11-generate.c"
}

SeahorsePkcs11GenerateMechanismListItem*
seahorse_pkcs11_generate_mechanism_list_item_new (gulong type,
                                                  const gchar* label)
{
#line 52 "../pkcs11/pkcs11-generate.vala"
	return seahorse_pkcs11_generate_mechanism_list_item_construct (SEAHORSE_PKCS11_GENERATE_TYPE_MECHANISM_LIST_ITEM, type, label);
#line 1267 "pkcs11-generate.c"
}

gulong
seahorse_pkcs11_generate_mechanism_list_item_get_mechanism_type (SeahorsePkcs11GenerateMechanismListItem* self)
{
	gulong result;
#line 49 "../pkcs11/pkcs11-generate.vala"
	g_return_val_if_fail (self != NULL, 0UL);
#line 49 "../pkcs11/pkcs11-generate.vala"
	result = self->priv->_mechanism_type;
#line 49 "../pkcs11/pkcs11-generate.vala"
	return result;
#line 1280 "pkcs11-generate.c"
}

void
seahorse_pkcs11_generate_mechanism_list_item_set_mechanism_type (SeahorsePkcs11GenerateMechanismListItem* self,
                                                                 gulong value)
{
	gulong old_value;
#line 49 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 49 "../pkcs11/pkcs11-generate.vala"
	old_value = seahorse_pkcs11_generate_mechanism_list_item_get_mechanism_type (self);
#line 49 "../pkcs11/pkcs11-generate.vala"
	if (old_value != value) {
#line 49 "../pkcs11/pkcs11-generate.vala"
		self->priv->_mechanism_type = value;
#line 49 "../pkcs11/pkcs11-generate.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_generate_mechanism_list_item_properties[SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_MECHANISM_TYPE_PROPERTY]);
#line 1298 "pkcs11-generate.c"
	}
}

const gchar*
seahorse_pkcs11_generate_mechanism_list_item_get_label (SeahorsePkcs11GenerateMechanismListItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../pkcs11/pkcs11-generate.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = self->priv->_label;
#line 50 "../pkcs11/pkcs11-generate.vala"
	result = _tmp0_;
#line 50 "../pkcs11/pkcs11-generate.vala"
	return result;
#line 1315 "pkcs11-generate.c"
}

void
seahorse_pkcs11_generate_mechanism_list_item_set_label (SeahorsePkcs11GenerateMechanismListItem* self,
                                                        const gchar* value)
{
	gchar* old_value;
#line 50 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (self != NULL);
#line 50 "../pkcs11/pkcs11-generate.vala"
	old_value = seahorse_pkcs11_generate_mechanism_list_item_get_label (self);
#line 50 "../pkcs11/pkcs11-generate.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1329 "pkcs11-generate.c"
		gchar* _tmp0_;
#line 50 "../pkcs11/pkcs11-generate.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../pkcs11/pkcs11-generate.vala"
		_g_free0 (self->priv->_label);
#line 50 "../pkcs11/pkcs11-generate.vala"
		self->priv->_label = _tmp0_;
#line 50 "../pkcs11/pkcs11-generate.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_pkcs11_generate_mechanism_list_item_properties[SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_LABEL_PROPERTY]);
#line 1339 "pkcs11-generate.c"
	}
}

static void
seahorse_pkcs11_generate_mechanism_list_item_class_init (SeahorsePkcs11GenerateMechanismListItemClass * klass,
                                                         gpointer klass_data)
{
#line 48 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_mechanism_list_item_parent_class = g_type_class_peek_parent (klass);
#line 48 "../pkcs11/pkcs11-generate.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePkcs11GenerateMechanismListItem_private_offset);
#line 48 "../pkcs11/pkcs11-generate.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_pkcs11_generate_mechanism_list_item_get_property;
#line 48 "../pkcs11/pkcs11-generate.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_pkcs11_generate_mechanism_list_item_set_property;
#line 48 "../pkcs11/pkcs11-generate.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_pkcs11_generate_mechanism_list_item_finalize;
#line 48 "../pkcs11/pkcs11-generate.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_MECHANISM_TYPE_PROPERTY, seahorse_pkcs11_generate_mechanism_list_item_properties[SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_MECHANISM_TYPE_PROPERTY] = g_param_spec_ulong ("mechanism-type", "mechanism-type", "mechanism-type", 0, G_MAXULONG, 0UL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 48 "../pkcs11/pkcs11-generate.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_LABEL_PROPERTY, seahorse_pkcs11_generate_mechanism_list_item_properties[SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1361 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_mechanism_list_item_instance_init (SeahorsePkcs11GenerateMechanismListItem * self,
                                                            gpointer klass)
{
#line 48 "../pkcs11/pkcs11-generate.vala"
	self->priv = seahorse_pkcs11_generate_mechanism_list_item_get_instance_private (self);
#line 1370 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_mechanism_list_item_finalize (GObject * obj)
{
	SeahorsePkcs11GenerateMechanismListItem * self;
#line 48 "../pkcs11/pkcs11-generate.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_GENERATE_TYPE_MECHANISM_LIST_ITEM, SeahorsePkcs11GenerateMechanismListItem);
#line 50 "../pkcs11/pkcs11-generate.vala"
	_g_free0 (self->priv->_label);
#line 48 "../pkcs11/pkcs11-generate.vala"
	G_OBJECT_CLASS (seahorse_pkcs11_generate_mechanism_list_item_parent_class)->finalize (obj);
#line 1383 "pkcs11-generate.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_pkcs11_generate_mechanism_list_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePkcs11GenerateMechanismListItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_pkcs11_generate_mechanism_list_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePkcs11GenerateMechanismListItem), 0, (GInstanceInitFunc) seahorse_pkcs11_generate_mechanism_list_item_instance_init, NULL };
	GType seahorse_pkcs11_generate_mechanism_list_item_type_id;
	seahorse_pkcs11_generate_mechanism_list_item_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorsePkcs11GenerateMechanismListItem", &g_define_type_info, 0);
	SeahorsePkcs11GenerateMechanismListItem_private_offset = g_type_add_instance_private (seahorse_pkcs11_generate_mechanism_list_item_type_id, sizeof (SeahorsePkcs11GenerateMechanismListItemPrivate));
	return seahorse_pkcs11_generate_mechanism_list_item_type_id;
}

GType
seahorse_pkcs11_generate_mechanism_list_item_get_type (void)
{
	static gsize seahorse_pkcs11_generate_mechanism_list_item_type_id__once = 0;
	if (g_once_init_enter (&seahorse_pkcs11_generate_mechanism_list_item_type_id__once)) {
		GType seahorse_pkcs11_generate_mechanism_list_item_type_id;
		seahorse_pkcs11_generate_mechanism_list_item_type_id = seahorse_pkcs11_generate_mechanism_list_item_get_type_once ();
		g_once_init_leave (&seahorse_pkcs11_generate_mechanism_list_item_type_id__once, seahorse_pkcs11_generate_mechanism_list_item_type_id);
	}
	return seahorse_pkcs11_generate_mechanism_list_item_type_id__once;
}

static void
_vala_seahorse_pkcs11_generate_mechanism_list_item_get_property (GObject * object,
                                                                 guint property_id,
                                                                 GValue * value,
                                                                 GParamSpec * pspec)
{
	SeahorsePkcs11GenerateMechanismListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_GENERATE_TYPE_MECHANISM_LIST_ITEM, SeahorsePkcs11GenerateMechanismListItem);
#line 48 "../pkcs11/pkcs11-generate.vala"
	switch (property_id) {
#line 48 "../pkcs11/pkcs11-generate.vala"
		case SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_MECHANISM_TYPE_PROPERTY:
#line 48 "../pkcs11/pkcs11-generate.vala"
		g_value_set_ulong (value, seahorse_pkcs11_generate_mechanism_list_item_get_mechanism_type (self));
#line 48 "../pkcs11/pkcs11-generate.vala"
		break;
#line 48 "../pkcs11/pkcs11-generate.vala"
		case SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_LABEL_PROPERTY:
#line 48 "../pkcs11/pkcs11-generate.vala"
		g_value_set_string (value, seahorse_pkcs11_generate_mechanism_list_item_get_label (self));
#line 48 "../pkcs11/pkcs11-generate.vala"
		break;
#line 1430 "pkcs11-generate.c"
		default:
#line 48 "../pkcs11/pkcs11-generate.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 48 "../pkcs11/pkcs11-generate.vala"
		break;
#line 1436 "pkcs11-generate.c"
	}
}

static void
_vala_seahorse_pkcs11_generate_mechanism_list_item_set_property (GObject * object,
                                                                 guint property_id,
                                                                 const GValue * value,
                                                                 GParamSpec * pspec)
{
	SeahorsePkcs11GenerateMechanismListItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_PKCS11_GENERATE_TYPE_MECHANISM_LIST_ITEM, SeahorsePkcs11GenerateMechanismListItem);
#line 48 "../pkcs11/pkcs11-generate.vala"
	switch (property_id) {
#line 48 "../pkcs11/pkcs11-generate.vala"
		case SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_MECHANISM_TYPE_PROPERTY:
#line 48 "../pkcs11/pkcs11-generate.vala"
		seahorse_pkcs11_generate_mechanism_list_item_set_mechanism_type (self, g_value_get_ulong (value));
#line 48 "../pkcs11/pkcs11-generate.vala"
		break;
#line 48 "../pkcs11/pkcs11-generate.vala"
		case SEAHORSE_PKCS11_GENERATE_MECHANISM_LIST_ITEM_LABEL_PROPERTY:
#line 48 "../pkcs11/pkcs11-generate.vala"
		seahorse_pkcs11_generate_mechanism_list_item_set_label (self, g_value_get_string (value));
#line 48 "../pkcs11/pkcs11-generate.vala"
		break;
#line 1462 "pkcs11-generate.c"
		default:
#line 48 "../pkcs11/pkcs11-generate.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 48 "../pkcs11/pkcs11-generate.vala"
		break;
#line 1468 "pkcs11-generate.c"
	}
}

static void
seahorse_pkcs11_generate_mechanism_entry_copy (const SeahorsePkcs11GenerateMechanismEntry* self,
                                               SeahorsePkcs11GenerateMechanismEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 39 "../pkcs11/pkcs11-generate.vala"
	(*dest).mechanism_type = (*self).mechanism_type;
#line 39 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = (*self).label;
#line 39 "../pkcs11/pkcs11-generate.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 39 "../pkcs11/pkcs11-generate.vala"
	_g_free0 ((*dest).label);
#line 39 "../pkcs11/pkcs11-generate.vala"
	(*dest).label = _tmp1_;
#line 1488 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_mechanism_entry_destroy (SeahorsePkcs11GenerateMechanismEntry* self)
{
#line 41 "../pkcs11/pkcs11-generate.vala"
	_g_free0 ((*self).label);
#line 1496 "pkcs11-generate.c"
}

static SeahorsePkcs11GenerateMechanismEntry*
seahorse_pkcs11_generate_mechanism_entry_dup (const SeahorsePkcs11GenerateMechanismEntry* self)
{
	SeahorsePkcs11GenerateMechanismEntry* dup;
#line 39 "../pkcs11/pkcs11-generate.vala"
	dup = g_new0 (SeahorsePkcs11GenerateMechanismEntry, 1);
#line 39 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_mechanism_entry_copy (self, dup);
#line 39 "../pkcs11/pkcs11-generate.vala"
	return dup;
#line 1509 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_mechanism_entry_free (SeahorsePkcs11GenerateMechanismEntry* self)
{
#line 39 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_mechanism_entry_destroy (self);
#line 39 "../pkcs11/pkcs11-generate.vala"
	g_free (self);
#line 1519 "pkcs11-generate.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_pkcs11_generate_mechanism_entry_get_type_once (void)
{
	GType seahorse_pkcs11_generate_mechanism_entry_type_id;
	seahorse_pkcs11_generate_mechanism_entry_type_id = g_boxed_type_register_static ("SeahorsePkcs11GenerateMechanismEntry", (GBoxedCopyFunc) seahorse_pkcs11_generate_mechanism_entry_dup, (GBoxedFreeFunc) seahorse_pkcs11_generate_mechanism_entry_free);
	return seahorse_pkcs11_generate_mechanism_entry_type_id;
}

static GType
seahorse_pkcs11_generate_mechanism_entry_get_type (void)
{
	static gsize seahorse_pkcs11_generate_mechanism_entry_type_id__once = 0;
	if (g_once_init_enter (&seahorse_pkcs11_generate_mechanism_entry_type_id__once)) {
		GType seahorse_pkcs11_generate_mechanism_entry_type_id;
		seahorse_pkcs11_generate_mechanism_entry_type_id = seahorse_pkcs11_generate_mechanism_entry_get_type_once ();
		g_once_init_leave (&seahorse_pkcs11_generate_mechanism_entry_type_id__once, seahorse_pkcs11_generate_mechanism_entry_type_id);
	}
	return seahorse_pkcs11_generate_mechanism_entry_type_id__once;
}

static void
_seahorse_pkcs11_generate___lambda12_ (SeahorsePkcs11Generate* self,
                                       GListModel* model,
                                       guint pos,
                                       guint removed,
                                       guint added)
{
	AdwComboRow* _tmp0_;
#line 74 "../pkcs11/pkcs11-generate.vala"
	g_return_if_fail (model != NULL);
#line 75 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = self->priv->token_row;
#line 75 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, g_list_model_get_n_items (model) > ((guint) 0));
#line 1556 "pkcs11-generate.c"
}

static void
__seahorse_pkcs11_generate___lambda12__g_list_model_items_changed (GListModel* _sender,
                                                                   guint position,
                                                                   guint removed,
                                                                   guint added,
                                                                   gpointer self)
{
#line 74 "../pkcs11/pkcs11-generate.vala"
	_seahorse_pkcs11_generate___lambda12_ ((SeahorsePkcs11Generate*) self, _sender, position, removed, added);
#line 1568 "pkcs11-generate.c"
}

static void
_seahorse_pkcs11_generate_on_selected_token_changed_g_object_notify (GObject* _sender,
                                                                     GParamSpec* pspec,
                                                                     gpointer self)
{
#line 79 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_on_selected_token_changed ((SeahorsePkcs11Generate*) self, _sender, pspec);
#line 1578 "pkcs11-generate.c"
}

static GObject *
seahorse_pkcs11_generate_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorsePkcs11Generate * self;
	SeahorsePkcs11Backend* backend = NULL;
	SeahorsePkcs11Backend* _tmp0_;
	SeahorsePkcs11Backend* _tmp1_;
	SeahorsePkcs11TokenFilter* filter = NULL;
	SeahorsePkcs11TokenFilter* _tmp2_;
	SeahorsePkcs11TokenFilter* _tmp3_;
	SeahorsePkcs11TokenFilter* _tmp4_;
	GtkFilterListModel* writable_tokens_model = NULL;
	SeahorsePkcs11Backend* _tmp5_;
	GListModel* _tmp6_;
	SeahorsePkcs11TokenFilter* _tmp7_;
	GtkFilter* _tmp8_;
	GtkFilterListModel* _tmp9_;
	AdwComboRow* _tmp10_;
	GtkFilterListModel* _tmp11_;
	AdwComboRow* _tmp12_;
	GtkFilterListModel* _tmp13_;
	GtkFilterListModel* _tmp14_;
	AdwComboRow* _tmp15_;
	AdwComboRow* _tmp16_;
#line 63 "../pkcs11/pkcs11-generate.vala"
	parent_class = G_OBJECT_CLASS (seahorse_pkcs11_generate_parent_class);
#line 63 "../pkcs11/pkcs11-generate.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 63 "../pkcs11/pkcs11-generate.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_GENERATE, SeahorsePkcs11Generate);
#line 65 "../pkcs11/pkcs11-generate.vala"
	_tmp0_ = seahorse_pkcs11_backend_get ();
#line 65 "../pkcs11/pkcs11-generate.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 65 "../pkcs11/pkcs11-generate.vala"
	backend = _tmp1_;
#line 66 "../pkcs11/pkcs11-generate.vala"
	_tmp2_ = seahorse_pkcs11_token_filter_new ();
#line 66 "../pkcs11/pkcs11-generate.vala"
	filter = _tmp2_;
#line 67 "../pkcs11/pkcs11-generate.vala"
	_tmp3_ = filter;
#line 67 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_token_filter_set_only_writable (_tmp3_, TRUE);
#line 68 "../pkcs11/pkcs11-generate.vala"
	_tmp4_ = filter;
#line 68 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_token_filter_set_mechanism (_tmp4_, CKM_RSA_PKCS_KEY_PAIR_GEN);
#line 69 "../pkcs11/pkcs11-generate.vala"
	_tmp5_ = backend;
#line 69 "../pkcs11/pkcs11-generate.vala"
	_tmp6_ = _g_object_ref0 ((GListModel*) _tmp5_);
#line 69 "../pkcs11/pkcs11-generate.vala"
	_tmp7_ = filter;
#line 69 "../pkcs11/pkcs11-generate.vala"
	_tmp8_ = _g_object_ref0 ((GtkFilter*) _tmp7_);
#line 69 "../pkcs11/pkcs11-generate.vala"
	_tmp9_ = gtk_filter_list_model_new (_tmp6_, _tmp8_);
#line 69 "../pkcs11/pkcs11-generate.vala"
	writable_tokens_model = _tmp9_;
#line 70 "../pkcs11/pkcs11-generate.vala"
	_tmp10_ = self->priv->token_row;
#line 70 "../pkcs11/pkcs11-generate.vala"
	_tmp11_ = writable_tokens_model;
#line 70 "../pkcs11/pkcs11-generate.vala"
	adw_combo_row_set_model (_tmp10_, (GListModel*) _tmp11_);
#line 73 "../pkcs11/pkcs11-generate.vala"
	_tmp12_ = self->priv->token_row;
#line 73 "../pkcs11/pkcs11-generate.vala"
	_tmp13_ = writable_tokens_model;
#line 73 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp12_, g_list_model_get_n_items ((GListModel*) _tmp13_) > ((guint) 0));
#line 74 "../pkcs11/pkcs11-generate.vala"
	_tmp14_ = writable_tokens_model;
#line 74 "../pkcs11/pkcs11-generate.vala"
	g_signal_connect_object ((GListModel*) _tmp14_, "items-changed", (GCallback) __seahorse_pkcs11_generate___lambda12__g_list_model_items_changed, self, 0);
#line 79 "../pkcs11/pkcs11-generate.vala"
	_tmp15_ = self->priv->token_row;
#line 79 "../pkcs11/pkcs11-generate.vala"
	g_signal_connect_object ((GObject*) _tmp15_, "notify::selected-item", (GCallback) _seahorse_pkcs11_generate_on_selected_token_changed_g_object_notify, self, 0);
#line 80 "../pkcs11/pkcs11-generate.vala"
	_tmp16_ = self->priv->token_row;
#line 80 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_on_selected_token_changed (self, (GObject*) _tmp16_, NULL);
#line 82 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_validate_input (self);
#line 63 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (writable_tokens_model);
#line 63 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (filter);
#line 63 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (backend);
#line 63 "../pkcs11/pkcs11-generate.vala"
	return obj;
#line 1679 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_class_init (SeahorsePkcs11GenerateClass * klass,
                                     gpointer klass_data)
{
#line 23 "../pkcs11/pkcs11-generate.vala"
	seahorse_pkcs11_generate_parent_class = g_type_class_peek_parent (klass);
#line 23 "../pkcs11/pkcs11-generate.vala"
	g_type_class_adjust_private_offset (klass, &SeahorsePkcs11Generate_private_offset);
#line 23 "../pkcs11/pkcs11-generate.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_pkcs11_generate_constructor;
#line 23 "../pkcs11/pkcs11-generate.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_pkcs11_generate_finalize;
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/pkcs11-generate.ui");
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "label_row", FALSE, SeahorsePkcs11Generate_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11GeneratePrivate, label_row));
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "token_row", FALSE, SeahorsePkcs11Generate_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11GeneratePrivate, token_row));
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mechanism_row", FALSE, SeahorsePkcs11Generate_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11GeneratePrivate, mechanism_row));
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "mechanism_items", FALSE, SeahorsePkcs11Generate_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11GeneratePrivate, mechanism_items));
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "key_size_row", FALSE, SeahorsePkcs11Generate_private_offset + G_STRUCT_OFFSET (SeahorsePkcs11GeneratePrivate, key_size_row));
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_mechanism_selected", G_CALLBACK(_seahorse_pkcs11_generate_on_mechanism_selected_g_object_notify));
#line 58 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_class_install_action (GTK_WIDGET_CLASS (klass), "create", NULL, (GtkWidgetActionActivateFunc) seahorse_pkcs11_generate_create_action);
#line 60 "../pkcs11/pkcs11-generate.vala"
	g_type_ensure (SEAHORSE_PKCS11_GENERATE_TYPE_MECHANISM_LIST_ITEM);
#line 1712 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_instance_init (SeahorsePkcs11Generate * self,
                                        gpointer klass)
{
#line 23 "../pkcs11/pkcs11-generate.vala"
	self->priv = seahorse_pkcs11_generate_get_instance_private (self);
#line 23 "../pkcs11/pkcs11-generate.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1723 "pkcs11-generate.c"
}

static void
seahorse_pkcs11_generate_finalize (GObject * obj)
{
	SeahorsePkcs11Generate * self;
#line 23 "../pkcs11/pkcs11-generate.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_PKCS11_TYPE_GENERATE, SeahorsePkcs11Generate);
#line 28 "../pkcs11/pkcs11-generate.vala"
	_g_free0 (self->priv->mechanism);
#line 34 "../pkcs11/pkcs11-generate.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 35 "../pkcs11/pkcs11-generate.vala"
	_gck_attributes_unref0 (self->priv->pub_attrs);
#line 36 "../pkcs11/pkcs11-generate.vala"
	_gck_attributes_unref0 (self->priv->prv_attrs);
#line 23 "../pkcs11/pkcs11-generate.vala"
	G_OBJECT_CLASS (seahorse_pkcs11_generate_parent_class)->finalize (obj);
#line 1742 "pkcs11-generate.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_pkcs11_generate_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorsePkcs11GenerateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_pkcs11_generate_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorsePkcs11Generate), 0, (GInstanceInitFunc) seahorse_pkcs11_generate_instance_init, NULL };
	GType seahorse_pkcs11_generate_type_id;
	seahorse_pkcs11_generate_type_id = g_type_register_static (gtk_application_window_get_type (), "SeahorsePkcs11Generate", &g_define_type_info, 0);
	SeahorsePkcs11Generate_private_offset = g_type_add_instance_private (seahorse_pkcs11_generate_type_id, sizeof (SeahorsePkcs11GeneratePrivate));
	return seahorse_pkcs11_generate_type_id;
}

GType
seahorse_pkcs11_generate_get_type (void)
{
	static gsize seahorse_pkcs11_generate_type_id__once = 0;
	if (g_once_init_enter (&seahorse_pkcs11_generate_type_id__once)) {
		GType seahorse_pkcs11_generate_type_id;
		seahorse_pkcs11_generate_type_id = seahorse_pkcs11_generate_get_type_once ();
		g_once_init_leave (&seahorse_pkcs11_generate_type_id__once, seahorse_pkcs11_generate_type_id);
	}
	return seahorse_pkcs11_generate_type_id__once;
}

