/* application.c generated by valac 0.56.18, the Vala compiler
 * generated from application.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2003 Jacob Perkins
 * Copyright (C) 2005, 2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (C) 2012 Stefan Walter
 * Copyright (C) 2018 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include "seahorse-common.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "config.h"
#include <gtk/gtk.h>
#include "seahorse-gkr.h"
#include "seahorse-ssh.h"
#include "pgp/seahorse-pgp-backend.h"
#include "pkcs11/seahorse-pkcs11-backend.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SEAHORSE_TYPE_APPLICATION (seahorse_application_get_type ())
#define SEAHORSE_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_APPLICATION, SeahorseApplication))
#define SEAHORSE_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_APPLICATION, SeahorseApplicationClass))
#define SEAHORSE_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_APPLICATION))
#define SEAHORSE_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_APPLICATION))
#define SEAHORSE_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_APPLICATION, SeahorseApplicationClass))

typedef struct _SeahorseApplication SeahorseApplication;
typedef struct _SeahorseApplicationClass SeahorseApplicationClass;
typedef struct _SeahorseApplicationPrivate SeahorseApplicationPrivate;

#define SEAHORSE_TYPE_SEARCH_PROVIDER (seahorse_search_provider_get_type ())
#define SEAHORSE_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProvider))
#define SEAHORSE_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProviderClass))
#define SEAHORSE_IS_SEARCH_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER))
#define SEAHORSE_IS_SEARCH_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_SEARCH_PROVIDER))
#define SEAHORSE_SEARCH_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_SEARCH_PROVIDER, SeahorseSearchProviderClass))

typedef struct _SeahorseSearchProvider SeahorseSearchProvider;
typedef struct _SeahorseSearchProviderClass SeahorseSearchProviderClass;

#define SEAHORSE_TYPE_KEY_MANAGER (seahorse_key_manager_get_type ())
#define SEAHORSE_KEY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManager))
#define SEAHORSE_KEY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManagerClass))
#define SEAHORSE_IS_KEY_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_KEY_MANAGER))
#define SEAHORSE_IS_KEY_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_KEY_MANAGER))
#define SEAHORSE_KEY_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_KEY_MANAGER, SeahorseKeyManagerClass))

typedef struct _SeahorseKeyManager SeahorseKeyManager;
typedef struct _SeahorseKeyManagerClass SeahorseKeyManagerClass;
enum  {
	SEAHORSE_APPLICATION_0_PROPERTY,
	SEAHORSE_APPLICATION_NUM_PROPERTIES
};
static GParamSpec* seahorse_application_properties[SEAHORSE_APPLICATION_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define SEAHORSE_TYPE_PREFS_DIALOG (seahorse_prefs_dialog_get_type ())
#define SEAHORSE_PREFS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_PREFS_DIALOG, SeahorsePrefsDialog))
#define SEAHORSE_PREFS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_PREFS_DIALOG, SeahorsePrefsDialogClass))
#define SEAHORSE_IS_PREFS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_PREFS_DIALOG))
#define SEAHORSE_IS_PREFS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_PREFS_DIALOG))
#define SEAHORSE_PREFS_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_PREFS_DIALOG, SeahorsePrefsDialogClass))

typedef struct _SeahorsePrefsDialog SeahorsePrefsDialog;
typedef struct _SeahorsePrefsDialogClass SeahorsePrefsDialogClass;

struct _SeahorseApplication {
	AdwApplication parent_instance;
	SeahorseApplicationPrivate * priv;
};

struct _SeahorseApplicationClass {
	AdwApplicationClass parent_class;
};

struct _SeahorseApplicationPrivate {
	SeahorseSearchProvider* search_provider;
	guint search_provider_dbus_id;
	SeahorseKeyManager* key_mgr;
};

struct _Block1Data {
	int _ref_count_;
	SeahorseApplication* self;
	GtkUriLauncher* help_launcher;
};

static gint SeahorseApplication_private_offset;
static gpointer seahorse_application_parent_class = NULL;

VALA_EXTERN GType seahorse_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseApplication, g_object_unref)
VALA_EXTERN GType seahorse_search_provider_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseSearchProvider, g_object_unref)
VALA_EXTERN guint seahorse_search_provider_register_object (void* object,
                                                GDBusConnection* connection,
                                                const gchar* path,
                                                GError** error);
VALA_EXTERN GType seahorse_key_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseKeyManager, g_object_unref)
static void _g_application_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self);
static void seahorse_application_on_app_help (SeahorseApplication* self,
                                       GSimpleAction* action,
                                       GVariant* param);
static void _seahorse_application_on_app_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void seahorse_application_on_app_about (SeahorseApplication* self,
                                        GSimpleAction* action,
                                        GVariant* param);
static void _seahorse_application_on_app_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void seahorse_application_on_app_preferences (SeahorseApplication* self,
                                              GSimpleAction* action,
                                              GVariant* param);
static void _seahorse_application_on_app_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
VALA_EXTERN SeahorseApplication* seahorse_application_new (void);
VALA_EXTERN SeahorseApplication* seahorse_application_construct (GType object_type);
VALA_EXTERN SeahorseSearchProvider* seahorse_search_provider_new (GApplication* app);
VALA_EXTERN SeahorseSearchProvider* seahorse_search_provider_construct (GType object_type,
                                                            GApplication* app);
VALA_EXTERN gboolean seahorse_prefs_dialog_available (void);
static void seahorse_application_add_action_accelerators (SeahorseApplication* self);
static void seahorse_application_real_startup (GApplication* base);
static void seahorse_application_real_activate (GApplication* base);
VALA_EXTERN SeahorseKeyManager* seahorse_key_manager_new (SeahorseApplication* app);
VALA_EXTERN SeahorseKeyManager* seahorse_key_manager_construct (GType object_type,
                                                    SeahorseApplication* app);
static void seahorse_application_real_open (GApplication* base,
                                     GFile** files,
                                     gint files_length1,
                                     const gchar* hint);
VALA_EXTERN void seahorse_key_manager_import_file (SeahorseKeyManager* self,
                                       GFile* file,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
VALA_EXTERN void seahorse_key_manager_import_file_finish (SeahorseKeyManager* self,
                                              GAsyncResult* _res_);
static gint seahorse_application_real_handle_local_options (GApplication* base,
                                                     GVariantDict* options);
static gboolean seahorse_application_real_dbus_register (GApplication* base,
                                                  GDBusConnection* connection,
                                                  const gchar* object_path,
                                                  GError** error);
static void seahorse_application_real_dbus_unregister (GApplication* base,
                                                GDBusConnection* connection,
                                                const gchar* object_path);
VALA_EXTERN void seahorse_application_initialize_search (SeahorseApplication* self);
VALA_EXTERN void seahorse_search_provider_load (SeahorseSearchProvider* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
VALA_EXTERN void seahorse_search_provider_load_finish (SeahorseSearchProvider* self,
                                           GAsyncResult* _res_,
                                           GError** error);
static gchar** _vala_array_dup1 (gchar** self,
                          gssize length);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda19_ (Block1Data* _data1_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda19__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
VALA_EXTERN GType seahorse_prefs_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorsePrefsDialog, g_object_unref)
VALA_EXTERN SeahorsePrefsDialog* seahorse_prefs_dialog_new (void);
VALA_EXTERN SeahorsePrefsDialog* seahorse_prefs_dialog_construct (GType object_type);
static void seahorse_application_finalize (GObject * obj);
static GType seahorse_application_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const gchar* SEAHORSE_APPLICATION_DEVELOPERS[9] = {"Niels De Graef <nielsdegraef@gmail.com>", "Jacob Perkins <jap1@users.sourceforge.net>", "Jose Carlos Garcia Sogo <jsogo@users.sourceforge.net>", "Jean Schurger <yshark@schurger.org>", "Stef Walter <stef@memberwebs.com>", "Adam Schreiber <sadam@clemson.edu>", "Albrecht Dreß <albrecht.dress@arcor.de>", "Jim Pharis <binbrain@gmail.com>", NULL};
static const gchar* SEAHORSE_APPLICATION_DESIGNERS[3] = {"Jacob Perkins <jap1@users.sourceforge.net>", "Stef Walter <stef@memberwebs.com>", NULL};
static const GActionEntry SEAHORSE_APPLICATION_action_entries[4] = {{"quit", _g_application_quit_gsimple_action_activate_callback}, {"help", _seahorse_application_on_app_help_gsimple_action_activate_callback}, {"about", _seahorse_application_on_app_about_gsimple_action_activate_callback}, {"preferences", _seahorse_application_on_app_preferences_gsimple_action_activate_callback}};
static const GOptionEntry SEAHORSE_APPLICATION_cmd_options[2] = {{"version", 'v', (gint) 0, G_OPTION_ARG_NONE, NULL, N_ ("Version of this application"), NULL}, {NULL}};

static inline gpointer
seahorse_application_get_instance_private (SeahorseApplication* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseApplication_private_offset);
}

static void
_g_application_quit_gsimple_action_activate_callback (GSimpleAction* action,
                                                      GVariant* parameter,
                                                      gpointer self)
{
#line 49 "../src/application.vala"
	g_application_quit ((GApplication*) self);
#line 248 "application.c"
}

static void
_seahorse_application_on_app_help_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 49 "../src/application.vala"
	seahorse_application_on_app_help ((SeahorseApplication*) self, action, parameter);
#line 258 "application.c"
}

static void
_seahorse_application_on_app_about_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 49 "../src/application.vala"
	seahorse_application_on_app_about ((SeahorseApplication*) self, action, parameter);
#line 268 "application.c"
}

static void
_seahorse_application_on_app_preferences_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 49 "../src/application.vala"
	seahorse_application_on_app_preferences ((SeahorseApplication*) self, action, parameter);
#line 278 "application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 70 "../src/application.vala"
	return self ? g_object_ref (self) : NULL;
#line 286 "application.c"
}

SeahorseApplication*
seahorse_application_construct (GType object_type)
{
	SeahorseApplication * self = NULL;
	SeahorseSearchProvider* _tmp0_;
	GSimpleAction* pref_action = NULL;
	GAction* _tmp1_;
	GSimpleAction* _tmp2_;
#line 62 "../src/application.vala"
	self = (SeahorseApplication*) g_object_new (object_type, "application-id", APPLICATION_ID, "resource-base-path", "/org/gnome/Seahorse", "flags", G_APPLICATION_HANDLES_OPEN, NULL);
#line 67 "../src/application.vala"
	_tmp0_ = seahorse_search_provider_new ((GApplication*) self);
#line 67 "../src/application.vala"
	_g_object_unref0 (self->priv->search_provider);
#line 67 "../src/application.vala"
	self->priv->search_provider = _tmp0_;
#line 69 "../src/application.vala"
	g_action_map_add_action_entries ((GActionMap*) self, SEAHORSE_APPLICATION_action_entries, (gint) G_N_ELEMENTS (SEAHORSE_APPLICATION_action_entries), self);
#line 70 "../src/application.vala"
	_tmp1_ = g_action_map_lookup_action ((GActionMap*) self, "preferences");
#line 70 "../src/application.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp1_) : NULL);
#line 70 "../src/application.vala"
	pref_action = _tmp2_;
#line 71 "../src/application.vala"
	g_simple_action_set_enabled (pref_action, seahorse_prefs_dialog_available ());
#line 72 "../src/application.vala"
	seahorse_application_add_action_accelerators (self);
#line 74 "../src/application.vala"
	g_application_add_main_option_entries ((GApplication*) self, SEAHORSE_APPLICATION_cmd_options);
#line 61 "../src/application.vala"
	_g_object_unref0 (pref_action);
#line 61 "../src/application.vala"
	return self;
#line 323 "application.c"
}

SeahorseApplication*
seahorse_application_new (void)
{
#line 61 "../src/application.vala"
	return seahorse_application_construct (SEAHORSE_TYPE_APPLICATION);
#line 331 "application.c"
}

static void
seahorse_application_add_action_accelerators (SeahorseApplication* self)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _tmp20__length1;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
#line 77 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/application.vala"
	_tmp0_ = g_strdup ("F1");
#line 78 "../src/application.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 78 "../src/application.vala"
	_tmp1_[0] = _tmp0_;
#line 78 "../src/application.vala"
	_tmp2_ = _tmp1_;
#line 78 "../src/application.vala"
	_tmp2__length1 = 1;
#line 78 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.help", _tmp2_);
#line 78 "../src/application.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/application.vala"
	_tmp3_ = g_strdup ("<control>comma");
#line 79 "../src/application.vala"
	_tmp4_ = g_new0 (gchar*, 1 + 1);
#line 79 "../src/application.vala"
	_tmp4_[0] = _tmp3_;
#line 79 "../src/application.vala"
	_tmp5_ = _tmp4_;
#line 79 "../src/application.vala"
	_tmp5__length1 = 1;
#line 79 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.preferences", _tmp5_);
#line 79 "../src/application.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_free), NULL);
#line 80 "../src/application.vala"
	_tmp6_ = g_strdup ("<control>q");
#line 80 "../src/application.vala"
	_tmp7_ = g_new0 (gchar*, 1 + 1);
#line 80 "../src/application.vala"
	_tmp7_[0] = _tmp6_;
#line 80 "../src/application.vala"
	_tmp8_ = _tmp7_;
#line 80 "../src/application.vala"
	_tmp8__length1 = 1;
#line 80 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "app.quit", _tmp8_);
#line 80 "../src/application.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 82 "../src/application.vala"
	_tmp9_ = g_strdup ("<control>f");
#line 82 "../src/application.vala"
	_tmp10_ = g_new0 (gchar*, 1 + 1);
#line 82 "../src/application.vala"
	_tmp10_[0] = _tmp9_;
#line 82 "../src/application.vala"
	_tmp11_ = _tmp10_;
#line 82 "../src/application.vala"
	_tmp11__length1 = 1;
#line 82 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.show-search", _tmp11_);
#line 82 "../src/application.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/application.vala"
	_tmp12_ = g_strdup ("<control>n");
#line 83 "../src/application.vala"
	_tmp13_ = g_new0 (gchar*, 1 + 1);
#line 83 "../src/application.vala"
	_tmp13_[0] = _tmp12_;
#line 83 "../src/application.vala"
	_tmp14_ = _tmp13_;
#line 83 "../src/application.vala"
	_tmp14__length1 = 1;
#line 83 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.new-item", _tmp14_);
#line 83 "../src/application.vala"
	_tmp14_ = (_vala_array_free (_tmp14_, _tmp14__length1, (GDestroyNotify) g_free), NULL);
#line 84 "../src/application.vala"
	_tmp15_ = g_strdup ("<control>i");
#line 84 "../src/application.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 84 "../src/application.vala"
	_tmp16_[0] = _tmp15_;
#line 84 "../src/application.vala"
	_tmp17_ = _tmp16_;
#line 84 "../src/application.vala"
	_tmp17__length1 = 1;
#line 84 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.import-file", _tmp17_);
#line 84 "../src/application.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/application.vala"
	_tmp18_ = g_strdup ("<control>c");
#line 85 "../src/application.vala"
	_tmp19_ = g_new0 (gchar*, 1 + 1);
#line 85 "../src/application.vala"
	_tmp19_[0] = _tmp18_;
#line 85 "../src/application.vala"
	_tmp20_ = _tmp19_;
#line 85 "../src/application.vala"
	_tmp20__length1 = 1;
#line 85 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.copy", _tmp20_);
#line 85 "../src/application.vala"
	_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 86 "../src/application.vala"
	_tmp21_ = g_strdup ("<control>v");
#line 86 "../src/application.vala"
	_tmp22_ = g_new0 (gchar*, 1 + 1);
#line 86 "../src/application.vala"
	_tmp22_[0] = _tmp21_;
#line 86 "../src/application.vala"
	_tmp23_ = _tmp22_;
#line 86 "../src/application.vala"
	_tmp23__length1 = 1;
#line 86 "../src/application.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) self, "win.paste", _tmp23_);
#line 86 "../src/application.vala"
	_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 483 "application.c"
}

static void
seahorse_application_real_startup (GApplication* base)
{
	SeahorseApplication * self;
#line 89 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 90 "../src/application.vala"
	G_APPLICATION_CLASS (seahorse_application_parent_class)->startup ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_get_type (), AdwApplication));
#line 92 "../src/application.vala"
	g_set_prgname (APPLICATION_ID);
#line 93 "../src/application.vala"
	g_set_application_name (_ ("Passwords and Keys"));
#line 96 "../src/application.vala"
	seahorse_gkr_backend_initialize ();
#line 97 "../src/application.vala"
	seahorse_ssh_backend_initialize ();
#line 99 "../src/application.vala"
	seahorse_pgp_backend_initialize (NULL);
#line 102 "../src/application.vala"
	seahorse_pkcs11_backend_initialize ();
#line 506 "application.c"
}

static void
seahorse_application_real_activate (GApplication* base)
{
	SeahorseApplication * self;
	GtkWindow* _tmp0_;
	SeahorseKeyManager* _tmp2_;
#line 106 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 107 "../src/application.vala"
	_tmp0_ = gtk_application_get_active_window ((GtkApplication*) self);
#line 107 "../src/application.vala"
	if (_tmp0_ == NULL) {
#line 521 "application.c"
		SeahorseKeyManager* _tmp1_;
#line 108 "../src/application.vala"
		_tmp1_ = seahorse_key_manager_new (self);
#line 108 "../src/application.vala"
		g_object_ref_sink (_tmp1_);
#line 108 "../src/application.vala"
		_g_object_unref0 (self->priv->key_mgr);
#line 108 "../src/application.vala"
		self->priv->key_mgr = _tmp1_;
#line 531 "application.c"
	}
#line 110 "../src/application.vala"
	_tmp2_ = self->priv->key_mgr;
#line 110 "../src/application.vala"
	gtk_window_present ((GtkWindow*) _tmp2_);
#line 537 "application.c"
}

static void
seahorse_application_real_open (GApplication* base,
                                GFile** files,
                                gint files_length1,
                                const gchar* hint)
{
	SeahorseApplication * self;
	SeahorseKeyManager* _tmp0_;
	SeahorseKeyManager* _tmp1_;
	GFile* _tmp2_;
#line 113 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 113 "../src/application.vala"
	g_return_if_fail (hint != NULL);
#line 114 "../src/application.vala"
	g_application_activate ((GApplication*) self);
#line 115 "../src/application.vala"
	_tmp0_ = self->priv->key_mgr;
#line 115 "../src/application.vala"
	g_return_if_fail (_tmp0_ != NULL);
#line 118 "../src/application.vala"
	_tmp1_ = self->priv->key_mgr;
#line 118 "../src/application.vala"
	_tmp2_ = files[0];
#line 118 "../src/application.vala"
	seahorse_key_manager_import_file (_tmp1_, _tmp2_, NULL, NULL);
#line 566 "application.c"
}

static gint
seahorse_application_real_handle_local_options (GApplication* base,
                                                GVariantDict* options)
{
	SeahorseApplication * self;
	gint result;
#line 121 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 121 "../src/application.vala"
	g_return_val_if_fail (options != NULL, 0);
#line 122 "../src/application.vala"
	if (g_variant_dict_contains (options, "version")) {
#line 123 "../src/application.vala"
		g_print ("%s\n", PACKAGE_STRING);
#line 125 "../src/application.vala"
		g_print ("GNUPG: %s (%d.%d.%d)\n", GNUPG, GPG_MAJOR, GPG_MINOR, GPG_MICRO);
#line 127 "../src/application.vala"
		result = 0;
#line 127 "../src/application.vala"
		return result;
#line 589 "application.c"
	}
#line 130 "../src/application.vala"
	result = -1;
#line 130 "../src/application.vala"
	return result;
#line 595 "application.c"
}

static gboolean
seahorse_application_real_dbus_register (GApplication* base,
                                         GDBusConnection* connection,
                                         const gchar* object_path,
                                         GError** error)
{
	SeahorseApplication * self;
	gboolean _tmp0_ = FALSE;
	guint _tmp2_ = 0U;
	SeahorseSearchProvider* _tmp3_;
	guint _tmp4_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 133 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 133 "../src/application.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 133 "../src/application.vala"
	g_return_val_if_fail (object_path != NULL, FALSE);
#line 134 "../src/application.vala"
	_tmp0_ = G_APPLICATION_CLASS (seahorse_application_parent_class)->dbus_register ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_get_type (), AdwApplication), connection, object_path, &_inner_error0_);
#line 134 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 621 "application.c"
		gboolean _tmp1_ = FALSE;
#line 134 "../src/application.vala"
		g_propagate_error (error, _inner_error0_);
#line 134 "../src/application.vala"
		return _tmp1_;
#line 627 "application.c"
	}
#line 134 "../src/application.vala"
	if (!_tmp0_) {
#line 135 "../src/application.vala"
		result = FALSE;
#line 135 "../src/application.vala"
		return result;
#line 635 "application.c"
	}
#line 137 "../src/application.vala"
	_tmp3_ = self->priv->search_provider;
#line 137 "../src/application.vala"
	_tmp4_ = seahorse_search_provider_register_object (_tmp3_, connection, object_path, &_inner_error0_);
#line 137 "../src/application.vala"
	_tmp2_ = _tmp4_;
#line 137 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 645 "application.c"
		gboolean _tmp5_ = FALSE;
#line 137 "../src/application.vala"
		g_propagate_error (error, _inner_error0_);
#line 137 "../src/application.vala"
		return _tmp5_;
#line 651 "application.c"
	}
#line 137 "../src/application.vala"
	self->priv->search_provider_dbus_id = _tmp2_;
#line 138 "../src/application.vala"
	result = TRUE;
#line 138 "../src/application.vala"
	return result;
#line 659 "application.c"
}

static void
seahorse_application_real_dbus_unregister (GApplication* base,
                                           GDBusConnection* connection,
                                           const gchar* object_path)
{
	SeahorseApplication * self;
#line 141 "../src/application.vala"
	self = (SeahorseApplication*) base;
#line 141 "../src/application.vala"
	g_return_if_fail (connection != NULL);
#line 141 "../src/application.vala"
	g_return_if_fail (object_path != NULL);
#line 142 "../src/application.vala"
	if (self->priv->search_provider_dbus_id != ((guint) 0)) {
#line 143 "../src/application.vala"
		g_dbus_connection_unregister_object (connection, self->priv->search_provider_dbus_id);
#line 144 "../src/application.vala"
		self->priv->search_provider_dbus_id = (guint) 0;
#line 680 "application.c"
	}
#line 147 "../src/application.vala"
	G_APPLICATION_CLASS (seahorse_application_parent_class)->dbus_unregister ((GApplication*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_application_get_type (), AdwApplication), connection, object_path);
#line 684 "application.c"
}

void
seahorse_application_initialize_search (SeahorseApplication* self)
{
	SeahorseSearchProvider* _tmp0_;
#line 150 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/application.vala"
	_tmp0_ = self->priv->search_provider;
#line 151 "../src/application.vala"
	seahorse_search_provider_load (_tmp0_, NULL, NULL);
#line 697 "application.c"
}

static gchar**
_vala_array_dup1 (gchar** self,
                  gssize length)
{
#line 155 "../src/application.vala"
	if (length >= 0) {
#line 706 "application.c"
		gchar** result;
		gssize i;
#line 155 "../src/application.vala"
		result = g_new0 (gchar*, length + 1);
#line 155 "../src/application.vala"
		for (i = 0; i < length; i++) {
#line 713 "application.c"
			gchar* _tmp0_;
#line 155 "../src/application.vala"
			_tmp0_ = g_strdup (self[i]);
#line 155 "../src/application.vala"
			result[i] = _tmp0_;
#line 719 "application.c"
		}
#line 155 "../src/application.vala"
		return result;
#line 723 "application.c"
	}
#line 155 "../src/application.vala"
	return NULL;
#line 727 "application.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 155 "../src/application.vala"
	if (length >= 0) {
#line 736 "application.c"
		gchar** result;
		gssize i;
#line 155 "../src/application.vala"
		result = g_new0 (gchar*, length + 1);
#line 155 "../src/application.vala"
		for (i = 0; i < length; i++) {
#line 743 "application.c"
			gchar* _tmp0_;
#line 155 "../src/application.vala"
			_tmp0_ = g_strdup (self[i]);
#line 155 "../src/application.vala"
			result[i] = _tmp0_;
#line 749 "application.c"
		}
#line 155 "../src/application.vala"
		return result;
#line 753 "application.c"
	}
#line 155 "../src/application.vala"
	return NULL;
#line 757 "application.c"
}

static void
seahorse_application_on_app_about (SeahorseApplication* self,
                                   GSimpleAction* action,
                                   GVariant* param)
{
	AdwAboutDialog* dialog = NULL;
	gchar* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	AdwAboutDialog* _tmp9_ = NULL;
	SeahorseKeyManager* _tmp10_;
#line 154 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/application.vala"
	g_return_if_fail (action != NULL);
#line 155 "../src/application.vala"
	_tmp0_ = g_strdup (_ ("Passwords and Keys"));
#line 155 "../src/application.vala"
	_tmp1_ = _vala_array_dup1 (SEAHORSE_APPLICATION_DEVELOPERS, G_N_ELEMENTS (SEAHORSE_APPLICATION_DEVELOPERS));
#line 155 "../src/application.vala"
	_tmp1__length1 = G_N_ELEMENTS (SEAHORSE_APPLICATION_DEVELOPERS);
#line 155 "../src/application.vala"
	_tmp2_ = _vala_array_dup2 (SEAHORSE_APPLICATION_DESIGNERS, G_N_ELEMENTS (SEAHORSE_APPLICATION_DESIGNERS));
#line 155 "../src/application.vala"
	_tmp2__length1 = G_N_ELEMENTS (SEAHORSE_APPLICATION_DESIGNERS);
#line 155 "../src/application.vala"
	_tmp3_ = g_strdup (_ ("The GNOME Project"));
#line 155 "../src/application.vala"
	_tmp4_ = g_strdup ("https://wiki.gnome.org/Apps/Seahorse");
#line 155 "../src/application.vala"
	_tmp5_ = g_strdup ("https://gitlab.gnome.org/GNOME/seahorse/-/issues/new");
#line 155 "../src/application.vala"
	_tmp6_ = g_strdup (VERSION);
#line 155 "../src/application.vala"
	_tmp7_ = g_strdup (APPLICATION_ID);
#line 155 "../src/application.vala"
	_tmp8_ = g_strdup ("© Seahorse contributors");
#line 155 "../src/application.vala"
	_tmp9_ = (AdwAboutDialog*) adw_about_dialog_new ();
#line 155 "../src/application.vala"
	adw_about_dialog_set_application_name (_tmp9_, _tmp0_);
#line 155 "../src/application.vala"
	_g_free0 (_tmp0_);
#line 155 "../src/application.vala"
	adw_about_dialog_set_developers (_tmp9_, _tmp1_);
#line 155 "../src/application.vala"
	_tmp1_ = (_vala_array_free (_tmp1_, _tmp1__length1, (GDestroyNotify) g_free), NULL);
#line 155 "../src/application.vala"
	adw_about_dialog_set_designers (_tmp9_, _tmp2_);
#line 155 "../src/application.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 155 "../src/application.vala"
	adw_about_dialog_set_developer_name (_tmp9_, _tmp3_);
#line 155 "../src/application.vala"
	_g_free0 (_tmp3_);
#line 155 "../src/application.vala"
	adw_about_dialog_set_website (_tmp9_, _tmp4_);
#line 155 "../src/application.vala"
	_g_free0 (_tmp4_);
#line 155 "../src/application.vala"
	adw_about_dialog_set_issue_url (_tmp9_, _tmp5_);
#line 155 "../src/application.vala"
	_g_free0 (_tmp5_);
#line 155 "../src/application.vala"
	adw_about_dialog_set_version (_tmp9_, _tmp6_);
#line 155 "../src/application.vala"
	_g_free0 (_tmp6_);
#line 155 "../src/application.vala"
	adw_about_dialog_set_application_icon (_tmp9_, _tmp7_);
#line 155 "../src/application.vala"
	_g_free0 (_tmp7_);
#line 155 "../src/application.vala"
	adw_about_dialog_set_copyright (_tmp9_, _tmp8_);
#line 155 "../src/application.vala"
	_g_free0 (_tmp8_);
#line 155 "../src/application.vala"
	adw_about_dialog_set_license_type (_tmp9_, GTK_LICENSE_GPL_2_0);
#line 155 "../src/application.vala"
	g_object_ref_sink (_tmp9_);
#line 155 "../src/application.vala"
	dialog = _tmp9_;
#line 167 "../src/application.vala"
	_tmp10_ = self->priv->key_mgr;
#line 167 "../src/application.vala"
	adw_dialog_present ((AdwDialog*) dialog, (GtkWidget*) _tmp10_);
#line 154 "../src/application.vala"
	_g_object_unref0 (dialog);
#line 855 "application.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 170 "../src/application.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 170 "../src/application.vala"
	return _data1_;
#line 865 "application.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 170 "../src/application.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 875 "application.c"
		SeahorseApplication* self;
#line 170 "../src/application.vala"
		self = _data1_->self;
#line 170 "../src/application.vala"
		_g_object_unref0 (_data1_->help_launcher);
#line 170 "../src/application.vala"
		_g_object_unref0 (self);
#line 170 "../src/application.vala"
		g_slice_free (Block1Data, _data1_);
#line 885 "application.c"
	}
}

static void
__lambda19_ (Block1Data* _data1_,
             GObject* obj,
             GAsyncResult* res)
{
	SeahorseApplication* self;
	GError* _inner_error0_ = NULL;
#line 172 "../src/application.vala"
	self = _data1_->self;
#line 172 "../src/application.vala"
	g_return_if_fail (res != NULL);
#line 900 "application.c"
	{
#line 174 "../src/application.vala"
		gtk_uri_launcher_launch_finish (_data1_->help_launcher, res, &_inner_error0_);
#line 174 "../src/application.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 906 "application.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 173 "../src/application.vala"
		err = _inner_error0_;
#line 173 "../src/application.vala"
		_inner_error0_ = NULL;
#line 176 "../src/application.vala"
		_tmp0_ = err;
#line 176 "../src/application.vala"
		_tmp1_ = _tmp0_->message;
#line 176 "../src/application.vala"
		g_warning ("application.vala:176: Error showing help: %s", _tmp1_);
#line 173 "../src/application.vala"
		_g_error_free0 (err);
#line 928 "application.c"
	}
	__finally0:
#line 173 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../src/application.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 173 "../src/application.vala"
		g_clear_error (&_inner_error0_);
#line 173 "../src/application.vala"
		return;
#line 939 "application.c"
	}
}

static void
___lambda19__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 172 "../src/application.vala"
	__lambda19_ (self, source_object, res);
#line 172 "../src/application.vala"
	block1_data_unref (self);
#line 952 "application.c"
}

static void
seahorse_application_on_app_help (SeahorseApplication* self,
                                  GSimpleAction* action,
                                  GVariant* param)
{
	Block1Data* _data1_;
	GtkUriLauncher* _tmp0_;
	SeahorseKeyManager* _tmp1_;
#line 170 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/application.vala"
	g_return_if_fail (action != NULL);
#line 170 "../src/application.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 170 "../src/application.vala"
	_data1_->_ref_count_ = 1;
#line 170 "../src/application.vala"
	_data1_->self = g_object_ref (self);
#line 171 "../src/application.vala"
	_tmp0_ = gtk_uri_launcher_new ("help:seahorse");
#line 171 "../src/application.vala"
	_data1_->help_launcher = _tmp0_;
#line 172 "../src/application.vala"
	_tmp1_ = self->priv->key_mgr;
#line 172 "../src/application.vala"
	gtk_uri_launcher_launch (_data1_->help_launcher, (GtkWindow*) _tmp1_, NULL, ___lambda19__gasync_ready_callback, block1_data_ref (_data1_));
#line 170 "../src/application.vala"
	block1_data_unref (_data1_);
#line 170 "../src/application.vala"
	_data1_ = NULL;
#line 985 "application.c"
}

static void
seahorse_application_on_app_preferences (SeahorseApplication* self,
                                         GSimpleAction* action,
                                         GVariant* param)
{
	SeahorsePrefsDialog* prefs_dialog = NULL;
	SeahorsePrefsDialog* _tmp0_;
	SeahorseKeyManager* _tmp1_;
#line 181 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/application.vala"
	g_return_if_fail (action != NULL);
#line 182 "../src/application.vala"
	_tmp0_ = seahorse_prefs_dialog_new ();
#line 182 "../src/application.vala"
	g_object_ref_sink (_tmp0_);
#line 182 "../src/application.vala"
	prefs_dialog = _tmp0_;
#line 183 "../src/application.vala"
	_tmp1_ = self->priv->key_mgr;
#line 183 "../src/application.vala"
	adw_dialog_present ((AdwDialog*) prefs_dialog, (GtkWidget*) _tmp1_);
#line 181 "../src/application.vala"
	_g_object_unref0 (prefs_dialog);
#line 1012 "application.c"
}

static void
seahorse_application_class_init (SeahorseApplicationClass * klass,
                                 gpointer klass_data)
{
#line 24 "../src/application.vala"
	seahorse_application_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/application.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseApplication_private_offset);
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->startup = (void (*) (GApplication*)) seahorse_application_real_startup;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) seahorse_application_real_activate;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->open = (void (*) (GApplication*, GFile**, gint, const gchar*)) seahorse_application_real_open;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->handle_local_options = (gint (*) (GApplication*, GVariantDict*)) seahorse_application_real_handle_local_options;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_register = (gboolean (*) (GApplication*, GDBusConnection*, const gchar*, GError**)) seahorse_application_real_dbus_register;
#line 24 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_unregister = (void (*) (GApplication*, GDBusConnection*, const gchar*)) seahorse_application_real_dbus_unregister;
#line 24 "../src/application.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_application_finalize;
#line 1037 "application.c"
}

static void
seahorse_application_instance_init (SeahorseApplication * self,
                                    gpointer klass)
{
#line 24 "../src/application.vala"
	self->priv = seahorse_application_get_instance_private (self);
#line 27 "../src/application.vala"
	self->priv->search_provider_dbus_id = (guint) 0;
#line 29 "../src/application.vala"
	self->priv->key_mgr = NULL;
#line 1050 "application.c"
}

static void
seahorse_application_finalize (GObject * obj)
{
	SeahorseApplication * self;
#line 24 "../src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_APPLICATION, SeahorseApplication);
#line 26 "../src/application.vala"
	_g_object_unref0 (self->priv->search_provider);
#line 29 "../src/application.vala"
	_g_object_unref0 (self->priv->key_mgr);
#line 24 "../src/application.vala"
	G_OBJECT_CLASS (seahorse_application_parent_class)->finalize (obj);
#line 1065 "application.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseApplication), 0, (GInstanceInitFunc) seahorse_application_instance_init, NULL };
	GType seahorse_application_type_id;
	seahorse_application_type_id = g_type_register_static (adw_application_get_type (), "SeahorseApplication", &g_define_type_info, 0);
	SeahorseApplication_private_offset = g_type_add_instance_private (seahorse_application_type_id, sizeof (SeahorseApplicationPrivate));
	return seahorse_application_type_id;
}

GType
seahorse_application_get_type (void)
{
	static gsize seahorse_application_type_id__once = 0;
	if (g_once_init_enter (&seahorse_application_type_id__once)) {
		GType seahorse_application_type_id;
		seahorse_application_type_id = seahorse_application_get_type_once ();
		g_once_init_leave (&seahorse_application_type_id__once, seahorse_application_type_id);
	}
	return seahorse_application_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

