/* import-dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from import-dialog.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2011 Collabora Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Author: Stef Walter <stefw@collabora.co.uk>
 */

#include <adwaita.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gcr/gcr.h>
#include <glib.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gck/gck.h>
#include "seahorse-pkcs11.h"
#include "seahorse-common.h"
#include "pgp/seahorse-pgp-backend.h"
#include "seahorse-ssh.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SEAHORSE_TYPE_IMPORT_DIALOG (seahorse_import_dialog_get_type ())
#define SEAHORSE_IMPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialog))
#define SEAHORSE_IMPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialogClass))
#define SEAHORSE_IS_IMPORT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SEAHORSE_TYPE_IMPORT_DIALOG))
#define SEAHORSE_IS_IMPORT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SEAHORSE_TYPE_IMPORT_DIALOG))
#define SEAHORSE_IMPORT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialogClass))

typedef struct _SeahorseImportDialog SeahorseImportDialog;
typedef struct _SeahorseImportDialogClass SeahorseImportDialogClass;
typedef struct _SeahorseImportDialogPrivate SeahorseImportDialogPrivate;
enum  {
	SEAHORSE_IMPORT_DIALOG_0_PROPERTY,
	SEAHORSE_IMPORT_DIALOG_INPUT_PROPERTY,
	SEAHORSE_IMPORT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* seahorse_import_dialog_properties[SEAHORSE_IMPORT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SeahorseImportDialogParseInputData SeahorseImportDialogParseInputData;
#define _gck_attributes_unref0(var) ((var == NULL) ? NULL : (var = (gck_attributes_unref (var), NULL)))
#define __vala_GcrParsed_free0(var) ((var == NULL) ? NULL : (var = (_vala_GcrParsed_free (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;

struct _SeahorseImportDialog {
	AdwWindow parent_instance;
	SeahorseImportDialogPrivate * priv;
};

struct _SeahorseImportDialogClass {
	AdwWindowClass parent_class;
};

struct _SeahorseImportDialogPrivate {
	GtkBox* container;
	GcrParser* parser;
	GPtrArray* parsed_items;
	GInputStream* _input;
};

struct _SeahorseImportDialogParseInputData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseImportDialog* self;
	GCancellable* cancellable;
	GCancellable* _tmp0_;
	GcrParser* _tmp1_;
	GInputStream* _tmp2_;
	GError* err;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GError* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	SeahorseImportDialog* self;
	GtkLabel* label;
	GtkPasswordEntry* entry;
	GtkButton* button;
	GcrParser* parser;
};

struct _Block3Data {
	int _ref_count_;
	SeahorseImportDialog* self;
	GcrImporter* importer;
};

static gint SeahorseImportDialog_private_offset;
static gpointer seahorse_import_dialog_parent_class = NULL;

VALA_EXTERN GType seahorse_import_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SeahorseImportDialog, g_object_unref)
static void _vala_GcrParsed_free (GcrParsed* self);
static void __vala_GcrParsed_free0_ (gpointer var);
VALA_EXTERN SeahorseImportDialog* seahorse_import_dialog_new (GInputStream* input,
                                                  const gchar* title,
                                                  GtkWindow* parent);
VALA_EXTERN SeahorseImportDialog* seahorse_import_dialog_construct (GType object_type,
                                                        GInputStream* input,
                                                        const gchar* title,
                                                        GtkWindow* parent);
static void seahorse_import_dialog_parse_input_data_free (gpointer _data);
static void seahorse_import_dialog_parse_input (SeahorseImportDialog* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void seahorse_import_dialog_parse_input_finish (SeahorseImportDialog* self,
                                                GAsyncResult* _res_);
static gboolean seahorse_import_dialog_parse_input_co (SeahorseImportDialogParseInputData* _data_);
VALA_EXTERN GInputStream* seahorse_import_dialog_get_input (SeahorseImportDialog* self);
static void seahorse_import_dialog_parse_input_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void seahorse_import_dialog_show_error (SeahorseImportDialog* self,
                                        const gchar* message);
static void seahorse_import_dialog_on_parser_parsed (SeahorseImportDialog* self,
                                              GcrParser* parser);
static GcrParsed* _vala_GcrParsed_copy (GcrParsed* self);
static guint8* _vala_array_dup3 (guint8* self,
                          gssize length);
static void ___lambda8_ (SeahorseImportDialog* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ____lambda8__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean seahorse_import_dialog_on_parser_authenticate (SeahorseImportDialog* self,
                                                        GcrParser* parser,
                                                        gint count);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda9_ (Block2Data* _data2_,
                 GtkButton* btn);
static void ___lambda9__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void seahorse_import_dialog_action_import_all (SeahorseImportDialog* self,
                                               const gchar* action_name,
                                               GVariant* param);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void ____lambda10_ (Block3Data* _data3_,
                    GObject* obj,
                    GAsyncResult* res);
static void _____lambda10__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void seahorse_import_dialog_set_input (SeahorseImportDialog* self,
                                       GInputStream* value);
static GObject * seahorse_import_dialog_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _seahorse_import_dialog_on_parser_parsed_gcr_parser_parsed (GcrParser* _sender,
                                                                 gpointer self);
static gboolean _seahorse_import_dialog_on_parser_authenticate_gcr_parser_authenticate (GcrParser* _sender,
                                                                                 gint count,
                                                                                 gpointer self);
static void seahorse_import_dialog_finalize (GObject * obj);
static GType seahorse_import_dialog_get_type_once (void);
static void _vala_seahorse_import_dialog_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_seahorse_import_dialog_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
seahorse_import_dialog_get_instance_private (SeahorseImportDialog* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseImportDialog_private_offset);
}

static void
_vala_GcrParsed_free (GcrParsed* self)
{
#line 28 "../src/import-dialog.vala"
	g_boxed_free (gcr_parsed_get_type (), self);
#line 228 "import-dialog.c"
}

static void
__vala_GcrParsed_free0_ (gpointer var)
{
#line 28 "../src/import-dialog.vala"
	(var == NULL) ? NULL : (var = (_vala_GcrParsed_free (var), NULL));
#line 236 "import-dialog.c"
}

SeahorseImportDialog*
seahorse_import_dialog_construct (GType object_type,
                                  GInputStream* input,
                                  const gchar* title,
                                  GtkWindow* parent)
{
	SeahorseImportDialog * self = NULL;
	const gchar* _tmp0_ = NULL;
#line 47 "../src/import-dialog.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 52 "../src/import-dialog.vala"
	_tmp0_ = title;
#line 52 "../src/import-dialog.vala"
	if (_tmp0_ == NULL) {
#line 52 "../src/import-dialog.vala"
		_tmp0_ = _ ("Import Data");
#line 255 "import-dialog.c"
	}
#line 50 "../src/import-dialog.vala"
	self = (SeahorseImportDialog*) g_object_new (object_type, "input", input, "title", _tmp0_, "transient-for", parent, NULL);
#line 47 "../src/import-dialog.vala"
	return self;
#line 261 "import-dialog.c"
}

SeahorseImportDialog*
seahorse_import_dialog_new (GInputStream* input,
                            const gchar* title,
                            GtkWindow* parent)
{
#line 47 "../src/import-dialog.vala"
	return seahorse_import_dialog_construct (SEAHORSE_TYPE_IMPORT_DIALOG, input, title, parent);
#line 271 "import-dialog.c"
}

static void
seahorse_import_dialog_parse_input_data_free (gpointer _data)
{
	SeahorseImportDialogParseInputData* _data_;
	_data_ = _data;
#line 23 "../src/import-dialog.vala"
	_g_object_unref0 (_data_->self);
#line 23 "../src/import-dialog.vala"
	g_slice_free (SeahorseImportDialogParseInputData, _data_);
#line 283 "import-dialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 23 "../src/import-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 291 "import-dialog.c"
}

static void
seahorse_import_dialog_parse_input (SeahorseImportDialog* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	SeahorseImportDialogParseInputData* _data_;
	SeahorseImportDialog* _tmp0_;
#line 23 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/import-dialog.vala"
	_data_ = g_slice_new0 (SeahorseImportDialogParseInputData);
#line 23 "../src/import-dialog.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 23 "../src/import-dialog.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_import_dialog_parse_input_data_free);
#line 23 "../src/import-dialog.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 23 "../src/import-dialog.vala"
	_data_->self = _tmp0_;
#line 23 "../src/import-dialog.vala"
	seahorse_import_dialog_parse_input_co (_data_);
#line 315 "import-dialog.c"
}

static void
seahorse_import_dialog_parse_input_finish (SeahorseImportDialog* self,
                                           GAsyncResult* _res_)
{
	SeahorseImportDialogParseInputData* _data_;
#line 23 "../src/import-dialog.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 325 "import-dialog.c"
}

static void
seahorse_import_dialog_parse_input_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	SeahorseImportDialogParseInputData* _data_;
#line 62 "../src/import-dialog.vala"
	_data_ = _user_data_;
#line 62 "../src/import-dialog.vala"
	_data_->_source_object_ = source_object;
#line 62 "../src/import-dialog.vala"
	_data_->_res_ = _res_;
#line 62 "../src/import-dialog.vala"
	seahorse_import_dialog_parse_input_co (_data_);
#line 342 "import-dialog.c"
}

static gboolean
seahorse_import_dialog_parse_input_co (SeahorseImportDialogParseInputData* _data_)
{
#line 57 "../src/import-dialog.vala"
	switch (_data_->_state_) {
#line 57 "../src/import-dialog.vala"
		case 0:
#line 352 "import-dialog.c"
		goto _state_0;
#line 57 "../src/import-dialog.vala"
		case 1:
#line 356 "import-dialog.c"
		goto _state_1;
		default:
#line 57 "../src/import-dialog.vala"
		g_assert_not_reached ();
#line 361 "import-dialog.c"
	}
	_state_0:
#line 58 "../src/import-dialog.vala"
	_data_->_tmp0_ = g_cancellable_new ();
#line 58 "../src/import-dialog.vala"
	_data_->cancellable = _data_->_tmp0_;
#line 368 "import-dialog.c"
	{
#line 61 "../src/import-dialog.vala"
		g_debug ("import-dialog.vala:61: Parsing input");
#line 62 "../src/import-dialog.vala"
		_data_->_tmp1_ = _data_->self->priv->parser;
#line 62 "../src/import-dialog.vala"
		_data_->_tmp2_ = _data_->self->priv->_input;
#line 62 "../src/import-dialog.vala"
		_data_->_state_ = 1;
#line 62 "../src/import-dialog.vala"
		gcr_parser_parse_stream_async (_data_->_tmp1_, _data_->_tmp2_, _data_->cancellable, seahorse_import_dialog_parse_input_ready, _data_);
#line 62 "../src/import-dialog.vala"
		return FALSE;
#line 382 "import-dialog.c"
		_state_1:
#line 62 "../src/import-dialog.vala"
		gcr_parser_parse_stream_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error0_);
#line 62 "../src/import-dialog.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 388 "import-dialog.c"
			goto __catch0_g_error;
		}
#line 63 "../src/import-dialog.vala"
		g_debug ("import-dialog.vala:63: Successfully parsed input");
#line 393 "import-dialog.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 60 "../src/import-dialog.vala"
		_data_->err = _data_->_inner_error0_;
#line 60 "../src/import-dialog.vala"
		_data_->_inner_error0_ = NULL;
#line 65 "../src/import-dialog.vala"
		_data_->_tmp3_ = _data_->err;
#line 65 "../src/import-dialog.vala"
		_data_->_tmp4_ = _data_->_tmp3_->message;
#line 65 "../src/import-dialog.vala"
		g_warning ("import-dialog.vala:65: Error parsing input: %s", _data_->_tmp4_);
#line 67 "../src/import-dialog.vala"
		_data_->_tmp5_ = _data_->err;
#line 67 "../src/import-dialog.vala"
		_data_->_tmp6_ = _data_->_tmp5_->message;
#line 67 "../src/import-dialog.vala"
		_data_->_tmp7_ = g_strdup_printf ("Failed to read input: %s", _data_->_tmp6_);
#line 67 "../src/import-dialog.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 67 "../src/import-dialog.vala"
		seahorse_import_dialog_show_error (_data_->self, _data_->_tmp8_);
#line 67 "../src/import-dialog.vala"
		_g_free0 (_data_->_tmp8_);
#line 60 "../src/import-dialog.vala"
		_g_error_free0 (_data_->err);
#line 422 "import-dialog.c"
	}
	__finally0:
#line 60 "../src/import-dialog.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 60 "../src/import-dialog.vala"
		_g_object_unref0 (_data_->cancellable);
#line 60 "../src/import-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 60 "../src/import-dialog.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 60 "../src/import-dialog.vala"
		g_object_unref (_data_->_async_result);
#line 60 "../src/import-dialog.vala"
		return FALSE;
#line 437 "import-dialog.c"
	}
#line 57 "../src/import-dialog.vala"
	_g_object_unref0 (_data_->cancellable);
#line 57 "../src/import-dialog.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 57 "../src/import-dialog.vala"
	if (_data_->_state_ != 0) {
#line 57 "../src/import-dialog.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 57 "../src/import-dialog.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 449 "import-dialog.c"
		}
	}
#line 57 "../src/import-dialog.vala"
	g_object_unref (_data_->_async_result);
#line 57 "../src/import-dialog.vala"
	return FALSE;
#line 456 "import-dialog.c"
}

static GcrParsed*
_vala_GcrParsed_copy (GcrParsed* self)
{
#line 72 "../src/import-dialog.vala"
	return g_boxed_copy (gcr_parsed_get_type (), self);
#line 464 "import-dialog.c"
}

static gpointer
__vala_GcrParsed_copy0 (gpointer self)
{
#line 72 "../src/import-dialog.vala"
	return self ? _vala_GcrParsed_copy (self) : NULL;
#line 472 "import-dialog.c"
}

static gpointer
_gck_attributes_ref0 (gpointer self)
{
#line 73 "../src/import-dialog.vala"
	return self ? gck_attributes_ref (self) : NULL;
#line 480 "import-dialog.c"
}

static guint8*
_vala_array_dup3 (guint8* self,
                  gssize length)
{
#line 90 "../src/import-dialog.vala"
	if (length > 0) {
#line 90 "../src/import-dialog.vala"
		return g_memdup2 (self, length * sizeof (guint8));
#line 491 "import-dialog.c"
	}
#line 90 "../src/import-dialog.vala"
	return NULL;
#line 495 "import-dialog.c"
}

static void
___lambda8_ (SeahorseImportDialog* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 91 "../src/import-dialog.vala"
	g_return_if_fail (res != NULL);
#line 506 "import-dialog.c"
	{
		SeahorseSshKeyKeyParseResult parse_res = {0};
		SeahorseSshKeyKeyParseResult _tmp0_ = {0};
		SeahorseSshKey* key = NULL;
		SeahorseSshKeyKeyParseResult _tmp1_;
		SeahorseSshKeyData** _tmp2_;
		gint _tmp2__length1;
		SeahorseSshKeyData* _tmp3_;
		SeahorseSshKey* _tmp4_;
		GtkBox* _tmp5_;
		SeahorseSshKey* _tmp6_;
		SeahorsePanel* _tmp7_;
		SeahorsePanel* _tmp8_;
#line 93 "../src/import-dialog.vala"
		seahorse_ssh_key_parse_finish (res, &_tmp0_, &_inner_error0_);
#line 93 "../src/import-dialog.vala"
		parse_res = _tmp0_;
#line 93 "../src/import-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 526 "import-dialog.c"
			goto __catch0_g_error;
		}
#line 95 "../src/import-dialog.vala"
		_tmp1_ = parse_res;
#line 95 "../src/import-dialog.vala"
		_tmp2_ = _tmp1_.public_keys;
#line 95 "../src/import-dialog.vala"
		_tmp2__length1 = _tmp1_.public_keys_length1;
#line 95 "../src/import-dialog.vala"
		_tmp3_ = _tmp2_[0];
#line 95 "../src/import-dialog.vala"
		_tmp4_ = seahorse_ssh_key_new (NULL, _tmp3_);
#line 95 "../src/import-dialog.vala"
		key = _tmp4_;
#line 96 "../src/import-dialog.vala"
		_tmp5_ = self->priv->container;
#line 96 "../src/import-dialog.vala"
		_tmp6_ = key;
#line 96 "../src/import-dialog.vala"
		_tmp7_ = seahorse_viewable_create_panel ((SeahorseViewable*) _tmp6_);
#line 96 "../src/import-dialog.vala"
		_tmp8_ = _tmp7_;
#line 96 "../src/import-dialog.vala"
		gtk_box_append (_tmp5_, (GtkWidget*) _tmp8_);
#line 96 "../src/import-dialog.vala"
		_g_object_unref0 (_tmp8_);
#line 92 "../src/import-dialog.vala"
		_g_object_unref0 (key);
#line 92 "../src/import-dialog.vala"
		seahorse_ssh_key_key_parse_result_destroy (&parse_res);
#line 557 "import-dialog.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 92 "../src/import-dialog.vala"
		err = _inner_error0_;
#line 92 "../src/import-dialog.vala"
		_inner_error0_ = NULL;
#line 98 "../src/import-dialog.vala"
		_tmp9_ = err;
#line 98 "../src/import-dialog.vala"
		_tmp10_ = _tmp9_->message;
#line 98 "../src/import-dialog.vala"
		g_warning ("import-dialog.vala:98: Couldn't parse SSH key data: %s", _tmp10_);
#line 99 "../src/import-dialog.vala"
		_tmp11_ = err;
#line 99 "../src/import-dialog.vala"
		_tmp12_ = _tmp11_->message;
#line 99 "../src/import-dialog.vala"
		_tmp13_ = g_strdup_printf ("Couldn't parse SSH key: %s", _tmp12_);
#line 99 "../src/import-dialog.vala"
		_tmp14_ = _tmp13_;
#line 99 "../src/import-dialog.vala"
		seahorse_import_dialog_show_error (self, _tmp14_);
#line 99 "../src/import-dialog.vala"
		_g_free0 (_tmp14_);
#line 92 "../src/import-dialog.vala"
		_g_error_free0 (err);
#line 593 "import-dialog.c"
	}
	__finally0:
#line 92 "../src/import-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 92 "../src/import-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "../src/import-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 92 "../src/import-dialog.vala"
		return;
#line 604 "import-dialog.c"
	}
}

static void
____lambda8__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 91 "../src/import-dialog.vala"
	___lambda8_ ((SeahorseImportDialog*) self, source_object, res);
#line 91 "../src/import-dialog.vala"
	g_object_unref (self);
#line 617 "import-dialog.c"
}

static inline gboolean
vala_g_list_is_empty (GList* self)
{
	gboolean result;
#line 5301 "glib-2.0.vapi"
	result = ((GList*) self) == NULL;
#line 5301 "glib-2.0.vapi"
	return result;
#line 628 "import-dialog.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 71 "../src/import-dialog.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 636 "import-dialog.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 71 "../src/import-dialog.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 644 "import-dialog.c"
}

static void
seahorse_import_dialog_on_parser_parsed (SeahorseImportDialog* self,
                                         GcrParser* parser)
{
	GcrParsed* parsed = NULL;
	GcrParsed* _tmp0_;
	GcrParsed* _tmp1_;
	GckAttributes* attributes = NULL;
	GcrParsed* _tmp2_;
	GckAttributes* _tmp3_;
	GckAttributes* _tmp4_;
	GcrParsed* _tmp5_;
	GPtrArray* _tmp40_;
	GcrParsed* _tmp41_;
	GcrParsed* _tmp42_;
	GList* importers = NULL;
	GcrParsed* _tmp43_;
	GList* _tmp44_;
#line 71 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 71 "../src/import-dialog.vala"
	g_return_if_fail (parser != NULL);
#line 72 "../src/import-dialog.vala"
	_tmp0_ = gcr_parser_get_parsed (parser);
#line 72 "../src/import-dialog.vala"
	_tmp1_ = __vala_GcrParsed_copy0 (_tmp0_);
#line 72 "../src/import-dialog.vala"
	parsed = _tmp1_;
#line 73 "../src/import-dialog.vala"
	_tmp2_ = parsed;
#line 73 "../src/import-dialog.vala"
	_tmp3_ = gcr_parsed_get_attributes (_tmp2_);
#line 73 "../src/import-dialog.vala"
	_tmp4_ = _gck_attributes_ref0 (_tmp3_);
#line 73 "../src/import-dialog.vala"
	attributes = _tmp4_;
#line 75 "../src/import-dialog.vala"
	_tmp5_ = parsed;
#line 75 "../src/import-dialog.vala"
	switch (gcr_parsed_get_format (_tmp5_)) {
#line 75 "../src/import-dialog.vala"
		case GCR_FORMAT_DER_CERTIFICATE_X509:
#line 689 "import-dialog.c"
		{
			GcrSimpleCertificate* certificate = NULL;
			GcrParsed* _tmp6_;
			gsize _tmp7_ = 0;
			guint8* _tmp8_;
			GcrSimpleCertificate* _tmp9_;
			GtkBox* _tmp10_;
			GcrSimpleCertificate* _tmp11_;
			SeahorsePkcs11CertificateWidget* _tmp12_;
			SeahorsePkcs11CertificateWidget* _tmp13_;
#line 78 "../src/import-dialog.vala"
			g_debug ("import-dialog.vala:78: Parser found x.509 DER certificate");
#line 79 "../src/import-dialog.vala"
			_tmp6_ = parsed;
#line 79 "../src/import-dialog.vala"
			_tmp8_ = gcr_parsed_get_data (_tmp6_, &_tmp7_);
#line 79 "../src/import-dialog.vala"
			_tmp9_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp8_, _tmp7_);
#line 79 "../src/import-dialog.vala"
			certificate = _tmp9_;
#line 80 "../src/import-dialog.vala"
			_tmp10_ = self->priv->container;
#line 80 "../src/import-dialog.vala"
			_tmp11_ = certificate;
#line 80 "../src/import-dialog.vala"
			_tmp12_ = seahorse_pkcs11_certificate_widget_new ((GcrCertificate*) _tmp11_);
#line 80 "../src/import-dialog.vala"
			g_object_ref_sink (_tmp12_);
#line 80 "../src/import-dialog.vala"
			_tmp13_ = _tmp12_;
#line 80 "../src/import-dialog.vala"
			gtk_box_append (_tmp10_, (GtkWidget*) _tmp13_);
#line 80 "../src/import-dialog.vala"
			_g_object_unref0 (_tmp13_);
#line 82 "../src/import-dialog.vala"
			_g_object_unref0 (certificate);
#line 82 "../src/import-dialog.vala"
			break;
#line 728 "import-dialog.c"
		}
#line 75 "../src/import-dialog.vala"
		case GCR_FORMAT_OPENPGP_PACKET:
#line 732 "import-dialog.c"
		{
			SeahorseObject* key = NULL;
			SeahorsePgpBackend* _tmp14_;
			GcrParsed* _tmp15_;
			SeahorseObject* _tmp16_;
			GtkBox* _tmp17_;
			SeahorseObject* _tmp18_;
			SeahorsePanel* _tmp19_;
			SeahorsePanel* _tmp20_;
#line 84 "../src/import-dialog.vala"
			g_debug ("import-dialog.vala:84: Parser found OpenPGP packet");
#line 85 "../src/import-dialog.vala"
			_tmp14_ = seahorse_pgp_backend_get ();
#line 85 "../src/import-dialog.vala"
			_tmp15_ = parsed;
#line 85 "../src/import-dialog.vala"
			_tmp16_ = seahorse_pgp_backend_create_key_for_parsed (_tmp14_, _tmp15_);
#line 85 "../src/import-dialog.vala"
			key = _tmp16_;
#line 86 "../src/import-dialog.vala"
			_tmp17_ = self->priv->container;
#line 86 "../src/import-dialog.vala"
			_tmp18_ = key;
#line 86 "../src/import-dialog.vala"
			_tmp19_ = seahorse_viewable_create_panel (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, SEAHORSE_TYPE_VIEWABLE, SeahorseViewable));
#line 86 "../src/import-dialog.vala"
			_tmp20_ = _tmp19_;
#line 86 "../src/import-dialog.vala"
			gtk_box_append (_tmp17_, (GtkWidget*) _tmp20_);
#line 86 "../src/import-dialog.vala"
			_g_object_unref0 (_tmp20_);
#line 87 "../src/import-dialog.vala"
			_g_object_unref0 (key);
#line 87 "../src/import-dialog.vala"
			break;
#line 768 "import-dialog.c"
		}
#line 75 "../src/import-dialog.vala"
		case GCR_FORMAT_OPENSSH_PUBLIC:
#line 772 "import-dialog.c"
		{
			GMemoryInputStream* stream = NULL;
			GcrParsed* _tmp21_;
			gsize _tmp22_ = 0;
			guint8* _tmp23_;
			guint8* _tmp24_;
			gint _tmp24__length1;
			GDestroyNotify _tmp25_;
			GMemoryInputStream* _tmp26_;
			GMemoryInputStream* _tmp27_;
#line 89 "../src/import-dialog.vala"
			g_debug ("import-dialog.vala:89: Parser found Public SSH Key");
#line 90 "../src/import-dialog.vala"
			_tmp21_ = parsed;
#line 90 "../src/import-dialog.vala"
			_tmp23_ = gcr_parsed_get_data (_tmp21_, &_tmp22_);
#line 90 "../src/import-dialog.vala"
			_tmp24_ = (_tmp23_ != NULL) ? _vala_array_dup3 (_tmp23_, _tmp22_) : _tmp23_;
#line 90 "../src/import-dialog.vala"
			_tmp24__length1 = _tmp22_;
#line 90 "../src/import-dialog.vala"
			_tmp25_ = g_free;
#line 90 "../src/import-dialog.vala"
			_tmp26_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp24_, _tmp24__length1, _tmp25_);
#line 90 "../src/import-dialog.vala"
			stream = _tmp26_;
#line 91 "../src/import-dialog.vala"
			_tmp27_ = stream;
#line 91 "../src/import-dialog.vala"
			seahorse_ssh_key_parse ((GInputStream*) _tmp27_, NULL, ____lambda8__gasync_ready_callback, g_object_ref (self));
#line 102 "../src/import-dialog.vala"
			_g_object_unref0 (stream);
#line 102 "../src/import-dialog.vala"
			break;
#line 807 "import-dialog.c"
		}
#line 75 "../src/import-dialog.vala"
		case GCR_FORMAT_DER_PRIVATE_KEY:
#line 75 "../src/import-dialog.vala"
		case GCR_FORMAT_DER_PRIVATE_KEY_RSA:
#line 75 "../src/import-dialog.vala"
		case GCR_FORMAT_DER_PRIVATE_KEY_DSA:
#line 75 "../src/import-dialog.vala"
		case GCR_FORMAT_DER_PRIVATE_KEY_EC:
#line 817 "import-dialog.c"
		{
			SeahorsePkcs11PrivateKey* key = NULL;
			GckAttributes* _tmp28_;
			SeahorsePkcs11PrivateKey* _tmp29_;
			SeahorsePkcs11CertKeyPair* pair = NULL;
			SeahorsePkcs11PrivateKey* _tmp30_;
			SeahorsePkcs11CertKeyPair* _tmp31_;
			GtkBox* _tmp32_;
			SeahorsePkcs11CertKeyPair* _tmp33_;
			SeahorsePanel* _tmp34_;
			SeahorsePanel* _tmp35_;
#line 107 "../src/import-dialog.vala"
			g_debug ("import-dialog.vala:107: Parser found private key");
#line 108 "../src/import-dialog.vala"
			_tmp28_ = attributes;
#line 108 "../src/import-dialog.vala"
			_tmp29_ = seahorse_pkcs11_private_key_new_from_attributes (_tmp28_);
#line 108 "../src/import-dialog.vala"
			key = _tmp29_;
#line 109 "../src/import-dialog.vala"
			_tmp30_ = key;
#line 109 "../src/import-dialog.vala"
			_tmp31_ = seahorse_pkcs11_cert_key_pair_new_for_private_key (NULL, _tmp30_);
#line 109 "../src/import-dialog.vala"
			pair = _tmp31_;
#line 110 "../src/import-dialog.vala"
			_tmp32_ = self->priv->container;
#line 110 "../src/import-dialog.vala"
			_tmp33_ = pair;
#line 110 "../src/import-dialog.vala"
			_tmp34_ = seahorse_viewable_create_panel ((SeahorseViewable*) _tmp33_);
#line 110 "../src/import-dialog.vala"
			_tmp35_ = _tmp34_;
#line 110 "../src/import-dialog.vala"
			gtk_box_append (_tmp32_, (GtkWidget*) _tmp35_);
#line 110 "../src/import-dialog.vala"
			_g_object_unref0 (_tmp35_);
#line 111 "../src/import-dialog.vala"
			_g_object_unref0 (pair);
#line 111 "../src/import-dialog.vala"
			_g_object_unref0 (key);
#line 111 "../src/import-dialog.vala"
			break;
#line 861 "import-dialog.c"
		}
		default:
		{
			GcrParsed* _tmp36_;
			GcrParsed* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 113 "../src/import-dialog.vala"
			_tmp36_ = parsed;
#line 113 "../src/import-dialog.vala"
			g_warning ("import-dialog.vala:113: unsupported format %u", (guint) gcr_parsed_get_format (_tmp36_));
#line 114 "../src/import-dialog.vala"
			_tmp37_ = parsed;
#line 114 "../src/import-dialog.vala"
			_tmp38_ = g_strdup_printf ("Unsupported format %u", (guint) gcr_parsed_get_format (_tmp37_));
#line 114 "../src/import-dialog.vala"
			_tmp39_ = _tmp38_;
#line 114 "../src/import-dialog.vala"
			seahorse_import_dialog_show_error (self, _tmp39_);
#line 114 "../src/import-dialog.vala"
			_g_free0 (_tmp39_);
#line 115 "../src/import-dialog.vala"
			break;
#line 885 "import-dialog.c"
		}
	}
#line 119 "../src/import-dialog.vala"
	_tmp40_ = self->priv->parsed_items;
#line 119 "../src/import-dialog.vala"
	_tmp41_ = parsed;
#line 119 "../src/import-dialog.vala"
	_tmp42_ = __vala_GcrParsed_copy0 (_tmp41_);
#line 119 "../src/import-dialog.vala"
	g_ptr_array_add (_tmp40_, _tmp42_);
#line 122 "../src/import-dialog.vala"
	_tmp43_ = parsed;
#line 122 "../src/import-dialog.vala"
	_tmp44_ = gcr_importer_create_for_parsed (_tmp43_);
#line 122 "../src/import-dialog.vala"
	importers = _tmp44_;
#line 123 "../src/import-dialog.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "import-all", !vala_g_list_is_empty (importers));
#line 71 "../src/import-dialog.vala"
	(importers == NULL) ? NULL : (importers = (_g_list_free__g_object_unref0_ (importers), NULL));
#line 71 "../src/import-dialog.vala"
	_gck_attributes_unref0 (attributes);
#line 71 "../src/import-dialog.vala"
	__vala_GcrParsed_free0 (parsed);
#line 910 "import-dialog.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 126 "../src/import-dialog.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 126 "../src/import-dialog.vala"
	return _data2_;
#line 920 "import-dialog.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 126 "../src/import-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 930 "import-dialog.c"
		SeahorseImportDialog* self;
#line 126 "../src/import-dialog.vala"
		self = _data2_->self;
#line 126 "../src/import-dialog.vala"
		_g_object_unref0 (_data2_->button);
#line 126 "../src/import-dialog.vala"
		_g_object_unref0 (_data2_->entry);
#line 126 "../src/import-dialog.vala"
		_g_object_unref0 (_data2_->label);
#line 126 "../src/import-dialog.vala"
		_g_object_unref0 (_data2_->parser);
#line 126 "../src/import-dialog.vala"
		_g_object_unref0 (self);
#line 126 "../src/import-dialog.vala"
		g_slice_free (Block2Data, _data2_);
#line 946 "import-dialog.c"
	}
}

static void
__lambda9_ (Block2Data* _data2_,
            GtkButton* btn)
{
	SeahorseImportDialog* self;
	gchar* pw = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* _tmp5_;
#line 136 "../src/import-dialog.vala"
	self = _data2_->self;
#line 136 "../src/import-dialog.vala"
	g_return_if_fail (btn != NULL);
#line 137 "../src/import-dialog.vala"
	_tmp0_ = gtk_editable_get_text ((GtkEditable*) _data2_->entry);
#line 137 "../src/import-dialog.vala"
	_tmp1_ = _tmp0_;
#line 137 "../src/import-dialog.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 137 "../src/import-dialog.vala"
	pw = _tmp2_;
#line 139 "../src/import-dialog.vala"
	_tmp3_ = self->priv->container;
#line 139 "../src/import-dialog.vala"
	gtk_box_remove (_tmp3_, (GtkWidget*) _data2_->label);
#line 140 "../src/import-dialog.vala"
	_tmp4_ = self->priv->container;
#line 140 "../src/import-dialog.vala"
	gtk_box_remove (_tmp4_, (GtkWidget*) _data2_->entry);
#line 141 "../src/import-dialog.vala"
	_tmp5_ = self->priv->container;
#line 141 "../src/import-dialog.vala"
	gtk_box_remove (_tmp5_, (GtkWidget*) _data2_->button);
#line 143 "../src/import-dialog.vala"
	g_debug ("import-dialog.vala:143: Adding password to parser");
#line 144 "../src/import-dialog.vala"
	gcr_parser_add_password (_data2_->parser, pw);
#line 136 "../src/import-dialog.vala"
	_g_free0 (pw);
#line 992 "import-dialog.c"
}

static void
___lambda9__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 136 "../src/import-dialog.vala"
	__lambda9_ (self, _sender);
#line 1001 "import-dialog.c"
}

static gboolean
seahorse_import_dialog_on_parser_authenticate (SeahorseImportDialog* self,
                                               GcrParser* parser,
                                               gint count)
{
	Block2Data* _data2_;
	GcrParser* _tmp0_;
	GtkLabel* _tmp1_;
	GtkBox* _tmp2_;
	GtkPasswordEntry* _tmp3_;
	GtkBox* _tmp4_;
	GtkButton* _tmp5_;
	GtkBox* _tmp6_;
	gboolean result;
#line 126 "../src/import-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 126 "../src/import-dialog.vala"
	g_return_val_if_fail (parser != NULL, FALSE);
#line 126 "../src/import-dialog.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 126 "../src/import-dialog.vala"
	_data2_->_ref_count_ = 1;
#line 126 "../src/import-dialog.vala"
	_data2_->self = g_object_ref (self);
#line 126 "../src/import-dialog.vala"
	_tmp0_ = _g_object_ref0 (parser);
#line 126 "../src/import-dialog.vala"
	_g_object_unref0 (_data2_->parser);
#line 126 "../src/import-dialog.vala"
	_data2_->parser = _tmp0_;
#line 127 "../src/import-dialog.vala"
	g_debug ("import-dialog.vala:127: Need authentication for parser");
#line 129 "../src/import-dialog.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (_ ("A password is needed to read the input file"));
#line 129 "../src/import-dialog.vala"
	g_object_ref_sink (_tmp1_);
#line 129 "../src/import-dialog.vala"
	_data2_->label = _tmp1_;
#line 130 "../src/import-dialog.vala"
	_tmp2_ = self->priv->container;
#line 130 "../src/import-dialog.vala"
	gtk_box_append (_tmp2_, (GtkWidget*) _data2_->label);
#line 131 "../src/import-dialog.vala"
	_tmp3_ = (GtkPasswordEntry*) gtk_password_entry_new ();
#line 131 "../src/import-dialog.vala"
	g_object_ref_sink (_tmp3_);
#line 131 "../src/import-dialog.vala"
	_data2_->entry = _tmp3_;
#line 132 "../src/import-dialog.vala"
	_tmp4_ = self->priv->container;
#line 132 "../src/import-dialog.vala"
	gtk_box_append (_tmp4_, (GtkWidget*) _data2_->entry);
#line 133 "../src/import-dialog.vala"
	_tmp5_ = (GtkButton*) gtk_button_new_with_label (_ ("Enter password"));
#line 133 "../src/import-dialog.vala"
	g_object_ref_sink (_tmp5_);
#line 133 "../src/import-dialog.vala"
	_data2_->button = _tmp5_;
#line 134 "../src/import-dialog.vala"
	_tmp6_ = self->priv->container;
#line 134 "../src/import-dialog.vala"
	gtk_box_append (_tmp6_, (GtkWidget*) _data2_->button);
#line 136 "../src/import-dialog.vala"
	g_signal_connect_data (_data2_->button, "clicked", (GCallback) ___lambda9__gtk_button_clicked, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 147 "../src/import-dialog.vala"
	result = TRUE;
#line 147 "../src/import-dialog.vala"
	block2_data_unref (_data2_);
#line 147 "../src/import-dialog.vala"
	_data2_ = NULL;
#line 147 "../src/import-dialog.vala"
	return result;
#line 1076 "import-dialog.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 151 "../src/import-dialog.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 151 "../src/import-dialog.vala"
	return _data3_;
#line 1086 "import-dialog.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 151 "../src/import-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1096 "import-dialog.c"
		SeahorseImportDialog* self;
#line 151 "../src/import-dialog.vala"
		self = _data3_->self;
#line 151 "../src/import-dialog.vala"
		_g_object_unref0 (_data3_->importer);
#line 151 "../src/import-dialog.vala"
		_g_object_unref0 (self);
#line 151 "../src/import-dialog.vala"
		g_slice_free (Block3Data, _data3_);
#line 1106 "import-dialog.c"
	}
}

static void
____lambda10_ (Block3Data* _data3_,
               GObject* obj,
               GAsyncResult* res)
{
	SeahorseImportDialog* self;
	GError* _inner_error0_ = NULL;
#line 160 "../src/import-dialog.vala"
	self = _data3_->self;
#line 160 "../src/import-dialog.vala"
	g_return_if_fail (res != NULL);
#line 1121 "import-dialog.c"
	{
		GcrImporter* _tmp0_;
#line 162 "../src/import-dialog.vala"
		_tmp0_ = _data3_->importer;
#line 162 "../src/import-dialog.vala"
		gcr_importer_import_finish (_tmp0_, res, &_inner_error0_);
#line 162 "../src/import-dialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1130 "import-dialog.c"
			goto __catch0_g_error;
		}
#line 163 "../src/import-dialog.vala"
		g_debug ("import-dialog.vala:163: Successfully imported item");
#line 164 "../src/import-dialog.vala"
		gtk_window_close ((GtkWindow*) self);
#line 1137 "import-dialog.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 161 "../src/import-dialog.vala"
		err = _inner_error0_;
#line 161 "../src/import-dialog.vala"
		_inner_error0_ = NULL;
#line 166 "../src/import-dialog.vala"
		_tmp1_ = err;
#line 166 "../src/import-dialog.vala"
		_tmp2_ = _tmp1_->message;
#line 166 "../src/import-dialog.vala"
		g_warning ("import-dialog.vala:166: Import failed: %s", _tmp2_);
#line 167 "../src/import-dialog.vala"
		_tmp3_ = err;
#line 167 "../src/import-dialog.vala"
		_tmp4_ = _tmp3_->message;
#line 167 "../src/import-dialog.vala"
		_tmp5_ = g_strdup_printf (_ ("Import failed: %s"), _tmp4_);
#line 167 "../src/import-dialog.vala"
		_tmp6_ = _tmp5_;
#line 167 "../src/import-dialog.vala"
		seahorse_import_dialog_show_error (self, _tmp6_);
#line 167 "../src/import-dialog.vala"
		_g_free0 (_tmp6_);
#line 161 "../src/import-dialog.vala"
		_g_error_free0 (err);
#line 1173 "import-dialog.c"
	}
	__finally0:
#line 161 "../src/import-dialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 161 "../src/import-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 161 "../src/import-dialog.vala"
		g_clear_error (&_inner_error0_);
#line 161 "../src/import-dialog.vala"
		return;
#line 1184 "import-dialog.c"
	}
}

static void
_____lambda10__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 160 "../src/import-dialog.vala"
	____lambda10_ (self, source_object, res);
#line 160 "../src/import-dialog.vala"
	block3_data_unref (self);
#line 1197 "import-dialog.c"
}

static void
seahorse_import_dialog_action_import_all (SeahorseImportDialog* self,
                                          const gchar* action_name,
                                          GVariant* param)
{
	GPtrArray* _tmp0_;
#line 150 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/import-dialog.vala"
	g_return_if_fail (action_name != NULL);
#line 151 "../src/import-dialog.vala"
	_tmp0_ = self->priv->parsed_items;
#line 1212 "import-dialog.c"
	{
		GPtrArray* parsed_collection = NULL;
		guint parsed_index = 0U;
#line 151 "../src/import-dialog.vala"
		parsed_collection = _tmp0_;
#line 151 "../src/import-dialog.vala"
		for (parsed_index = 0; parsed_index < parsed_collection->len; parsed_index = parsed_index + 1) {
#line 1220 "import-dialog.c"
			GcrParsed* parsed = NULL;
#line 151 "../src/import-dialog.vala"
			parsed = (GcrParsed*) g_ptr_array_index (parsed_collection, parsed_index);
#line 1224 "import-dialog.c"
			{
				Block3Data* _data3_;
				GList* importers = NULL;
				GcrParsed* _tmp1_;
				GList* _tmp2_;
				GList* _tmp3_;
				GList* _tmp4_;
				gconstpointer _tmp5_;
				GcrImporter* _tmp6_;
				GcrImporter* _tmp7_;
				GcrParsed* _tmp8_;
				GcrImporter* _tmp9_;
#line 151 "../src/import-dialog.vala"
				_data3_ = g_slice_new0 (Block3Data);
#line 151 "../src/import-dialog.vala"
				_data3_->_ref_count_ = 1;
#line 151 "../src/import-dialog.vala"
				_data3_->self = g_object_ref (self);
#line 152 "../src/import-dialog.vala"
				_tmp1_ = parsed;
#line 152 "../src/import-dialog.vala"
				_tmp2_ = gcr_importer_create_for_parsed (_tmp1_);
#line 152 "../src/import-dialog.vala"
				importers = _tmp2_;
#line 153 "../src/import-dialog.vala"
				_tmp3_ = importers;
#line 153 "../src/import-dialog.vala"
				if (g_list_length (_tmp3_) == ((guint) 0)) {
#line 154 "../src/import-dialog.vala"
					g_warning ("import-dialog.vala:154: No importers available. How was the import act" \
"ion called?");
#line 155 "../src/import-dialog.vala"
					(importers == NULL) ? NULL : (importers = (_g_list_free__g_object_unref0_ (importers), NULL));
#line 155 "../src/import-dialog.vala"
					block3_data_unref (_data3_);
#line 155 "../src/import-dialog.vala"
					_data3_ = NULL;
#line 155 "../src/import-dialog.vala"
					return;
#line 1263 "import-dialog.c"
				}
#line 158 "../src/import-dialog.vala"
				_tmp4_ = importers;
#line 158 "../src/import-dialog.vala"
				_tmp5_ = _tmp4_->data;
#line 158 "../src/import-dialog.vala"
				_tmp6_ = _g_object_ref0 ((GcrImporter*) _tmp5_);
#line 158 "../src/import-dialog.vala"
				_data3_->importer = _tmp6_;
#line 159 "../src/import-dialog.vala"
				_tmp7_ = _data3_->importer;
#line 159 "../src/import-dialog.vala"
				_tmp8_ = parsed;
#line 159 "../src/import-dialog.vala"
				gcr_importer_queue_for_parsed (_tmp7_, _tmp8_);
#line 160 "../src/import-dialog.vala"
				_tmp9_ = _data3_->importer;
#line 160 "../src/import-dialog.vala"
				gcr_importer_import_async (_tmp9_, NULL, _____lambda10__gasync_ready_callback, block3_data_ref (_data3_));
#line 151 "../src/import-dialog.vala"
				(importers == NULL) ? NULL : (importers = (_g_list_free__g_object_unref0_ (importers), NULL));
#line 151 "../src/import-dialog.vala"
				block3_data_unref (_data3_);
#line 151 "../src/import-dialog.vala"
				_data3_ = NULL;
#line 1289 "import-dialog.c"
			}
		}
	}
}

static void
seahorse_import_dialog_show_error (SeahorseImportDialog* self,
                                   const gchar* message)
{
	GtkLabel* label = NULL;
	GtkLabel* _tmp0_;
	GtkBox* _tmp1_;
#line 173 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/import-dialog.vala"
	g_return_if_fail (message != NULL);
#line 174 "../src/import-dialog.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (message);
#line 174 "../src/import-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 174 "../src/import-dialog.vala"
	label = _tmp0_;
#line 175 "../src/import-dialog.vala"
	gtk_label_set_wrap (label, TRUE);
#line 176 "../src/import-dialog.vala"
	gtk_widget_add_css_class ((GtkWidget*) label, "error");
#line 177 "../src/import-dialog.vala"
	_tmp1_ = self->priv->container;
#line 177 "../src/import-dialog.vala"
	gtk_box_prepend (_tmp1_, (GtkWidget*) label);
#line 173 "../src/import-dialog.vala"
	_g_object_unref0 (label);
#line 1322 "import-dialog.c"
}

GInputStream*
seahorse_import_dialog_get_input (SeahorseImportDialog* self)
{
	GInputStream* result;
	GInputStream* _tmp0_;
#line 30 "../src/import-dialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/import-dialog.vala"
	_tmp0_ = self->priv->_input;
#line 30 "../src/import-dialog.vala"
	result = _tmp0_;
#line 30 "../src/import-dialog.vala"
	return result;
#line 1338 "import-dialog.c"
}

void
seahorse_import_dialog_set_input (SeahorseImportDialog* self,
                                  GInputStream* value)
{
	GInputStream* old_value;
#line 30 "../src/import-dialog.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/import-dialog.vala"
	old_value = seahorse_import_dialog_get_input (self);
#line 30 "../src/import-dialog.vala"
	if (old_value != value) {
#line 1352 "import-dialog.c"
		GInputStream* _tmp0_;
#line 30 "../src/import-dialog.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 30 "../src/import-dialog.vala"
		_g_object_unref0 (self->priv->_input);
#line 30 "../src/import-dialog.vala"
		self->priv->_input = _tmp0_;
#line 30 "../src/import-dialog.vala"
		g_object_notify_by_pspec ((GObject *) self, seahorse_import_dialog_properties[SEAHORSE_IMPORT_DIALOG_INPUT_PROPERTY]);
#line 1362 "import-dialog.c"
	}
}

static void
_seahorse_import_dialog_on_parser_parsed_gcr_parser_parsed (GcrParser* _sender,
                                                            gpointer self)
{
#line 41 "../src/import-dialog.vala"
	seahorse_import_dialog_on_parser_parsed ((SeahorseImportDialog*) self, _sender);
#line 1372 "import-dialog.c"
}

static gboolean
_seahorse_import_dialog_on_parser_authenticate_gcr_parser_authenticate (GcrParser* _sender,
                                                                        gint count,
                                                                        gpointer self)
{
	gboolean result;
	result = seahorse_import_dialog_on_parser_authenticate ((SeahorseImportDialog*) self, _sender, count);
#line 42 "../src/import-dialog.vala"
	return result;
#line 1384 "import-dialog.c"
}

static GObject *
seahorse_import_dialog_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseImportDialog * self;
	GcrParser* _tmp0_;
	GcrParser* _tmp1_;
	GcrParser* _tmp2_;
#line 36 "../src/import-dialog.vala"
	parent_class = G_OBJECT_CLASS (seahorse_import_dialog_parent_class);
#line 36 "../src/import-dialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 36 "../src/import-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialog);
#line 37 "../src/import-dialog.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "import-all", FALSE);
#line 40 "../src/import-dialog.vala"
	_tmp0_ = gcr_parser_new ();
#line 40 "../src/import-dialog.vala"
	_g_object_unref0 (self->priv->parser);
#line 40 "../src/import-dialog.vala"
	self->priv->parser = _tmp0_;
#line 41 "../src/import-dialog.vala"
	_tmp1_ = self->priv->parser;
#line 41 "../src/import-dialog.vala"
	g_signal_connect_object (_tmp1_, "parsed", (GCallback) _seahorse_import_dialog_on_parser_parsed_gcr_parser_parsed, self, 0);
#line 42 "../src/import-dialog.vala"
	_tmp2_ = self->priv->parser;
#line 42 "../src/import-dialog.vala"
	g_signal_connect_object (_tmp2_, "authenticate", (GCallback) _seahorse_import_dialog_on_parser_authenticate_gcr_parser_authenticate, self, 0);
#line 44 "../src/import-dialog.vala"
	seahorse_import_dialog_parse_input (self, NULL, NULL);
#line 36 "../src/import-dialog.vala"
	return obj;
#line 1424 "import-dialog.c"
}

static void
seahorse_import_dialog_class_init (SeahorseImportDialogClass * klass,
                                   gpointer klass_data)
{
#line 23 "../src/import-dialog.vala"
	seahorse_import_dialog_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/import-dialog.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseImportDialog_private_offset);
#line 23 "../src/import-dialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_import_dialog_get_property;
#line 23 "../src/import-dialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_import_dialog_set_property;
#line 23 "../src/import-dialog.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_import_dialog_constructor;
#line 23 "../src/import-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_import_dialog_finalize;
#line 23 "../src/import-dialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_IMPORT_DIALOG_INPUT_PROPERTY, seahorse_import_dialog_properties[SEAHORSE_IMPORT_DIALOG_INPUT_PROPERTY] = g_param_spec_object ("input", "input", "input", g_input_stream_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 23 "../src/import-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Seahorse/import-dialog.ui");
#line 23 "../src/import-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "container", FALSE, SeahorseImportDialog_private_offset + G_STRUCT_OFFSET (SeahorseImportDialogPrivate, container));
#line 33 "../src/import-dialog.vala"
	gtk_widget_class_install_action (GTK_WIDGET_CLASS (klass), "import-all", NULL, (GtkWidgetActionActivateFunc) seahorse_import_dialog_action_import_all);
#line 1451 "import-dialog.c"
}

static void
seahorse_import_dialog_instance_init (SeahorseImportDialog * self,
                                      gpointer klass)
{
	GPtrArray* _tmp0_;
#line 23 "../src/import-dialog.vala"
	self->priv = seahorse_import_dialog_get_instance_private (self);
#line 28 "../src/import-dialog.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, __vala_GcrParsed_free0_);
#line 28 "../src/import-dialog.vala"
	self->priv->parsed_items = _tmp0_;
#line 23 "../src/import-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1467 "import-dialog.c"
}

static void
seahorse_import_dialog_finalize (GObject * obj)
{
	SeahorseImportDialog * self;
#line 23 "../src/import-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialog);
#line 27 "../src/import-dialog.vala"
	_g_object_unref0 (self->priv->parser);
#line 28 "../src/import-dialog.vala"
	_g_ptr_array_unref0 (self->priv->parsed_items);
#line 30 "../src/import-dialog.vala"
	_g_object_unref0 (self->priv->_input);
#line 23 "../src/import-dialog.vala"
	G_OBJECT_CLASS (seahorse_import_dialog_parent_class)->finalize (obj);
#line 1484 "import-dialog.c"
}

 G_GNUC_NO_INLINE static GType
seahorse_import_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseImportDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_import_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseImportDialog), 0, (GInstanceInitFunc) seahorse_import_dialog_instance_init, NULL };
	GType seahorse_import_dialog_type_id;
	seahorse_import_dialog_type_id = g_type_register_static (adw_window_get_type (), "SeahorseImportDialog", &g_define_type_info, 0);
	SeahorseImportDialog_private_offset = g_type_add_instance_private (seahorse_import_dialog_type_id, sizeof (SeahorseImportDialogPrivate));
	return seahorse_import_dialog_type_id;
}

GType
seahorse_import_dialog_get_type (void)
{
	static gsize seahorse_import_dialog_type_id__once = 0;
	if (g_once_init_enter (&seahorse_import_dialog_type_id__once)) {
		GType seahorse_import_dialog_type_id;
		seahorse_import_dialog_type_id = seahorse_import_dialog_get_type_once ();
		g_once_init_leave (&seahorse_import_dialog_type_id__once, seahorse_import_dialog_type_id);
	}
	return seahorse_import_dialog_type_id__once;
}

static void
_vala_seahorse_import_dialog_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	SeahorseImportDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialog);
#line 23 "../src/import-dialog.vala"
	switch (property_id) {
#line 23 "../src/import-dialog.vala"
		case SEAHORSE_IMPORT_DIALOG_INPUT_PROPERTY:
#line 23 "../src/import-dialog.vala"
		g_value_set_object (value, seahorse_import_dialog_get_input (self));
#line 23 "../src/import-dialog.vala"
		break;
#line 1525 "import-dialog.c"
		default:
#line 23 "../src/import-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/import-dialog.vala"
		break;
#line 1531 "import-dialog.c"
	}
}

static void
_vala_seahorse_import_dialog_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	SeahorseImportDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_TYPE_IMPORT_DIALOG, SeahorseImportDialog);
#line 23 "../src/import-dialog.vala"
	switch (property_id) {
#line 23 "../src/import-dialog.vala"
		case SEAHORSE_IMPORT_DIALOG_INPUT_PROPERTY:
#line 23 "../src/import-dialog.vala"
		seahorse_import_dialog_set_input (self, g_value_get_object (value));
#line 23 "../src/import-dialog.vala"
		break;
#line 1551 "import-dialog.c"
		default:
#line 23 "../src/import-dialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/import-dialog.vala"
		break;
#line 1557 "import-dialog.c"
	}
}

