/* source.c generated by valac 0.56.18, the Vala compiler
 * generated from source.vala, do not modify */

/*
 * Seahorse
 *
 * Copyright (C) 2004-2006 Stefan Walter
 * Copyright (C) 2011 Collabora Ltd.
 * Copyright (c) 2016 Niels De Graef
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see
 * <http://www.gnu.org/licenses/>.
 */

#include "seahorse-ssh.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include "seahorse-common.h"
#include <glib-object.h>
#include <gtk/gtk.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SEAHORSE_SSH_SOURCE_0_PROPERTY,
	SEAHORSE_SSH_SOURCE_LABEL_PROPERTY,
	SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY,
	SEAHORSE_SSH_SOURCE_URI_PROPERTY,
	SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY,
	SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY,
	SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY,
	SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY,
	SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY,
	SEAHORSE_SSH_SOURCE_NUM_PROPERTIES
};
static GParamSpec* seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _SeahorseSshSourceAddKeyFromFilenameData SeahorseSshSourceAddKeyFromFilenameData;
typedef struct _SeahorseSshSourceLoadKeyForPrivateFileData SeahorseSshSourceLoadKeyForPrivateFileData;
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
typedef struct _SeahorseSshSourceLoadData SeahorseSshSourceLoadData;
typedef struct _SeahorseSshSourceImportAsyncData SeahorseSshSourceImportAsyncData;
typedef struct _SeahorseSshSourceImportPublicAsyncData SeahorseSshSourceImportPublicAsyncData;
typedef struct _Block6Data Block6Data;
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
typedef struct _SeahorseSshSourceAuthorizeAsyncData SeahorseSshSourceAuthorizeAsyncData;

struct _SeahorseSshSourcePrivate {
	gchar* ssh_homedir;
	guint scheduled_refresh_source;
	GFileMonitor* monitor_handle;
	GPtrArray* keys;
};

struct _SeahorseSshSourceAddKeyFromFilenameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	gchar* privfile;
	SeahorseSshKey* result;
	guint i;
	gboolean _tmp0_;
	guint _tmp1_;
	GPtrArray* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	SeahorseSshKey* key;
	GPtrArray* _tmp5_;
	gconstpointer _tmp6_;
	SeahorseSshKey* _tmp7_;
	SeahorseSshKeyData* _tmp8_;
	SeahorseSshKeyData* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	SeahorseSshKey* _tmp12_;
	SeahorseSshKey* _tmp13_;
	SeahorseSshKey* _tmp14_;
	SeahorseSshKey* _tmp15_;
	SeahorseSshKey* _tmp16_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceLoadKeyForPrivateFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	gchar* privfile;
	SeahorseSshKey* result;
	gchar* pubfile;
	gchar* _tmp0_;
	SeahorseSshKey* key;
	gboolean _tmp1_;
	gboolean _tmp2_;
	const gchar* _tmp3_;
	SeahorseSshKeyKeyParseResult _result_;
	const gchar* _tmp4_;
	SeahorseSshKeyKeyParseResult _tmp5_;
	SeahorseSshKeyKeyParseResult _tmp6_;
	SeahorseSshKeyData** _tmp7_;
	gint _tmp7__length1;
	SeahorseSshKeyData** keydata_collection;
	gint keydata_collection_length1;
	gint _keydata_collection_size_;
	gint keydata_it;
	SeahorseSshKeyData* keydata;
	SeahorseSshKeyData* _tmp8_;
	const gchar* _tmp9_;
	SeahorseSshKey* _tmp10_;
	GError* e;
	const gchar* _tmp11_;
	GError* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GError* _tmp16_;
	GError* _tmp17_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceLoadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	GCancellable* cancellable;
	gboolean result;
	GDir* dir;
	const gchar* _tmp0_;
	GDir* _tmp1_;
	gchar* filename;
	GDir* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* privfile;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	gchar* pubfile;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	SeahorseSshKeyKeyParseResult _result_;
	const gchar* _tmp12_;
	SeahorseSshKeyKeyParseResult _tmp13_;
	SeahorseSshKeyKeyParseResult _tmp14_;
	SeahorseSshKeyData** _tmp15_;
	gint _tmp15__length1;
	SeahorseSshKeyData** keydata_collection;
	gint keydata_collection_length1;
	gint _keydata_collection_size_;
	gint keydata_it;
	SeahorseSshKeyData* keydata;
	SeahorseSshKeyData* _tmp16_;
	const gchar* _tmp17_;
	SeahorseSshKey* _tmp18_;
	SeahorseSshKey* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	SeahorseSshKeyKeyParseResult _vala1__result_;
	const gchar* _tmp22_;
	SeahorseSshKeyKeyParseResult _tmp23_;
	SeahorseSshKeyKeyParseResult _tmp24_;
	SeahorseSshKeyData** _tmp25_;
	gint _tmp25__length1;
	SeahorseSshKeyData** _vala1_keydata_collection;
	gint _vala1_keydata_collection_length1;
	gint __vala1_keydata_collection_size_;
	gint _vala1_keydata_it;
	SeahorseSshKeyData* _vala1_keydata;
	SeahorseSshKeyData* _tmp26_;
	const gchar* _tmp27_;
	SeahorseSshKey* _tmp28_;
	SeahorseSshKey* _tmp29_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceImportAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	GInputStream* input;
	GtkWindow* transient_for;
	GCancellable* cancellable;
	GList* result;
	SeahorseSshKeyKeyParseResult _result_;
	SeahorseSshKeyKeyParseResult _tmp0_;
	gchar* fullpath;
	gchar* _tmp1_;
	SeahorseSshKeyKeyParseResult _tmp2_;
	SeahorseSshKeyData** _tmp3_;
	gint _tmp3__length1;
	SeahorseSshKeyData** keydata_collection;
	gint keydata_collection_length1;
	gint _keydata_collection_size_;
	gint keydata_it;
	SeahorseSshKeyData* keydata;
	SeahorseSshKeyData* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	SeahorseSshKeyKeyParseResult _tmp8_;
	SeahorseSshSecData** _tmp9_;
	gint _tmp9__length1;
	SeahorseSshSecData** secdata_collection;
	gint secdata_collection_length1;
	gint _secdata_collection_size_;
	gint secdata_it;
	SeahorseSshSecData* secdata;
	SeahorseSshPrivateImportOperation* op;
	SeahorseSshPrivateImportOperation* _tmp10_;
	SeahorseSshPrivateImportOperation* _tmp11_;
	SeahorseSshSecData* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GError* _inner_error0_;
};

struct _SeahorseSshSourceImportPublicAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	SeahorseSshKeyData* data;
	gchar* filename;
	GCancellable* cancellable;
	gchar* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _inner_error0_;
};

struct _Block6Data {
	int _ref_count_;
	SeahorseSshSource* self;
	GSourceFunc callback;
	gpointer callback_target;
	GDestroyNotify callback_target_destroy_notify;
	GError* err;
	gchar* from;
	gchar* to;
	SeahorseSshKey* key;
	gpointer _async_data_;
};

struct _SeahorseSshSourceAuthorizeAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SeahorseSshSource* self;
	SeahorseSshKey* key;
	gboolean authorize;
	Block6Data* _data6_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GThread* thread;
	GThread* _tmp4_;
	GThread* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GError* _inner_error0_;
};

static gint SeahorseSshSource_private_offset;
static gpointer seahorse_ssh_source_parent_class = NULL;
static GListModelInterface * seahorse_ssh_source_g_list_model_parent_iface = NULL;
static SeahorsePlaceIface * seahorse_ssh_source_seahorse_place_parent_iface = NULL;

static void _g_object_unref0_ (gpointer var);
static gboolean seahorse_ssh_source_check_file_for_ssh (SeahorseSshSource* self,
                                                 const gchar* filename);
static void seahorse_ssh_source_cancel_scheduled_refresh (SeahorseSshSource* self);
static gboolean seahorse_ssh_source_scheduled_refresh (SeahorseSshSource* self);
static gboolean seahorse_ssh_source_scheduled_dummy (SeahorseSshSource* self);
static void seahorse_ssh_source_monitor_ssh_homedir (SeahorseSshSource* self);
static void ___lambda17_ (SeahorseSshSource* self,
                   GFile* file,
                   GFile* other_file,
                   GFileMonitorEvent event_type);
static gboolean _seahorse_ssh_source_scheduled_refresh_gsource_func (gpointer self);
static void ____lambda17__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static GType seahorse_ssh_source_real_get_item_type (GListModel* base);
static guint seahorse_ssh_source_real_get_n_items (GListModel* base);
static GObject* seahorse_ssh_source_real_get_item (GListModel* base,
                                            guint index);
static void seahorse_ssh_source_add_key_from_filename_data_free (gpointer _data);
static gboolean seahorse_ssh_source_add_key_from_filename_co (SeahorseSshSourceAddKeyFromFilenameData* _data_);
static void seahorse_ssh_source_load_key_for_private_file (SeahorseSshSource* self,
                                                    const gchar* privfile,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static SeahorseSshKey* seahorse_ssh_source_load_key_for_private_file_finish (SeahorseSshSource* self,
                                                                      GAsyncResult* _res_,
                                                                      GError** error);
static void seahorse_ssh_source_add_key_from_filename_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void seahorse_ssh_source_load_key_for_private_file_data_free (gpointer _data);
static gboolean seahorse_ssh_source_load_key_for_private_file_co (SeahorseSshSourceLoadKeyForPrivateFileData* _data_);
static void seahorse_ssh_source_load_key_for_private_file_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void seahorse_ssh_source_real_load_data_free (gpointer _data);
static void seahorse_ssh_source_real_load (SeahorsePlace* base,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
static gboolean seahorse_ssh_source_real_load_co (SeahorseSshSourceLoadData* _data_);
static gboolean _seahorse_ssh_source_scheduled_dummy_gsource_func (gpointer self);
static void ___lambda16_ (SeahorseSshSource* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ____lambda16__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void seahorse_ssh_source_load_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void seahorse_ssh_source_import_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_import_async_co (SeahorseSshSourceImportAsyncData* _data_);
static void seahorse_ssh_source_import_async_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void seahorse_ssh_source_import_public_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_import_public_async_co (SeahorseSshSourceImportPublicAsyncData* _data_);
static void seahorse_ssh_source_authorize_async_data_free (gpointer _data);
static gboolean seahorse_ssh_source_authorize_async_co (SeahorseSshSourceAuthorizeAsyncData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean _seahorse_ssh_source_authorize_async_co_gsource_func (gpointer self);
static void* __lambda13_ (Block6Data* _data6_);
static void seahorse_ssh_source_ensure_file_exists (SeahorseSshSource* self,
                                             const gchar* filename);
static gpointer ___lambda13__gthread_func (gpointer self);
static GObject * seahorse_ssh_source_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void seahorse_ssh_source_finalize (GObject * obj);
static GType seahorse_ssh_source_get_type_once (void);
static void _vala_seahorse_ssh_source_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_seahorse_ssh_source_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
seahorse_ssh_source_get_instance_private (SeahorseSshSource* self)
{
	return G_STRUCT_MEMBER_P (self, SeahorseSshSource_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 43 "../ssh/source.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 411 "source.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 430 "source.c"
}

static gboolean
seahorse_ssh_source_check_file_for_ssh (SeahorseSshSource* self,
                                        const gchar* filename)
{
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 95 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 95 "../ssh/source.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 96 "../ssh/source.vala"
	if (!g_file_test (filename, G_FILE_TEST_IS_REGULAR)) {
#line 97 "../ssh/source.vala"
		result = FALSE;
#line 97 "../ssh/source.vala"
		return result;
#line 449 "source.c"
	}
	{
		gchar* contents = NULL;
		gchar* _tmp0_ = NULL;
		const gchar* _tmp2_;
#line 101 "../ssh/source.vala"
		g_file_get_contents (filename, &_tmp0_, NULL, &_inner_error0_);
#line 101 "../ssh/source.vala"
		_g_free0 (contents);
#line 101 "../ssh/source.vala"
		contents = _tmp0_;
#line 101 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 463 "source.c"
			gboolean _tmp1_ = FALSE;
#line 101 "../ssh/source.vala"
			_g_free0 (contents);
#line 101 "../ssh/source.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 469 "source.c"
				goto __catch0_g_file_error;
			}
#line 101 "../ssh/source.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 101 "../ssh/source.vala"
			g_clear_error (&_inner_error0_);
#line 101 "../ssh/source.vala"
			return _tmp1_;
#line 478 "source.c"
		}
#line 104 "../ssh/source.vala"
		_tmp2_ = contents;
#line 104 "../ssh/source.vala"
		result = string_contains (_tmp2_, " PRIVATE KEY-----");
#line 104 "../ssh/source.vala"
		_g_free0 (contents);
#line 104 "../ssh/source.vala"
		return result;
#line 488 "source.c"
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 99 "../ssh/source.vala"
		e = _inner_error0_;
#line 99 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 106 "../ssh/source.vala"
		_tmp3_ = e;
#line 106 "../ssh/source.vala"
		_tmp4_ = _tmp3_->message;
#line 106 "../ssh/source.vala"
		_tmp5_ = g_strdup_printf ("Error reading file '%s' to check for SSH key. %s", filename, _tmp4_);
#line 106 "../ssh/source.vala"
		_tmp6_ = _tmp5_;
#line 106 "../ssh/source.vala"
		g_warning ("source.vala:106: %s", _tmp6_);
#line 106 "../ssh/source.vala"
		_g_free0 (_tmp6_);
#line 99 "../ssh/source.vala"
		_g_error_free0 (e);
#line 516 "source.c"
	}
	__finally0:
#line 99 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 521 "source.c"
		gboolean _tmp7_ = FALSE;
#line 99 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 99 "../ssh/source.vala"
		return _tmp7_;
#line 529 "source.c"
	}
#line 109 "../ssh/source.vala"
	result = FALSE;
#line 109 "../ssh/source.vala"
	return result;
#line 535 "source.c"
}

static void
seahorse_ssh_source_cancel_scheduled_refresh (SeahorseSshSource* self)
{
#line 112 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 113 "../ssh/source.vala"
	if (self->priv->scheduled_refresh_source != ((guint) 0)) {
#line 114 "../ssh/source.vala"
		g_debug ("source.vala:114: Cancelling scheduled refresh event");
#line 115 "../ssh/source.vala"
		g_source_remove (self->priv->scheduled_refresh_source);
#line 116 "../ssh/source.vala"
		self->priv->scheduled_refresh_source = (guint) 0;
#line 551 "source.c"
	}
}

static gboolean
seahorse_ssh_source_scheduled_refresh (SeahorseSshSource* self)
{
	gboolean result;
#line 120 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 121 "../ssh/source.vala"
	g_debug ("source.vala:121: Scheduled refresh event ocurring now");
#line 122 "../ssh/source.vala"
	seahorse_ssh_source_cancel_scheduled_refresh (self);
#line 123 "../ssh/source.vala"
	seahorse_place_load ((SeahorsePlace*) self, NULL, NULL, NULL);
#line 124 "../ssh/source.vala"
	result = FALSE;
#line 124 "../ssh/source.vala"
	return result;
#line 571 "source.c"
}

static gboolean
seahorse_ssh_source_scheduled_dummy (SeahorseSshSource* self)
{
	gboolean result;
#line 127 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../ssh/source.vala"
	g_debug ("source.vala:128: Dummy refresh event occurring now");
#line 129 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = (guint) 0;
#line 130 "../ssh/source.vala"
	result = FALSE;
#line 130 "../ssh/source.vala"
	return result;
#line 588 "source.c"
}

static gboolean
_seahorse_ssh_source_scheduled_refresh_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_scheduled_refresh ((SeahorseSshSource*) self);
#line 161 "../ssh/source.vala"
	return result;
#line 598 "source.c"
}

static void
___lambda17_ (SeahorseSshSource* self,
              GFile* file,
              GFile* other_file,
              GFileMonitorEvent event_type)
{
	gboolean _tmp0_ = FALSE;
	gchar* path = NULL;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
#line 140 "../ssh/source.vala"
	g_return_if_fail (file != NULL);
#line 141 "../ssh/source.vala"
	if (self->priv->scheduled_refresh_source != ((guint) 0)) {
#line 141 "../ssh/source.vala"
		_tmp0_ = TRUE;
#line 621 "source.c"
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
#line 142 "../ssh/source.vala"
		if (event_type != G_FILE_MONITOR_EVENT_CHANGED) {
#line 143 "../ssh/source.vala"
			_tmp3_ = event_type != G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT;
#line 630 "source.c"
		} else {
#line 142 "../ssh/source.vala"
			_tmp3_ = FALSE;
#line 634 "source.c"
		}
#line 142 "../ssh/source.vala"
		if (_tmp3_) {
#line 144 "../ssh/source.vala"
			_tmp2_ = event_type != G_FILE_MONITOR_EVENT_DELETED;
#line 640 "source.c"
		} else {
#line 142 "../ssh/source.vala"
			_tmp2_ = FALSE;
#line 644 "source.c"
		}
#line 142 "../ssh/source.vala"
		if (_tmp2_) {
#line 145 "../ssh/source.vala"
			_tmp1_ = event_type != G_FILE_MONITOR_EVENT_CREATED;
#line 650 "source.c"
		} else {
#line 142 "../ssh/source.vala"
			_tmp1_ = FALSE;
#line 654 "source.c"
		}
#line 142 "../ssh/source.vala"
		_tmp0_ = _tmp1_;
#line 658 "source.c"
	}
#line 141 "../ssh/source.vala"
	if (_tmp0_) {
#line 146 "../ssh/source.vala"
		return;
#line 664 "source.c"
	}
#line 148 "../ssh/source.vala"
	_tmp4_ = g_file_get_path (file);
#line 148 "../ssh/source.vala"
	path = _tmp4_;
#line 149 "../ssh/source.vala"
	_tmp5_ = path;
#line 149 "../ssh/source.vala"
	if (_tmp5_ == NULL) {
#line 150 "../ssh/source.vala"
		_g_free0 (path);
#line 150 "../ssh/source.vala"
		return;
#line 678 "source.c"
	}
#line 153 "../ssh/source.vala"
	if (event_type != G_FILE_MONITOR_EVENT_DELETED) {
#line 682 "source.c"
		const gchar* _tmp10_;
#line 154 "../ssh/source.vala"
		_tmp10_ = path;
#line 154 "../ssh/source.vala"
		_tmp9_ = !g_str_has_suffix (_tmp10_, SEAHORSE_SSH_SOURCE_AUTHORIZED_KEYS_FILE);
#line 688 "source.c"
	} else {
#line 153 "../ssh/source.vala"
		_tmp9_ = FALSE;
#line 692 "source.c"
	}
#line 153 "../ssh/source.vala"
	if (_tmp9_) {
#line 696 "source.c"
		const gchar* _tmp11_;
#line 155 "../ssh/source.vala"
		_tmp11_ = path;
#line 155 "../ssh/source.vala"
		_tmp8_ = !g_str_has_suffix (_tmp11_, SEAHORSE_SSH_SOURCE_OTHER_KEYS_FILE);
#line 702 "source.c"
	} else {
#line 153 "../ssh/source.vala"
		_tmp8_ = FALSE;
#line 706 "source.c"
	}
#line 153 "../ssh/source.vala"
	if (_tmp8_) {
#line 710 "source.c"
		const gchar* _tmp12_;
#line 156 "../ssh/source.vala"
		_tmp12_ = path;
#line 156 "../ssh/source.vala"
		_tmp7_ = !g_str_has_suffix (_tmp12_, ".pub");
#line 716 "source.c"
	} else {
#line 153 "../ssh/source.vala"
		_tmp7_ = FALSE;
#line 720 "source.c"
	}
#line 153 "../ssh/source.vala"
	if (_tmp7_) {
#line 724 "source.c"
		const gchar* _tmp13_;
#line 157 "../ssh/source.vala"
		_tmp13_ = path;
#line 157 "../ssh/source.vala"
		_tmp6_ = !seahorse_ssh_sec_data_contains_private_key (_tmp13_);
#line 730 "source.c"
	} else {
#line 153 "../ssh/source.vala"
		_tmp6_ = FALSE;
#line 734 "source.c"
	}
#line 153 "../ssh/source.vala"
	if (_tmp6_) {
#line 158 "../ssh/source.vala"
		_g_free0 (path);
#line 158 "../ssh/source.vala"
		return;
#line 742 "source.c"
	}
#line 160 "../ssh/source.vala"
	g_debug ("source.vala:160: Scheduling refresh event due to file changes");
#line 161 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _seahorse_ssh_source_scheduled_refresh_gsource_func, g_object_ref (self), g_object_unref);
#line 140 "../ssh/source.vala"
	_g_free0 (path);
#line 750 "source.c"
}

static void
____lambda17__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
#line 140 "../ssh/source.vala"
	___lambda17_ ((SeahorseSshSource*) self, file, other_file, event_type);
#line 762 "source.c"
}

static void
seahorse_ssh_source_monitor_ssh_homedir (SeahorseSshSource* self)
{
	GFile* dot_ssh_dir = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 133 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 134 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 134 "../ssh/source.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 134 "../ssh/source.vala"
	dot_ssh_dir = _tmp1_;
#line 135 "../ssh/source.vala"
	_tmp2_ = dot_ssh_dir;
#line 135 "../ssh/source.vala"
	if (_tmp2_ == NULL) {
#line 136 "../ssh/source.vala"
		_g_object_unref0 (dot_ssh_dir);
#line 136 "../ssh/source.vala"
		return;
#line 789 "source.c"
	}
	{
		GFileMonitor* _tmp3_ = NULL;
		GFile* _tmp4_;
		GFileMonitor* _tmp5_;
		GFileMonitor* _tmp6_;
		GFileMonitor* _tmp7_;
#line 139 "../ssh/source.vala"
		_tmp4_ = dot_ssh_dir;
#line 139 "../ssh/source.vala"
		_tmp5_ = g_file_monitor_directory (_tmp4_, G_FILE_MONITOR_NONE, NULL, &_inner_error0_);
#line 139 "../ssh/source.vala"
		_tmp3_ = _tmp5_;
#line 139 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 805 "source.c"
			goto __catch0_g_error;
		}
#line 139 "../ssh/source.vala"
		_tmp6_ = _tmp3_;
#line 139 "../ssh/source.vala"
		_tmp3_ = NULL;
#line 139 "../ssh/source.vala"
		_g_object_unref0 (self->priv->monitor_handle);
#line 139 "../ssh/source.vala"
		self->priv->monitor_handle = _tmp6_;
#line 140 "../ssh/source.vala"
		_tmp7_ = self->priv->monitor_handle;
#line 140 "../ssh/source.vala"
		g_signal_connect_object (_tmp7_, "changed", (GCallback) ____lambda17__g_file_monitor_changed, self, 0);
#line 138 "../ssh/source.vala"
		_g_object_unref0 (_tmp3_);
#line 822 "source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 138 "../ssh/source.vala"
		e = _inner_error0_;
#line 138 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 164 "../ssh/source.vala"
		_tmp8_ = self->priv->ssh_homedir;
#line 164 "../ssh/source.vala"
		_tmp9_ = e;
#line 164 "../ssh/source.vala"
		_tmp10_ = _tmp9_->message;
#line 164 "../ssh/source.vala"
		g_warning ("source.vala:164: couldn't monitor ssh directory: %s: %s", _tmp8_, _tmp10_);
#line 138 "../ssh/source.vala"
		_g_error_free0 (e);
#line 845 "source.c"
	}
	__finally0:
#line 138 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 138 "../ssh/source.vala"
		_g_object_unref0 (dot_ssh_dir);
#line 138 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 138 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 138 "../ssh/source.vala"
		return;
#line 858 "source.c"
	}
#line 133 "../ssh/source.vala"
	_g_object_unref0 (dot_ssh_dir);
#line 862 "source.c"
}

static GType
seahorse_ssh_source_real_get_item_type (GListModel* base)
{
	SeahorseSshSource * self;
	GType result;
#line 168 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 169 "../ssh/source.vala"
	result = SEAHORSE_SSH_TYPE_KEY;
#line 169 "../ssh/source.vala"
	return result;
#line 876 "source.c"
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
#line 5954 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5955 "glib-2.0.vapi"
	result = (gint) self->len;
#line 5955 "glib-2.0.vapi"
	return result;
#line 889 "source.c"
}

static guint
seahorse_ssh_source_real_get_n_items (GListModel* base)
{
	SeahorseSshSource * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint result;
#line 172 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 173 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 173 "../ssh/source.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 173 "../ssh/source.vala"
	_tmp2_ = _tmp1_;
#line 173 "../ssh/source.vala"
	result = (guint) _tmp2_;
#line 173 "../ssh/source.vala"
	return result;
#line 912 "source.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 179 "../ssh/source.vala"
	return self ? g_object_ref (self) : NULL;
#line 920 "source.c"
}

static GObject*
seahorse_ssh_source_real_get_item (GListModel* base,
                                   guint index)
{
	SeahorseSshSource * self;
	GPtrArray* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GPtrArray* _tmp3_;
	gconstpointer _tmp4_;
	GObject* _tmp5_;
	GObject* result;
#line 176 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 177 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 177 "../ssh/source.vala"
	_tmp1_ = vala_g_ptr_array_get_length (_tmp0_);
#line 177 "../ssh/source.vala"
	_tmp2_ = _tmp1_;
#line 177 "../ssh/source.vala"
	if (index >= ((guint) _tmp2_)) {
#line 178 "../ssh/source.vala"
		result = NULL;
#line 178 "../ssh/source.vala"
		return result;
#line 949 "source.c"
	}
#line 179 "../ssh/source.vala"
	_tmp3_ = self->priv->keys;
#line 179 "../ssh/source.vala"
	_tmp4_ = g_ptr_array_index (_tmp3_, index);
#line 179 "../ssh/source.vala"
	_tmp5_ = _g_object_ref0 ((GObject*) ((SeahorseSshKey*) _tmp4_));
#line 179 "../ssh/source.vala"
	result = _tmp5_;
#line 179 "../ssh/source.vala"
	return result;
#line 961 "source.c"
}

void
seahorse_ssh_source_remove_object (SeahorseSshSource* self,
                                   SeahorseSshKey* key)
{
	guint pos = 0U;
	GPtrArray* _tmp0_;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
#line 182 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 182 "../ssh/source.vala"
	g_return_if_fail (key != NULL);
#line 184 "../ssh/source.vala"
	_tmp0_ = self->priv->keys;
#line 184 "../ssh/source.vala"
	_tmp2_ = g_ptr_array_find (_tmp0_, key, &_tmp1_);
#line 184 "../ssh/source.vala"
	pos = _tmp1_;
#line 184 "../ssh/source.vala"
	if (_tmp2_) {
#line 984 "source.c"
		GPtrArray* _tmp3_;
#line 185 "../ssh/source.vala"
		_tmp3_ = self->priv->keys;
#line 185 "../ssh/source.vala"
		g_ptr_array_remove_index (_tmp3_, pos);
#line 186 "../ssh/source.vala"
		g_list_model_items_changed ((GListModel*) self, pos, (guint) 1, (guint) 0);
#line 992 "source.c"
	}
}

gchar*
seahorse_ssh_source_authorized_keys_path (SeahorseSshSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 190 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 191 "../ssh/source.vala"
	_tmp1_ = g_build_filename (_tmp0_, SEAHORSE_SSH_SOURCE_AUTHORIZED_KEYS_FILE, NULL);
#line 191 "../ssh/source.vala"
	result = _tmp1_;
#line 191 "../ssh/source.vala"
	return result;
#line 1012 "source.c"
}

gchar*
seahorse_ssh_source_other_keys_path (SeahorseSshSource* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 194 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 195 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 195 "../ssh/source.vala"
	_tmp1_ = g_build_filename (_tmp0_, SEAHORSE_SSH_SOURCE_OTHER_KEYS_FILE, NULL);
#line 195 "../ssh/source.vala"
	result = _tmp1_;
#line 195 "../ssh/source.vala"
	return result;
#line 1031 "source.c"
}

static void
seahorse_ssh_source_add_key_from_filename_data_free (gpointer _data)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceAddKeyFromFilenameData, _data_);
#line 1047 "source.c"
}

void
seahorse_ssh_source_add_key_from_filename (SeahorseSshSource* self,
                                           const gchar* privfile,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
	SeahorseSshSource* _tmp0_;
	gchar* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceAddKeyFromFilenameData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_add_key_from_filename_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = g_strdup (privfile);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_data_->privfile = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_add_key_from_filename_co (_data_);
#line 1079 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_add_key_from_filename_finish (SeahorseSshSource* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	SeahorseSshKey* result;
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 1095 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 1103 "source.c"
}

static void
seahorse_ssh_source_add_key_from_filename_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	SeahorseSshSourceAddKeyFromFilenameData* _data_;
#line 210 "../ssh/source.vala"
	_data_ = _user_data_;
#line 210 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 210 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 210 "../ssh/source.vala"
	seahorse_ssh_source_add_key_from_filename_co (_data_);
#line 1120 "source.c"
}

static gboolean
seahorse_ssh_source_add_key_from_filename_co (SeahorseSshSourceAddKeyFromFilenameData* _data_)
{
#line 198 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 198 "../ssh/source.vala"
		case 0:
#line 1130 "source.c"
		goto _state_0;
#line 198 "../ssh/source.vala"
		case 1:
#line 1134 "source.c"
		goto _state_1;
		default:
#line 198 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1139 "source.c"
	}
	_state_0:
#line 199 "../ssh/source.vala"
	if (_data_->privfile == NULL) {
#line 200 "../ssh/source.vala"
		_data_->result = NULL;
#line 200 "../ssh/source.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 200 "../ssh/source.vala"
		if (_data_->_state_ != 0) {
#line 200 "../ssh/source.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 200 "../ssh/source.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1154 "source.c"
			}
		}
#line 200 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 200 "../ssh/source.vala"
		return FALSE;
#line 1161 "source.c"
	}
	{
#line 203 "../ssh/source.vala"
		_data_->i = (guint) 0;
#line 1166 "source.c"
		{
#line 203 "../ssh/source.vala"
			_data_->_tmp0_ = TRUE;
#line 203 "../ssh/source.vala"
			while (TRUE) {
#line 203 "../ssh/source.vala"
				if (!_data_->_tmp0_) {
#line 203 "../ssh/source.vala"
					_data_->_tmp1_ = _data_->i;
#line 203 "../ssh/source.vala"
					_data_->i = _data_->_tmp1_ + 1;
#line 1178 "source.c"
				}
#line 203 "../ssh/source.vala"
				_data_->_tmp0_ = FALSE;
#line 203 "../ssh/source.vala"
				_data_->_tmp2_ = _data_->self->priv->keys;
#line 203 "../ssh/source.vala"
				_data_->_tmp3_ = vala_g_ptr_array_get_length (_data_->_tmp2_);
#line 203 "../ssh/source.vala"
				_data_->_tmp4_ = _data_->_tmp3_;
#line 203 "../ssh/source.vala"
				if (!(_data_->i < ((guint) _data_->_tmp4_))) {
#line 203 "../ssh/source.vala"
					break;
#line 1192 "source.c"
				}
#line 204 "../ssh/source.vala"
				_data_->_tmp5_ = _data_->self->priv->keys;
#line 204 "../ssh/source.vala"
				_data_->_tmp6_ = g_ptr_array_index (_data_->_tmp5_, _data_->i);
#line 204 "../ssh/source.vala"
				_data_->key = (SeahorseSshKey*) _data_->_tmp6_;
#line 205 "../ssh/source.vala"
				_data_->_tmp7_ = _data_->key;
#line 205 "../ssh/source.vala"
				_data_->_tmp8_ = seahorse_ssh_key_get_key_data (_data_->_tmp7_);
#line 205 "../ssh/source.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 205 "../ssh/source.vala"
				_data_->_tmp10_ = seahorse_ssh_key_data_get_privfile (_data_->_tmp9_);
#line 205 "../ssh/source.vala"
				_data_->_tmp11_ = _data_->_tmp10_;
#line 205 "../ssh/source.vala"
				if (g_strcmp0 (_data_->_tmp11_, _data_->privfile) == 0) {
#line 206 "../ssh/source.vala"
					_data_->_tmp12_ = _data_->key;
#line 206 "../ssh/source.vala"
					_data_->_tmp13_ = _g_object_ref0 (_data_->_tmp12_);
#line 206 "../ssh/source.vala"
					_data_->result = _data_->_tmp13_;
#line 206 "../ssh/source.vala"
					g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 206 "../ssh/source.vala"
					if (_data_->_state_ != 0) {
#line 206 "../ssh/source.vala"
						while (!g_task_get_completed (_data_->_async_result)) {
#line 206 "../ssh/source.vala"
							g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1226 "source.c"
						}
					}
#line 206 "../ssh/source.vala"
					g_object_unref (_data_->_async_result);
#line 206 "../ssh/source.vala"
					return FALSE;
#line 1233 "source.c"
				}
			}
		}
	}
#line 210 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 210 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file (_data_->self, _data_->privfile, seahorse_ssh_source_add_key_from_filename_ready, _data_);
#line 210 "../ssh/source.vala"
	return FALSE;
#line 1244 "source.c"
	_state_1:
#line 210 "../ssh/source.vala"
	_data_->_tmp15_ = seahorse_ssh_source_load_key_for_private_file_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 210 "../ssh/source.vala"
	_data_->_tmp14_ = _data_->_tmp15_;
#line 210 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 210 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 210 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 210 "../ssh/source.vala"
		return FALSE;
#line 1258 "source.c"
	}
#line 210 "../ssh/source.vala"
	_data_->_tmp16_ = _data_->_tmp14_;
#line 210 "../ssh/source.vala"
	_data_->_tmp14_ = NULL;
#line 210 "../ssh/source.vala"
	_data_->result = _data_->_tmp16_;
#line 210 "../ssh/source.vala"
	_g_object_unref0 (_data_->_tmp14_);
#line 210 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 210 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 210 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 210 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1276 "source.c"
		}
	}
#line 210 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 210 "../ssh/source.vala"
	return FALSE;
#line 1283 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file_data_free (gpointer _data)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceLoadKeyForPrivateFileData, _data_);
#line 1299 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file (SeahorseSshSource* self,
                                               const gchar* privfile,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
	SeahorseSshSource* _tmp0_;
	gchar* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (privfile != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceLoadKeyForPrivateFileData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_load_key_for_private_file_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = g_strdup (privfile);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->privfile);
#line 26 "../ssh/source.vala"
	_data_->privfile = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file_co (_data_);
#line 1333 "source.c"
}

static SeahorseSshKey*
seahorse_ssh_source_load_key_for_private_file_finish (SeahorseSshSource* self,
                                                      GAsyncResult* _res_,
                                                      GError** error)
{
	SeahorseSshKey* result;
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 1349 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 1357 "source.c"
}

static void
seahorse_ssh_source_load_key_for_private_file_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	SeahorseSshSourceLoadKeyForPrivateFileData* _data_;
#line 223 "../ssh/source.vala"
	_data_ = _user_data_;
#line 223 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 223 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 223 "../ssh/source.vala"
	seahorse_ssh_source_load_key_for_private_file_co (_data_);
#line 1374 "source.c"
}

static gboolean
seahorse_ssh_source_load_key_for_private_file_co (SeahorseSshSourceLoadKeyForPrivateFileData* _data_)
{
#line 214 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 214 "../ssh/source.vala"
		case 0:
#line 1384 "source.c"
		goto _state_0;
#line 214 "../ssh/source.vala"
		case 1:
#line 1388 "source.c"
		goto _state_1;
		default:
#line 214 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1393 "source.c"
	}
	_state_0:
#line 215 "../ssh/source.vala"
	_data_->_tmp0_ = g_strconcat (_data_->privfile, ".pub", NULL);
#line 215 "../ssh/source.vala"
	_data_->pubfile = _data_->_tmp0_;
#line 216 "../ssh/source.vala"
	_data_->key = NULL;
#line 219 "../ssh/source.vala"
	if (g_file_test (_data_->privfile, G_FILE_TEST_EXISTS)) {
#line 220 "../ssh/source.vala"
		_data_->_tmp3_ = _data_->pubfile;
#line 220 "../ssh/source.vala"
		_data_->_tmp2_ = g_file_test (_data_->_tmp3_, G_FILE_TEST_EXISTS);
#line 1408 "source.c"
	} else {
#line 219 "../ssh/source.vala"
		_data_->_tmp2_ = FALSE;
#line 1412 "source.c"
	}
#line 219 "../ssh/source.vala"
	if (_data_->_tmp2_) {
#line 221 "../ssh/source.vala"
		_data_->_tmp1_ = seahorse_ssh_source_check_file_for_ssh (_data_->self, _data_->privfile);
#line 1418 "source.c"
	} else {
#line 219 "../ssh/source.vala"
		_data_->_tmp1_ = FALSE;
#line 1422 "source.c"
	}
#line 219 "../ssh/source.vala"
	if (_data_->_tmp1_) {
#line 1426 "source.c"
		{
#line 223 "../ssh/source.vala"
			_data_->_tmp4_ = _data_->pubfile;
#line 223 "../ssh/source.vala"
			memset (&_data_->_tmp5_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 223 "../ssh/source.vala"
			_data_->_state_ = 1;
#line 223 "../ssh/source.vala"
			seahorse_ssh_key_parse_file (_data_->_tmp4_, NULL, seahorse_ssh_source_load_key_for_private_file_ready, _data_);
#line 223 "../ssh/source.vala"
			return FALSE;
#line 1438 "source.c"
			_state_1:
#line 223 "../ssh/source.vala"
			seahorse_ssh_key_parse_file_finish (_data_->_res_, &_data_->_tmp5_, &_data_->_inner_error0_);
#line 223 "../ssh/source.vala"
			_data_->_result_ = _data_->_tmp5_;
#line 223 "../ssh/source.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1446 "source.c"
				goto __catch0_g_error;
			}
#line 224 "../ssh/source.vala"
			_data_->_tmp6_ = _data_->_result_;
#line 224 "../ssh/source.vala"
			_data_->_tmp7_ = _data_->_tmp6_.public_keys;
#line 224 "../ssh/source.vala"
			_data_->_tmp7__length1 = _data_->_tmp6_.public_keys_length1;
#line 1455 "source.c"
			{
#line 224 "../ssh/source.vala"
				_data_->keydata_collection_length1 = 0;
#line 224 "../ssh/source.vala"
				_data_->_keydata_collection_size_ = 0;
#line 224 "../ssh/source.vala"
				_data_->keydata_collection = _data_->_tmp7_;
#line 224 "../ssh/source.vala"
				_data_->keydata_collection_length1 = _data_->_tmp7__length1;
#line 224 "../ssh/source.vala"
				for (_data_->keydata_it = 0; _data_->keydata_it < _data_->keydata_collection_length1; _data_->keydata_it = _data_->keydata_it + 1) {
#line 224 "../ssh/source.vala"
					_data_->keydata = _data_->keydata_collection[_data_->keydata_it];
#line 1469 "source.c"
					{
#line 225 "../ssh/source.vala"
						_data_->_tmp8_ = _data_->keydata;
#line 225 "../ssh/source.vala"
						_data_->_tmp9_ = _data_->pubfile;
#line 225 "../ssh/source.vala"
						_data_->_tmp10_ = seahorse_ssh_source_add_key_from_parsed_data (_data_->self, _data_->_tmp8_, _data_->_tmp9_, FALSE, FALSE, _data_->privfile);
#line 225 "../ssh/source.vala"
						_g_object_unref0 (_data_->key);
#line 225 "../ssh/source.vala"
						_data_->key = _data_->_tmp10_;
#line 1481 "source.c"
					}
				}
			}
#line 222 "../ssh/source.vala"
			seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 1487 "source.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 222 "../ssh/source.vala"
			_data_->e = _data_->_inner_error0_;
#line 222 "../ssh/source.vala"
			_data_->_inner_error0_ = NULL;
#line 228 "../ssh/source.vala"
			_data_->_tmp11_ = _data_->pubfile;
#line 228 "../ssh/source.vala"
			_data_->_tmp12_ = _data_->e;
#line 228 "../ssh/source.vala"
			_data_->_tmp13_ = _data_->_tmp12_->message;
#line 228 "../ssh/source.vala"
			_data_->_tmp14_ = g_strdup_printf ("Couldn't read SSH file: %s (%s)", _data_->_tmp11_, _data_->_tmp13_);
#line 228 "../ssh/source.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 228 "../ssh/source.vala"
			_data_->_tmp16_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, _data_->_tmp15_);
#line 228 "../ssh/source.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 228 "../ssh/source.vala"
			_g_free0 (_data_->_tmp15_);
#line 228 "../ssh/source.vala"
			_data_->_inner_error0_ = _data_->_tmp17_;
#line 228 "../ssh/source.vala"
			_g_error_free0 (_data_->e);
#line 1516 "source.c"
			goto __finally0;
		}
		__finally0:
#line 222 "../ssh/source.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 222 "../ssh/source.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 222 "../ssh/source.vala"
			_g_object_unref0 (_data_->key);
#line 222 "../ssh/source.vala"
			_g_free0 (_data_->pubfile);
#line 222 "../ssh/source.vala"
			g_object_unref (_data_->_async_result);
#line 222 "../ssh/source.vala"
			return FALSE;
#line 1532 "source.c"
		}
	}
#line 232 "../ssh/source.vala"
	_data_->result = _data_->key;
#line 232 "../ssh/source.vala"
	_g_free0 (_data_->pubfile);
#line 232 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 232 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 232 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 232 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1547 "source.c"
		}
	}
#line 232 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 232 "../ssh/source.vala"
	return FALSE;
#line 1554 "source.c"
}

static void
seahorse_ssh_source_real_load_data_free (gpointer _data)
{
	SeahorseSshSourceLoadData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceLoadData, _data_);
#line 1568 "source.c"
}

static void
seahorse_ssh_source_real_load (SeahorsePlace* base,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	SeahorseSshSource * self;
	SeahorseSshSourceLoadData* _data_;
	SeahorseSshSource* _tmp0_;
	GCancellable* _tmp1_;
#line 26 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceLoadData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_real_load_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp1_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_real_load_co (_data_);
#line 1601 "source.c"
}

static gboolean
seahorse_ssh_source_load_finish (SeahorsePlace* base,
                                 GAsyncResult* _res_,
                                 GError** error)
{
	gboolean result;
	SeahorseSshSourceLoadData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 1615 "source.c"
		gboolean _tmp0_ = FALSE;
#line 26 "../ssh/source.vala"
		return _tmp0_;
#line 1619 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	return result;
#line 1625 "source.c"
}

/**
     * Loads the keys from this Source's directory.
     *
     * @param cancellable Use this to cancel the operation.
     */
static gboolean
_seahorse_ssh_source_scheduled_dummy_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_scheduled_dummy ((SeahorseSshSource*) self);
#line 243 "../ssh/source.vala"
	return result;
#line 1640 "source.c"
}

static void
___lambda16_ (SeahorseSshSource* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 253 "../ssh/source.vala"
	g_return_if_fail (res != NULL);
#line 1651 "source.c"
	{
		SeahorseSshKey* _tmp0_;
		SeahorseSshKey* _tmp1_;
#line 255 "../ssh/source.vala"
		_tmp0_ = seahorse_ssh_source_load_key_for_private_file_finish (self, res, &_inner_error0_);
#line 255 "../ssh/source.vala"
		_tmp1_ = _tmp0_;
#line 255 "../ssh/source.vala"
		_g_object_unref0 (_tmp1_);
#line 255 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1663 "source.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 254 "../ssh/source.vala"
		err = _inner_error0_;
#line 254 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 257 "../ssh/source.vala"
		_tmp2_ = err;
#line 257 "../ssh/source.vala"
		_tmp3_ = _tmp2_->message;
#line 257 "../ssh/source.vala"
		g_warning ("source.vala:257: Couldn't load key for file: %s", _tmp3_);
#line 254 "../ssh/source.vala"
		_g_error_free0 (err);
#line 1685 "source.c"
	}
	__finally0:
#line 254 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 254 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 254 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 254 "../ssh/source.vala"
		return;
#line 1696 "source.c"
	}
}

static void
____lambda16__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 253 "../ssh/source.vala"
	___lambda16_ ((SeahorseSshSource*) self, source_object, res);
#line 253 "../ssh/source.vala"
	g_object_unref (self);
#line 1709 "source.c"
}

static void
seahorse_ssh_source_load_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	SeahorseSshSourceLoadData* _data_;
#line 265 "../ssh/source.vala"
	_data_ = _user_data_;
#line 265 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 265 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 265 "../ssh/source.vala"
	seahorse_ssh_source_real_load_co (_data_);
#line 1726 "source.c"
}

static gboolean
seahorse_ssh_source_real_load_co (SeahorseSshSourceLoadData* _data_)
{
#line 240 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 240 "../ssh/source.vala"
		case 0:
#line 1736 "source.c"
		goto _state_0;
#line 240 "../ssh/source.vala"
		case 1:
#line 1740 "source.c"
		goto _state_1;
#line 240 "../ssh/source.vala"
		case 2:
#line 1744 "source.c"
		goto _state_2;
		default:
#line 240 "../ssh/source.vala"
		g_assert_not_reached ();
#line 1749 "source.c"
	}
	_state_0:
#line 242 "../ssh/source.vala"
	seahorse_ssh_source_cancel_scheduled_refresh (_data_->self);
#line 243 "../ssh/source.vala"
	_data_->self->priv->scheduled_refresh_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, _seahorse_ssh_source_scheduled_dummy_gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 244 "../ssh/source.vala"
	g_debug ("source.vala:244: scheduled a dummy refresh");
#line 247 "../ssh/source.vala"
	_data_->_tmp0_ = _data_->self->priv->ssh_homedir;
#line 247 "../ssh/source.vala"
	_data_->_tmp1_ = g_dir_open (_data_->_tmp0_, (guint) 0, &_data_->_inner_error0_);
#line 247 "../ssh/source.vala"
	_data_->dir = _data_->_tmp1_;
#line 247 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 247 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 247 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 247 "../ssh/source.vala"
		return FALSE;
#line 1772 "source.c"
	}
#line 250 "../ssh/source.vala"
	_data_->filename = NULL;
#line 251 "../ssh/source.vala"
	while (TRUE) {
#line 251 "../ssh/source.vala"
		_data_->_tmp2_ = _data_->dir;
#line 251 "../ssh/source.vala"
		_data_->_tmp3_ = g_dir_read_name (_data_->_tmp2_);
#line 251 "../ssh/source.vala"
		_data_->_tmp4_ = g_strdup (_data_->_tmp3_);
#line 251 "../ssh/source.vala"
		_g_free0 (_data_->filename);
#line 251 "../ssh/source.vala"
		_data_->filename = _data_->_tmp4_;
#line 251 "../ssh/source.vala"
		_data_->_tmp5_ = _data_->filename;
#line 251 "../ssh/source.vala"
		if (!(_data_->_tmp5_ != NULL)) {
#line 251 "../ssh/source.vala"
			break;
#line 1794 "source.c"
		}
#line 252 "../ssh/source.vala"
		_data_->_tmp6_ = _data_->self->priv->ssh_homedir;
#line 252 "../ssh/source.vala"
		_data_->_tmp7_ = _data_->filename;
#line 252 "../ssh/source.vala"
		_data_->_tmp8_ = g_build_filename (_data_->_tmp6_, _data_->_tmp7_, NULL);
#line 252 "../ssh/source.vala"
		_data_->privfile = _data_->_tmp8_;
#line 253 "../ssh/source.vala"
		_data_->_tmp9_ = _data_->privfile;
#line 253 "../ssh/source.vala"
		seahorse_ssh_source_load_key_for_private_file (_data_->self, _data_->_tmp9_, ____lambda16__gasync_ready_callback, g_object_ref (_data_->self));
#line 251 "../ssh/source.vala"
		_g_free0 (_data_->privfile);
#line 1810 "source.c"
	}
#line 263 "../ssh/source.vala"
	_data_->_tmp10_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 263 "../ssh/source.vala"
	_data_->pubfile = _data_->_tmp10_;
#line 264 "../ssh/source.vala"
	_data_->_tmp11_ = _data_->pubfile;
#line 264 "../ssh/source.vala"
	if (g_file_test (_data_->_tmp11_, G_FILE_TEST_IS_REGULAR)) {
#line 265 "../ssh/source.vala"
		_data_->_tmp12_ = _data_->pubfile;
#line 265 "../ssh/source.vala"
		memset (&_data_->_tmp13_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 265 "../ssh/source.vala"
		_data_->_state_ = 1;
#line 265 "../ssh/source.vala"
		seahorse_ssh_key_parse_file (_data_->_tmp12_, NULL, seahorse_ssh_source_load_ready, _data_);
#line 265 "../ssh/source.vala"
		return FALSE;
#line 1830 "source.c"
		_state_1:
#line 265 "../ssh/source.vala"
		seahorse_ssh_key_parse_file_finish (_data_->_res_, &_data_->_tmp13_, &_data_->_inner_error0_);
#line 265 "../ssh/source.vala"
		_data_->_result_ = _data_->_tmp13_;
#line 265 "../ssh/source.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 265 "../ssh/source.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 265 "../ssh/source.vala"
			_g_free0 (_data_->pubfile);
#line 265 "../ssh/source.vala"
			_g_free0 (_data_->filename);
#line 265 "../ssh/source.vala"
			_g_dir_close0 (_data_->dir);
#line 265 "../ssh/source.vala"
			g_object_unref (_data_->_async_result);
#line 265 "../ssh/source.vala"
			return FALSE;
#line 1850 "source.c"
		}
#line 266 "../ssh/source.vala"
		_data_->_tmp14_ = _data_->_result_;
#line 266 "../ssh/source.vala"
		_data_->_tmp15_ = _data_->_tmp14_.public_keys;
#line 266 "../ssh/source.vala"
		_data_->_tmp15__length1 = _data_->_tmp14_.public_keys_length1;
#line 1858 "source.c"
		{
#line 266 "../ssh/source.vala"
			_data_->keydata_collection_length1 = 0;
#line 266 "../ssh/source.vala"
			_data_->_keydata_collection_size_ = 0;
#line 266 "../ssh/source.vala"
			_data_->keydata_collection = _data_->_tmp15_;
#line 266 "../ssh/source.vala"
			_data_->keydata_collection_length1 = _data_->_tmp15__length1;
#line 266 "../ssh/source.vala"
			for (_data_->keydata_it = 0; _data_->keydata_it < _data_->keydata_collection_length1; _data_->keydata_it = _data_->keydata_it + 1) {
#line 266 "../ssh/source.vala"
				_data_->keydata = _data_->keydata_collection[_data_->keydata_it];
#line 1872 "source.c"
				{
#line 267 "../ssh/source.vala"
					_data_->_tmp16_ = _data_->keydata;
#line 267 "../ssh/source.vala"
					_data_->_tmp17_ = _data_->pubfile;
#line 267 "../ssh/source.vala"
					_data_->_tmp18_ = seahorse_ssh_source_add_key_from_parsed_data (_data_->self, _data_->_tmp16_, _data_->_tmp17_, TRUE, TRUE, NULL);
#line 267 "../ssh/source.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 267 "../ssh/source.vala"
					_g_object_unref0 (_data_->_tmp19_);
#line 1884 "source.c"
				}
			}
		}
#line 264 "../ssh/source.vala"
		seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 1890 "source.c"
	}
#line 272 "../ssh/source.vala"
	_data_->_tmp20_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 272 "../ssh/source.vala"
	_g_free0 (_data_->pubfile);
#line 272 "../ssh/source.vala"
	_data_->pubfile = _data_->_tmp20_;
#line 273 "../ssh/source.vala"
	_data_->_tmp21_ = _data_->pubfile;
#line 273 "../ssh/source.vala"
	if (g_file_test (_data_->_tmp21_, G_FILE_TEST_IS_REGULAR)) {
#line 274 "../ssh/source.vala"
		_data_->_tmp22_ = _data_->pubfile;
#line 274 "../ssh/source.vala"
		memset (&_data_->_tmp23_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 274 "../ssh/source.vala"
		_data_->_state_ = 2;
#line 274 "../ssh/source.vala"
		seahorse_ssh_key_parse_file (_data_->_tmp22_, NULL, seahorse_ssh_source_load_ready, _data_);
#line 274 "../ssh/source.vala"
		return FALSE;
#line 1912 "source.c"
		_state_2:
#line 274 "../ssh/source.vala"
		seahorse_ssh_key_parse_file_finish (_data_->_res_, &_data_->_tmp23_, &_data_->_inner_error0_);
#line 274 "../ssh/source.vala"
		_data_->_vala1__result_ = _data_->_tmp23_;
#line 274 "../ssh/source.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 274 "../ssh/source.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 274 "../ssh/source.vala"
			_g_free0 (_data_->pubfile);
#line 274 "../ssh/source.vala"
			_g_free0 (_data_->filename);
#line 274 "../ssh/source.vala"
			_g_dir_close0 (_data_->dir);
#line 274 "../ssh/source.vala"
			g_object_unref (_data_->_async_result);
#line 274 "../ssh/source.vala"
			return FALSE;
#line 1932 "source.c"
		}
#line 275 "../ssh/source.vala"
		_data_->_tmp24_ = _data_->_vala1__result_;
#line 275 "../ssh/source.vala"
		_data_->_tmp25_ = _data_->_tmp24_.public_keys;
#line 275 "../ssh/source.vala"
		_data_->_tmp25__length1 = _data_->_tmp24_.public_keys_length1;
#line 1940 "source.c"
		{
#line 275 "../ssh/source.vala"
			_data_->_vala1_keydata_collection_length1 = 0;
#line 275 "../ssh/source.vala"
			_data_->__vala1_keydata_collection_size_ = 0;
#line 275 "../ssh/source.vala"
			_data_->_vala1_keydata_collection = _data_->_tmp25_;
#line 275 "../ssh/source.vala"
			_data_->_vala1_keydata_collection_length1 = _data_->_tmp25__length1;
#line 275 "../ssh/source.vala"
			for (_data_->_vala1_keydata_it = 0; _data_->_vala1_keydata_it < _data_->_vala1_keydata_collection_length1; _data_->_vala1_keydata_it = _data_->_vala1_keydata_it + 1) {
#line 275 "../ssh/source.vala"
				_data_->_vala1_keydata = _data_->_vala1_keydata_collection[_data_->_vala1_keydata_it];
#line 1954 "source.c"
				{
#line 276 "../ssh/source.vala"
					_data_->_tmp26_ = _data_->_vala1_keydata;
#line 276 "../ssh/source.vala"
					_data_->_tmp27_ = _data_->pubfile;
#line 276 "../ssh/source.vala"
					_data_->_tmp28_ = seahorse_ssh_source_add_key_from_parsed_data (_data_->self, _data_->_tmp26_, _data_->_tmp27_, TRUE, FALSE, NULL);
#line 276 "../ssh/source.vala"
					_data_->_tmp29_ = _data_->_tmp28_;
#line 276 "../ssh/source.vala"
					_g_object_unref0 (_data_->_tmp29_);
#line 1966 "source.c"
				}
			}
		}
#line 273 "../ssh/source.vala"
		seahorse_ssh_key_key_parse_result_destroy (&_data_->_vala1__result_);
#line 1972 "source.c"
	}
#line 280 "../ssh/source.vala"
	_data_->result = TRUE;
#line 280 "../ssh/source.vala"
	_g_free0 (_data_->pubfile);
#line 280 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 280 "../ssh/source.vala"
	_g_dir_close0 (_data_->dir);
#line 280 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 280 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 280 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 280 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1990 "source.c"
		}
	}
#line 280 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 280 "../ssh/source.vala"
	return FALSE;
#line 1997 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_add_key_from_parsed_data (SeahorseSshSource* self,
                                              SeahorseSshKeyData* keydata,
                                              const gchar* pubfile,
                                              gboolean partial,
                                              gboolean authorized,
                                              const gchar* privfile)
{
	gboolean _tmp0_ = FALSE;
	SeahorseSshKey* prev = NULL;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	SeahorseSshKey* _tmp3_;
	SeahorseSshKey* _tmp4_;
	SeahorseSshKey* _tmp6_;
	SeahorseSshKey* key = NULL;
	SeahorseSshKey* _tmp7_;
	GPtrArray* _tmp8_;
	SeahorseSshKey* _tmp9_;
	SeahorseSshKey* _tmp10_;
	GPtrArray* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	SeahorseSshKey* result;
#line 283 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 283 "../ssh/source.vala"
	g_return_val_if_fail (pubfile != NULL, NULL);
#line 288 "../ssh/source.vala"
	if (keydata != NULL) {
#line 288 "../ssh/source.vala"
		_tmp0_ = seahorse_ssh_key_data_is_valid (keydata);
#line 2032 "source.c"
	} else {
#line 288 "../ssh/source.vala"
		_tmp0_ = FALSE;
#line 2036 "source.c"
	}
#line 288 "../ssh/source.vala"
	g_return_val_if_fail (_tmp0_, NULL);
#line 290 "../ssh/source.vala"
	seahorse_ssh_key_data_set_pubfile (keydata, pubfile);
#line 291 "../ssh/source.vala"
	seahorse_ssh_key_data_set_partial (keydata, partial);
#line 292 "../ssh/source.vala"
	seahorse_ssh_key_data_set_authorized (keydata, authorized);
#line 293 "../ssh/source.vala"
	if (privfile != NULL) {
#line 294 "../ssh/source.vala"
		seahorse_ssh_key_data_set_privfile (keydata, privfile);
#line 2050 "source.c"
	}
#line 297 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_key_data_get_fingerprint (keydata);
#line 297 "../ssh/source.vala"
	_tmp2_ = _tmp1_;
#line 297 "../ssh/source.vala"
	_tmp3_ = seahorse_ssh_source_find_key_by_fingerprint (self, _tmp2_);
#line 297 "../ssh/source.vala"
	prev = _tmp3_;
#line 298 "../ssh/source.vala"
	_tmp4_ = prev;
#line 298 "../ssh/source.vala"
	if (_tmp4_ != NULL) {
#line 2064 "source.c"
		SeahorseSshKey* _tmp5_;
#line 299 "../ssh/source.vala"
		_tmp5_ = prev;
#line 299 "../ssh/source.vala"
		seahorse_ssh_key_merge_keydata (_tmp5_, keydata);
#line 2070 "source.c"
	}
#line 302 "../ssh/source.vala"
	_tmp6_ = prev;
#line 302 "../ssh/source.vala"
	if (_tmp6_ != NULL) {
#line 303 "../ssh/source.vala"
		result = prev;
#line 303 "../ssh/source.vala"
		return result;
#line 2080 "source.c"
	}
#line 306 "../ssh/source.vala"
	_tmp7_ = seahorse_ssh_key_new (self, keydata);
#line 306 "../ssh/source.vala"
	key = _tmp7_;
#line 307 "../ssh/source.vala"
	_tmp8_ = self->priv->keys;
#line 307 "../ssh/source.vala"
	_tmp9_ = key;
#line 307 "../ssh/source.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 307 "../ssh/source.vala"
	g_ptr_array_add (_tmp8_, _tmp10_);
#line 308 "../ssh/source.vala"
	_tmp11_ = self->priv->keys;
#line 308 "../ssh/source.vala"
	_tmp12_ = vala_g_ptr_array_get_length (_tmp11_);
#line 308 "../ssh/source.vala"
	_tmp13_ = _tmp12_;
#line 308 "../ssh/source.vala"
	g_list_model_items_changed ((GListModel*) self, (guint) (_tmp13_ - 1), (guint) 0, (guint) 1);
#line 310 "../ssh/source.vala"
	result = key;
#line 310 "../ssh/source.vala"
	_g_object_unref0 (prev);
#line 310 "../ssh/source.vala"
	return result;
#line 2108 "source.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 26 "../ssh/source.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2116 "source.c"
}

static void
seahorse_ssh_source_import_async_data_free (gpointer _data)
{
	SeahorseSshSourceImportAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->input);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->transient_for);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	(_data_->result == NULL) ? NULL : (_data_->result = (_g_list_free__g_object_unref0_ (_data_->result), NULL));
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceImportAsyncData, _data_);
#line 2136 "source.c"
}

void
seahorse_ssh_source_import_async (SeahorseSshSource* self,
                                  GInputStream* input,
                                  GtkWindow* transient_for,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	SeahorseSshSourceImportAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	GInputStream* _tmp1_;
	GtkWindow* _tmp2_;
	GCancellable* _tmp3_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (input != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceImportAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_import_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (input);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->input);
#line 26 "../ssh/source.vala"
	_data_->input = _tmp1_;
#line 26 "../ssh/source.vala"
	_tmp2_ = _g_object_ref0 (transient_for);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->transient_for);
#line 26 "../ssh/source.vala"
	_data_->transient_for = _tmp2_;
#line 26 "../ssh/source.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp3_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_import_async_co (_data_);
#line 2186 "source.c"
}

GList*
seahorse_ssh_source_import_finish (SeahorseSshSource* self,
                                   GAsyncResult* _res_,
                                   GError** error)
{
	GList* result;
	SeahorseSshSourceImportAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 2202 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 2210 "source.c"
}

/**
     * Parse an inputstream into a list of keys and import those keys.
     */
static void
seahorse_ssh_source_import_async_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	SeahorseSshSourceImportAsyncData* _data_;
#line 319 "../ssh/source.vala"
	_data_ = _user_data_;
#line 319 "../ssh/source.vala"
	_data_->_source_object_ = source_object;
#line 319 "../ssh/source.vala"
	_data_->_res_ = _res_;
#line 319 "../ssh/source.vala"
	seahorse_ssh_source_import_async_co (_data_);
#line 2230 "source.c"
}

static gboolean
seahorse_ssh_source_import_async_co (SeahorseSshSourceImportAsyncData* _data_)
{
#line 316 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 316 "../ssh/source.vala"
		case 0:
#line 2240 "source.c"
		goto _state_0;
#line 316 "../ssh/source.vala"
		case 1:
#line 2244 "source.c"
		goto _state_1;
#line 316 "../ssh/source.vala"
		case 2:
#line 2248 "source.c"
		goto _state_2;
#line 316 "../ssh/source.vala"
		case 3:
#line 2252 "source.c"
		goto _state_3;
		default:
#line 316 "../ssh/source.vala"
		g_assert_not_reached ();
#line 2257 "source.c"
	}
	_state_0:
#line 319 "../ssh/source.vala"
	memset (&_data_->_tmp0_, 0, sizeof (SeahorseSshKeyKeyParseResult));
#line 319 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 319 "../ssh/source.vala"
	seahorse_ssh_key_parse (_data_->input, _data_->cancellable, seahorse_ssh_source_import_async_ready, _data_);
#line 319 "../ssh/source.vala"
	return FALSE;
#line 2268 "source.c"
	_state_1:
#line 319 "../ssh/source.vala"
	seahorse_ssh_key_parse_finish (_data_->_res_, &_data_->_tmp0_, &_data_->_inner_error0_);
#line 319 "../ssh/source.vala"
	_data_->_result_ = _data_->_tmp0_;
#line 319 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 319 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 319 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 319 "../ssh/source.vala"
		return FALSE;
#line 2282 "source.c"
	}
#line 321 "../ssh/source.vala"
	_data_->_tmp1_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 321 "../ssh/source.vala"
	_data_->fullpath = _data_->_tmp1_;
#line 322 "../ssh/source.vala"
	_data_->_tmp2_ = _data_->_result_;
#line 322 "../ssh/source.vala"
	_data_->_tmp3_ = _data_->_tmp2_.public_keys;
#line 322 "../ssh/source.vala"
	_data_->_tmp3__length1 = _data_->_tmp2_.public_keys_length1;
#line 2294 "source.c"
	{
#line 322 "../ssh/source.vala"
		_data_->keydata_collection_length1 = 0;
#line 322 "../ssh/source.vala"
		_data_->_keydata_collection_size_ = 0;
#line 322 "../ssh/source.vala"
		_data_->keydata_collection = _data_->_tmp3_;
#line 322 "../ssh/source.vala"
		_data_->keydata_collection_length1 = _data_->_tmp3__length1;
#line 322 "../ssh/source.vala"
		for (_data_->keydata_it = 0; _data_->keydata_it < _data_->keydata_collection_length1; _data_->keydata_it = _data_->keydata_it + 1) {
#line 322 "../ssh/source.vala"
			_data_->keydata = _data_->keydata_collection[_data_->keydata_it];
#line 2308 "source.c"
			{
#line 323 "../ssh/source.vala"
				_data_->_tmp4_ = _data_->keydata;
#line 323 "../ssh/source.vala"
				_data_->_tmp5_ = _data_->fullpath;
#line 323 "../ssh/source.vala"
				_data_->_state_ = 2;
#line 323 "../ssh/source.vala"
				seahorse_ssh_source_import_public_async (_data_->self, _data_->_tmp4_, _data_->_tmp5_, _data_->cancellable, seahorse_ssh_source_import_async_ready, _data_);
#line 323 "../ssh/source.vala"
				return FALSE;
#line 2320 "source.c"
				_state_2:
#line 323 "../ssh/source.vala"
				_data_->_tmp6_ = seahorse_ssh_source_import_public_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 323 "../ssh/source.vala"
				_data_->_tmp7_ = _data_->_tmp6_;
#line 323 "../ssh/source.vala"
				_g_free0 (_data_->_tmp7_);
#line 323 "../ssh/source.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 323 "../ssh/source.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 323 "../ssh/source.vala"
					_g_free0 (_data_->fullpath);
#line 323 "../ssh/source.vala"
					seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 323 "../ssh/source.vala"
					g_object_unref (_data_->_async_result);
#line 323 "../ssh/source.vala"
					return FALSE;
#line 2340 "source.c"
				}
			}
		}
	}
#line 325 "../ssh/source.vala"
	_data_->_tmp8_ = _data_->_result_;
#line 325 "../ssh/source.vala"
	_data_->_tmp9_ = _data_->_tmp8_.secret_keys;
#line 325 "../ssh/source.vala"
	_data_->_tmp9__length1 = _data_->_tmp8_.secret_keys_length1;
#line 2351 "source.c"
	{
#line 325 "../ssh/source.vala"
		_data_->secdata_collection_length1 = 0;
#line 325 "../ssh/source.vala"
		_data_->_secdata_collection_size_ = 0;
#line 325 "../ssh/source.vala"
		_data_->secdata_collection = _data_->_tmp9_;
#line 325 "../ssh/source.vala"
		_data_->secdata_collection_length1 = _data_->_tmp9__length1;
#line 325 "../ssh/source.vala"
		for (_data_->secdata_it = 0; _data_->secdata_it < _data_->secdata_collection_length1; _data_->secdata_it = _data_->secdata_it + 1) {
#line 325 "../ssh/source.vala"
			_data_->secdata = _data_->secdata_collection[_data_->secdata_it];
#line 2365 "source.c"
			{
#line 326 "../ssh/source.vala"
				_data_->_tmp10_ = seahorse_ssh_private_import_operation_new ();
#line 326 "../ssh/source.vala"
				_data_->op = _data_->_tmp10_;
#line 327 "../ssh/source.vala"
				_data_->_tmp11_ = _data_->op;
#line 327 "../ssh/source.vala"
				_data_->_tmp12_ = _data_->secdata;
#line 327 "../ssh/source.vala"
				_data_->_state_ = 3;
#line 327 "../ssh/source.vala"
				seahorse_ssh_private_import_operation_import_private_async (_data_->_tmp11_, _data_->self, _data_->_tmp12_, NULL, _data_->cancellable, seahorse_ssh_source_import_async_ready, _data_);
#line 327 "../ssh/source.vala"
				return FALSE;
#line 2381 "source.c"
				_state_3:
#line 327 "../ssh/source.vala"
				_data_->_tmp13_ = seahorse_ssh_private_import_operation_import_private_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error0_);
#line 327 "../ssh/source.vala"
				_data_->_tmp14_ = _data_->_tmp13_;
#line 327 "../ssh/source.vala"
				_g_free0 (_data_->_tmp14_);
#line 327 "../ssh/source.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 327 "../ssh/source.vala"
					g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 327 "../ssh/source.vala"
					_g_object_unref0 (_data_->op);
#line 327 "../ssh/source.vala"
					_g_free0 (_data_->fullpath);
#line 327 "../ssh/source.vala"
					seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 327 "../ssh/source.vala"
					g_object_unref (_data_->_async_result);
#line 327 "../ssh/source.vala"
					return FALSE;
#line 2403 "source.c"
				}
#line 325 "../ssh/source.vala"
				_g_object_unref0 (_data_->op);
#line 2407 "source.c"
			}
		}
	}
#line 331 "../ssh/source.vala"
	_data_->result = NULL;
#line 331 "../ssh/source.vala"
	_g_free0 (_data_->fullpath);
#line 331 "../ssh/source.vala"
	seahorse_ssh_key_key_parse_result_destroy (&_data_->_result_);
#line 331 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 331 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 331 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 331 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2425 "source.c"
		}
	}
#line 331 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 331 "../ssh/source.vala"
	return FALSE;
#line 2432 "source.c"
}

static void
seahorse_ssh_source_import_public_async_data_free (gpointer _data)
{
	SeahorseSshSourceImportPublicAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->data);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->result);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceImportPublicAsyncData, _data_);
#line 2452 "source.c"
}

void
seahorse_ssh_source_import_public_async (SeahorseSshSource* self,
                                         SeahorseSshKeyData* data,
                                         const gchar* filename,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	SeahorseSshSourceImportPublicAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	SeahorseSshKeyData* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (data != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (filename != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceImportPublicAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_import_public_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (data);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->data);
#line 26 "../ssh/source.vala"
	_data_->data = _tmp1_;
#line 26 "../ssh/source.vala"
	_tmp2_ = g_strdup (filename);
#line 26 "../ssh/source.vala"
	_g_free0 (_data_->filename);
#line 26 "../ssh/source.vala"
	_data_->filename = _tmp2_;
#line 26 "../ssh/source.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->cancellable);
#line 26 "../ssh/source.vala"
	_data_->cancellable = _tmp3_;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_import_public_async_co (_data_);
#line 2504 "source.c"
}

gchar*
seahorse_ssh_source_import_public_finish (SeahorseSshSource* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	gchar* result;
	SeahorseSshSourceImportPublicAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return NULL;
#line 2520 "source.c"
	}
#line 26 "../ssh/source.vala"
	result = _data_->result;
#line 26 "../ssh/source.vala"
	_data_->result = NULL;
#line 26 "../ssh/source.vala"
	return result;
#line 2528 "source.c"
}

/**
     * Import a public key into a file.
     *
     * @param data The public key that needs to be imported.
     * @param filename The name of the file in which the key should be imported.
     * @param cancellable Allows the operation to be cancelled.
     */
static gboolean
seahorse_ssh_source_import_public_async_co (SeahorseSshSourceImportPublicAsyncData* _data_)
{
#line 341 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 341 "../ssh/source.vala"
		case 0:
#line 2545 "source.c"
		goto _state_0;
		default:
#line 341 "../ssh/source.vala"
		g_assert_not_reached ();
#line 2550 "source.c"
	}
	_state_0:
#line 344 "../ssh/source.vala"
	if (_data_->data == NULL) {
#line 344 "../ssh/source.vala"
		_data_->_tmp1_ = TRUE;
#line 2557 "source.c"
	} else {
#line 344 "../ssh/source.vala"
		_data_->_tmp1_ = !seahorse_ssh_key_data_is_valid (_data_->data);
#line 2561 "source.c"
	}
#line 344 "../ssh/source.vala"
	if (_data_->_tmp1_) {
#line 344 "../ssh/source.vala"
		_data_->_tmp0_ = TRUE;
#line 2567 "source.c"
	} else {
#line 344 "../ssh/source.vala"
		_data_->_tmp2_ = seahorse_ssh_key_data_get_rawdata (_data_->data);
#line 344 "../ssh/source.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 344 "../ssh/source.vala"
		_data_->_tmp0_ = _data_->_tmp3_ == NULL;
#line 2575 "source.c"
	}
#line 344 "../ssh/source.vala"
	if (_data_->_tmp0_) {
#line 345 "../ssh/source.vala"
		_data_->_tmp4_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Trying to import an invalid public key.");
#line 345 "../ssh/source.vala"
		_data_->_inner_error0_ = _data_->_tmp4_;
#line 345 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 345 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 345 "../ssh/source.vala"
		return FALSE;
#line 2589 "source.c"
	}
#line 347 "../ssh/source.vala"
	seahorse_ssh_key_data_filter_file (_data_->filename, _data_->data, NULL, &_data_->_inner_error0_);
#line 347 "../ssh/source.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 347 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 347 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 347 "../ssh/source.vala"
		return FALSE;
#line 2601 "source.c"
	}
#line 349 "../ssh/source.vala"
	_data_->_tmp5_ = seahorse_ssh_key_data_get_fingerprint (_data_->data);
#line 349 "../ssh/source.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 349 "../ssh/source.vala"
	_data_->_tmp7_ = g_strdup (_data_->_tmp6_);
#line 349 "../ssh/source.vala"
	_data_->result = _data_->_tmp7_;
#line 349 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 349 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 349 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 349 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2619 "source.c"
		}
	}
#line 349 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 349 "../ssh/source.vala"
	return FALSE;
#line 2626 "source.c"
}

/**
     * Returns a possible filename for a key.
     *
     * @param algo The type of the key
     */
gchar*
seahorse_ssh_source_new_filename_for_algorithm (SeahorseSshSource* self,
                                                SeahorseSshAlgorithm algo)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* type = NULL;
	gchar* _tmp3_;
	gchar* basename = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* filename = NULL;
	gchar* result;
#line 357 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 358 "../ssh/source.vala"
	_tmp1_ = seahorse_ssh_algorithm_to_string (algo);
#line 358 "../ssh/source.vala"
	_tmp0_ = _tmp1_;
#line 358 "../ssh/source.vala"
	if (_tmp0_ == NULL) {
#line 2658 "source.c"
		gchar* _tmp2_;
#line 358 "../ssh/source.vala"
		_tmp2_ = g_strdup ("unk");
#line 358 "../ssh/source.vala"
		_g_free0 (_tmp0_);
#line 358 "../ssh/source.vala"
		_tmp0_ = _tmp2_;
#line 2666 "source.c"
	}
#line 358 "../ssh/source.vala"
	_tmp3_ = _tmp0_;
#line 358 "../ssh/source.vala"
	_tmp0_ = NULL;
#line 358 "../ssh/source.vala"
	type = _tmp3_;
#line 359 "../ssh/source.vala"
	_tmp4_ = type;
#line 359 "../ssh/source.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 359 "../ssh/source.vala"
	_tmp6_ = _tmp5_;
#line 359 "../ssh/source.vala"
	_tmp7_ = g_strdup_printf ("id_%s", _tmp6_);
#line 359 "../ssh/source.vala"
	_tmp8_ = _tmp7_;
#line 359 "../ssh/source.vala"
	_g_free0 (_tmp6_);
#line 359 "../ssh/source.vala"
	basename = _tmp8_;
#line 361 "../ssh/source.vala"
	filename = NULL;
#line 2690 "source.c"
	{
		gint i = 0;
#line 362 "../ssh/source.vala"
		i = 0;
#line 2695 "source.c"
		{
			gboolean _tmp9_ = FALSE;
#line 362 "../ssh/source.vala"
			_tmp9_ = TRUE;
#line 362 "../ssh/source.vala"
			while (TRUE) {
#line 2702 "source.c"
				gchar* _tmp11_ = NULL;
				gchar* t = NULL;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				const gchar* _tmp21_;
#line 362 "../ssh/source.vala"
				if (!_tmp9_) {
#line 2713 "source.c"
					gint _tmp10_;
#line 362 "../ssh/source.vala"
					_tmp10_ = i;
#line 362 "../ssh/source.vala"
					i = _tmp10_ + 1;
#line 2719 "source.c"
				}
#line 362 "../ssh/source.vala"
				_tmp9_ = FALSE;
#line 362 "../ssh/source.vala"
				if (!(i < G_MAXINT)) {
#line 362 "../ssh/source.vala"
					break;
#line 2727 "source.c"
				}
#line 363 "../ssh/source.vala"
				if (i == 0) {
#line 2731 "source.c"
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 363 "../ssh/source.vala"
					_tmp12_ = basename;
#line 363 "../ssh/source.vala"
					_tmp13_ = g_strdup (_tmp12_);
#line 363 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 363 "../ssh/source.vala"
					_tmp11_ = _tmp13_;
#line 2742 "source.c"
				} else {
					const gchar* _tmp14_;
					gchar* _tmp15_;
#line 363 "../ssh/source.vala"
					_tmp14_ = basename;
#line 363 "../ssh/source.vala"
					_tmp15_ = g_strdup_printf ("%s.%d", _tmp14_, i);
#line 363 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 363 "../ssh/source.vala"
					_tmp11_ = _tmp15_;
#line 2754 "source.c"
				}
#line 363 "../ssh/source.vala"
				_tmp16_ = g_strdup (_tmp11_);
#line 363 "../ssh/source.vala"
				t = _tmp16_;
#line 364 "../ssh/source.vala"
				_tmp17_ = seahorse_ssh_source_get_base_directory (self);
#line 364 "../ssh/source.vala"
				_tmp18_ = _tmp17_;
#line 364 "../ssh/source.vala"
				_tmp19_ = t;
#line 364 "../ssh/source.vala"
				_tmp20_ = g_build_filename (_tmp18_, _tmp19_, NULL);
#line 364 "../ssh/source.vala"
				_g_free0 (filename);
#line 364 "../ssh/source.vala"
				filename = _tmp20_;
#line 366 "../ssh/source.vala"
				_tmp21_ = filename;
#line 366 "../ssh/source.vala"
				if (!g_file_test (_tmp21_, G_FILE_TEST_EXISTS)) {
#line 367 "../ssh/source.vala"
					_g_free0 (t);
#line 367 "../ssh/source.vala"
					_g_free0 (_tmp11_);
#line 367 "../ssh/source.vala"
					break;
#line 2782 "source.c"
				}
#line 369 "../ssh/source.vala"
				_g_free0 (filename);
#line 369 "../ssh/source.vala"
				filename = NULL;
#line 362 "../ssh/source.vala"
				_g_free0 (t);
#line 362 "../ssh/source.vala"
				_g_free0 (_tmp11_);
#line 2792 "source.c"
			}
		}
	}
#line 372 "../ssh/source.vala"
	result = filename;
#line 372 "../ssh/source.vala"
	_g_free0 (basename);
#line 372 "../ssh/source.vala"
	_g_free0 (type);
#line 372 "../ssh/source.vala"
	_g_free0 (_tmp0_);
#line 372 "../ssh/source.vala"
	return result;
#line 2806 "source.c"
}

static void
seahorse_ssh_source_authorize_async_data_free (gpointer _data)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
	_data_ = _data;
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->self);
#line 26 "../ssh/source.vala"
	g_slice_free (SeahorseSshSourceAuthorizeAsyncData, _data_);
#line 2818 "source.c"
}

void
seahorse_ssh_source_authorize_async (SeahorseSshSource* self,
                                     SeahorseSshKey* key,
                                     gboolean authorize,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
	SeahorseSshSource* _tmp0_;
	SeahorseSshKey* _tmp1_;
#line 26 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 26 "../ssh/source.vala"
	g_return_if_fail (key != NULL);
#line 26 "../ssh/source.vala"
	_data_ = g_slice_new0 (SeahorseSshSourceAuthorizeAsyncData);
#line 26 "../ssh/source.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 26 "../ssh/source.vala"
	g_task_set_task_data (_data_->_async_result, _data_, seahorse_ssh_source_authorize_async_data_free);
#line 26 "../ssh/source.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 26 "../ssh/source.vala"
	_data_->self = _tmp0_;
#line 26 "../ssh/source.vala"
	_tmp1_ = _g_object_ref0 (key);
#line 26 "../ssh/source.vala"
	_g_object_unref0 (_data_->key);
#line 26 "../ssh/source.vala"
	_data_->key = _tmp1_;
#line 26 "../ssh/source.vala"
	_data_->authorize = authorize;
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_authorize_async_co (_data_);
#line 2855 "source.c"
}

void
seahorse_ssh_source_authorize_finish (SeahorseSshSource* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	SeahorseSshSourceAuthorizeAsyncData* _data_;
#line 26 "../ssh/source.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 26 "../ssh/source.vala"
	if (NULL == _data_) {
#line 26 "../ssh/source.vala"
		return;
#line 2870 "source.c"
	}
}

/**
     * Adds/Removes a public key to/from the authorized keys.
     *
     * @param key The key that needs to be authorized.
     * @param authorize Whether the specified key needs to be (de-)authorized.
     */
static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 381 "../ssh/source.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 381 "../ssh/source.vala"
	return _data6_;
#line 2887 "source.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 381 "../ssh/source.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2897 "source.c"
		SeahorseSshSource* self;
#line 381 "../ssh/source.vala"
		self = _data6_->self;
#line 381 "../ssh/source.vala"
		_g_free0 (_data6_->to);
#line 381 "../ssh/source.vala"
		_g_free0 (_data6_->from);
#line 381 "../ssh/source.vala"
		_g_error_free0 (_data6_->err);
#line 381 "../ssh/source.vala"
		(_data6_->callback_target_destroy_notify == NULL) ? NULL : (_data6_->callback_target_destroy_notify (_data6_->callback_target), NULL);
#line 381 "../ssh/source.vala"
		_data6_->callback = NULL;
#line 381 "../ssh/source.vala"
		_data6_->callback_target = NULL;
#line 381 "../ssh/source.vala"
		_data6_->callback_target_destroy_notify = NULL;
#line 381 "../ssh/source.vala"
		_g_object_unref0 (_data6_->key);
#line 381 "../ssh/source.vala"
		_g_object_unref0 (self);
#line 381 "../ssh/source.vala"
		g_slice_free (Block6Data, _data6_);
#line 2921 "source.c"
	}
}

static gboolean
_seahorse_ssh_source_authorize_async_co_gsource_func (gpointer self)
{
	gboolean result;
	result = seahorse_ssh_source_authorize_async_co (self);
#line 382 "../ssh/source.vala"
	return result;
#line 2932 "source.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 414 "../ssh/source.vala"
	return self ? g_error_copy (self) : NULL;
#line 2940 "source.c"
}

static void*
__lambda13_ (Block6Data* _data6_)
{
	SeahorseSshSource* self;
	GSourceFunc _tmp13_;
	gpointer _tmp13__target;
	GDestroyNotify _tmp13__target_destroy_notify;
	GError* _inner_error0_ = NULL;
	void* result;
#line 396 "../ssh/source.vala"
	self = _data6_->self;
#line 2954 "source.c"
	{
		SeahorseSshKeyData* keydata = NULL;
		SeahorseSshKeyData* _tmp0_;
		SeahorseSshKeyData* _tmp1_;
		SeahorseSshKeyData* _tmp2_;
		SeahorseSshKeyData* _tmp3_;
		const gchar* _tmp5_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		SeahorseSshKeyData* _tmp10_;
#line 398 "../ssh/source.vala"
		_tmp0_ = seahorse_ssh_key_get_key_data (_data6_->key);
#line 398 "../ssh/source.vala"
		_tmp1_ = _tmp0_;
#line 398 "../ssh/source.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 398 "../ssh/source.vala"
		keydata = _tmp2_;
#line 399 "../ssh/source.vala"
		_tmp3_ = keydata;
#line 399 "../ssh/source.vala"
		if (_tmp3_ == NULL) {
#line 2977 "source.c"
			GError* _tmp4_;
#line 400 "../ssh/source.vala"
			_tmp4_ = g_error_new_literal (SEAHORSE_SSH_ERROR, SEAHORSE_SSH_ERROR_GENERAL, "Can't authorize empty key.");
#line 400 "../ssh/source.vala"
			_inner_error0_ = _tmp4_;
#line 400 "../ssh/source.vala"
			_g_object_unref0 (keydata);
#line 2985 "source.c"
			goto __catch0_g_error;
		}
#line 403 "../ssh/source.vala"
		_tmp5_ = _data6_->from;
#line 403 "../ssh/source.vala"
		if (g_file_test (_tmp5_, G_FILE_TEST_EXISTS)) {
#line 2992 "source.c"
			const gchar* _tmp6_;
			SeahorseSshKeyData* _tmp7_;
#line 404 "../ssh/source.vala"
			_tmp6_ = _data6_->from;
#line 404 "../ssh/source.vala"
			_tmp7_ = keydata;
#line 404 "../ssh/source.vala"
			seahorse_ssh_key_data_filter_file (_tmp6_, NULL, _tmp7_, &_inner_error0_);
#line 404 "../ssh/source.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 404 "../ssh/source.vala"
				_g_object_unref0 (keydata);
#line 3005 "source.c"
				goto __catch0_g_error;
			}
		}
#line 408 "../ssh/source.vala"
		_tmp8_ = _data6_->to;
#line 408 "../ssh/source.vala"
		seahorse_ssh_source_ensure_file_exists (self, _tmp8_);
#line 409 "../ssh/source.vala"
		_tmp9_ = _data6_->to;
#line 409 "../ssh/source.vala"
		_tmp10_ = keydata;
#line 409 "../ssh/source.vala"
		seahorse_ssh_key_data_filter_file (_tmp9_, _tmp10_, NULL, &_inner_error0_);
#line 409 "../ssh/source.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 409 "../ssh/source.vala"
			_g_object_unref0 (keydata);
#line 3023 "source.c"
			goto __catch0_g_error;
		}
#line 412 "../ssh/source.vala"
		seahorse_ssh_key_refresh (_data6_->key);
#line 397 "../ssh/source.vala"
		_g_object_unref0 (keydata);
#line 3030 "source.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		GError* _tmp12_;
#line 397 "../ssh/source.vala"
		e = _inner_error0_;
#line 397 "../ssh/source.vala"
		_inner_error0_ = NULL;
#line 414 "../ssh/source.vala"
		_tmp11_ = e;
#line 414 "../ssh/source.vala"
		_tmp12_ = _g_error_copy0 (_tmp11_);
#line 414 "../ssh/source.vala"
		_g_error_free0 (_data6_->err);
#line 414 "../ssh/source.vala"
		_data6_->err = _tmp12_;
#line 397 "../ssh/source.vala"
		_g_error_free0 (e);
#line 3052 "source.c"
	}
	__finally0:
#line 397 "../ssh/source.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 397 "../ssh/source.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 397 "../ssh/source.vala"
		g_clear_error (&_inner_error0_);
#line 397 "../ssh/source.vala"
		return NULL;
#line 3063 "source.c"
	}
#line 417 "../ssh/source.vala"
	_tmp13_ = _data6_->callback;
#line 417 "../ssh/source.vala"
	_tmp13__target = _data6_->callback_target;
#line 417 "../ssh/source.vala"
	_tmp13__target_destroy_notify = _data6_->callback_target_destroy_notify;
#line 417 "../ssh/source.vala"
	_data6_->callback = NULL;
#line 417 "../ssh/source.vala"
	_data6_->callback_target = NULL;
#line 417 "../ssh/source.vala"
	_data6_->callback_target_destroy_notify = NULL;
#line 417 "../ssh/source.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _tmp13_, _tmp13__target, _tmp13__target_destroy_notify);
#line 418 "../ssh/source.vala"
	result = NULL;
#line 418 "../ssh/source.vala"
	return result;
#line 3083 "source.c"
}

static gpointer
___lambda13__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda13_ (self);
#line 396 "../ssh/source.vala"
	block6_data_unref (self);
#line 396 "../ssh/source.vala"
	return result;
#line 3095 "source.c"
}

static gboolean
seahorse_ssh_source_authorize_async_co (SeahorseSshSourceAuthorizeAsyncData* _data_)
{
#line 381 "../ssh/source.vala"
	switch (_data_->_state_) {
#line 381 "../ssh/source.vala"
		case 0:
#line 3105 "source.c"
		goto _state_0;
#line 381 "../ssh/source.vala"
		case 1:
#line 3109 "source.c"
		goto _state_1;
		default:
#line 381 "../ssh/source.vala"
		g_assert_not_reached ();
#line 3114 "source.c"
	}
	_state_0:
#line 381 "../ssh/source.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 381 "../ssh/source.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 381 "../ssh/source.vala"
	_data_->_data6_->self = g_object_ref (_data_->self);
#line 381 "../ssh/source.vala"
	_g_object_unref0 (_data_->_data6_->key);
#line 381 "../ssh/source.vala"
	_data_->_data6_->key = _data_->key;
#line 381 "../ssh/source.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 382 "../ssh/source.vala"
	_data_->_data6_->callback = _seahorse_ssh_source_authorize_async_co_gsource_func;
#line 382 "../ssh/source.vala"
	_data_->_data6_->callback_target = _data_;
#line 382 "../ssh/source.vala"
	_data_->_data6_->callback_target_destroy_notify = NULL;
#line 383 "../ssh/source.vala"
	_data_->_data6_->err = NULL;
#line 388 "../ssh/source.vala"
	if (_data_->authorize) {
#line 389 "../ssh/source.vala"
		_data_->_tmp0_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 389 "../ssh/source.vala"
		_g_free0 (_data_->_data6_->from);
#line 389 "../ssh/source.vala"
		_data_->_data6_->from = _data_->_tmp0_;
#line 390 "../ssh/source.vala"
		_data_->_tmp1_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 390 "../ssh/source.vala"
		_g_free0 (_data_->_data6_->to);
#line 390 "../ssh/source.vala"
		_data_->_data6_->to = _data_->_tmp1_;
#line 3151 "source.c"
	} else {
#line 392 "../ssh/source.vala"
		_data_->_tmp2_ = seahorse_ssh_source_authorized_keys_path (_data_->self);
#line 392 "../ssh/source.vala"
		_g_free0 (_data_->_data6_->from);
#line 392 "../ssh/source.vala"
		_data_->_data6_->from = _data_->_tmp2_;
#line 393 "../ssh/source.vala"
		_data_->_tmp3_ = seahorse_ssh_source_other_keys_path (_data_->self);
#line 393 "../ssh/source.vala"
		_g_free0 (_data_->_data6_->to);
#line 393 "../ssh/source.vala"
		_data_->_data6_->to = _data_->_tmp3_;
#line 3165 "source.c"
	}
#line 396 "../ssh/source.vala"
	_data_->_tmp4_ = g_thread_new ("authorize-async", ___lambda13__gthread_func, block6_data_ref (_data_->_data6_));
#line 396 "../ssh/source.vala"
	_data_->thread = _data_->_tmp4_;
#line 421 "../ssh/source.vala"
	_data_->_state_ = 1;
#line 421 "../ssh/source.vala"
	return FALSE;
#line 3175 "source.c"
	_state_1:
	;
#line 423 "../ssh/source.vala"
	_data_->_tmp5_ = _data_->thread;
#line 423 "../ssh/source.vala"
	_data_->thread = NULL;
#line 423 "../ssh/source.vala"
	g_thread_join (_data_->_tmp5_);
#line 425 "../ssh/source.vala"
	_data_->_tmp6_ = _data_->_data6_->err;
#line 425 "../ssh/source.vala"
	if (_data_->_tmp6_ != NULL) {
#line 426 "../ssh/source.vala"
		_data_->_tmp7_ = _data_->_data6_->err;
#line 426 "../ssh/source.vala"
		_data_->_tmp8_ = _g_error_copy0 (_data_->_tmp7_);
#line 426 "../ssh/source.vala"
		_data_->_inner_error0_ = _data_->_tmp8_;
#line 426 "../ssh/source.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 426 "../ssh/source.vala"
		_g_thread_unref0 (_data_->thread);
#line 426 "../ssh/source.vala"
		block6_data_unref (_data_->_data6_);
#line 426 "../ssh/source.vala"
		_data_->_data6_ = NULL;
#line 426 "../ssh/source.vala"
		g_object_unref (_data_->_async_result);
#line 426 "../ssh/source.vala"
		return FALSE;
#line 3206 "source.c"
	}
#line 381 "../ssh/source.vala"
	_g_thread_unref0 (_data_->thread);
#line 381 "../ssh/source.vala"
	block6_data_unref (_data_->_data6_);
#line 381 "../ssh/source.vala"
	_data_->_data6_ = NULL;
#line 381 "../ssh/source.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 381 "../ssh/source.vala"
	if (_data_->_state_ != 0) {
#line 381 "../ssh/source.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 381 "../ssh/source.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3222 "source.c"
		}
	}
#line 381 "../ssh/source.vala"
	g_object_unref (_data_->_async_result);
#line 381 "../ssh/source.vala"
	return FALSE;
#line 3229 "source.c"
}

static void
seahorse_ssh_source_ensure_file_exists (SeahorseSshSource* self,
                                        const gchar* filename)
{
	gint fd = 0;
#line 429 "../ssh/source.vala"
	g_return_if_fail (self != NULL);
#line 429 "../ssh/source.vala"
	g_return_if_fail (filename != NULL);
#line 430 "../ssh/source.vala"
	fd = open (filename, O_WRONLY | O_CREAT, (mode_t) 0644);
#line 431 "../ssh/source.vala"
	close (fd);
#line 3245 "source.c"
}

SeahorseSshKey*
seahorse_ssh_source_find_key_by_fingerprint (SeahorseSshSource* self,
                                             const gchar* fingerprint)
{
	SeahorseSshKey* result;
#line 434 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 434 "../ssh/source.vala"
	g_return_val_if_fail (fingerprint != NULL, NULL);
#line 3257 "source.c"
	{
		guint i = 0U;
#line 435 "../ssh/source.vala"
		i = (guint) 0;
#line 3262 "source.c"
		{
			gboolean _tmp0_ = FALSE;
#line 435 "../ssh/source.vala"
			_tmp0_ = TRUE;
#line 435 "../ssh/source.vala"
			while (TRUE) {
#line 3269 "source.c"
				GPtrArray* _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				GPtrArray* _tmp5_;
				gconstpointer _tmp6_;
				const gchar* _tmp7_;
				const gchar* _tmp8_;
#line 435 "../ssh/source.vala"
				if (!_tmp0_) {
#line 3279 "source.c"
					guint _tmp1_;
#line 435 "../ssh/source.vala"
					_tmp1_ = i;
#line 435 "../ssh/source.vala"
					i = _tmp1_ + 1;
#line 3285 "source.c"
				}
#line 435 "../ssh/source.vala"
				_tmp0_ = FALSE;
#line 435 "../ssh/source.vala"
				_tmp2_ = self->priv->keys;
#line 435 "../ssh/source.vala"
				_tmp3_ = vala_g_ptr_array_get_length (_tmp2_);
#line 435 "../ssh/source.vala"
				_tmp4_ = _tmp3_;
#line 435 "../ssh/source.vala"
				if (!(i < ((guint) _tmp4_))) {
#line 435 "../ssh/source.vala"
					break;
#line 3299 "source.c"
				}
#line 436 "../ssh/source.vala"
				_tmp5_ = self->priv->keys;
#line 436 "../ssh/source.vala"
				_tmp6_ = g_ptr_array_index (_tmp5_, i);
#line 436 "../ssh/source.vala"
				_tmp7_ = seahorse_ssh_key_get_fingerprint ((SeahorseSshKey*) _tmp6_);
#line 436 "../ssh/source.vala"
				_tmp8_ = _tmp7_;
#line 436 "../ssh/source.vala"
				if (g_strcmp0 (_tmp8_, fingerprint) == 0) {
#line 3311 "source.c"
					GPtrArray* _tmp9_;
					gconstpointer _tmp10_;
					SeahorseSshKey* _tmp11_;
#line 437 "../ssh/source.vala"
					_tmp9_ = self->priv->keys;
#line 437 "../ssh/source.vala"
					_tmp10_ = g_ptr_array_index (_tmp9_, i);
#line 437 "../ssh/source.vala"
					_tmp11_ = _g_object_ref0 ((SeahorseSshKey*) _tmp10_);
#line 437 "../ssh/source.vala"
					result = _tmp11_;
#line 437 "../ssh/source.vala"
					return result;
#line 3325 "source.c"
				}
			}
		}
	}
#line 440 "../ssh/source.vala"
	result = NULL;
#line 440 "../ssh/source.vala"
	return result;
#line 3334 "source.c"
}

SeahorseSshSource*
seahorse_ssh_source_construct (GType object_type)
{
	SeahorseSshSource * self = NULL;
#line 26 "../ssh/source.vala"
	self = (SeahorseSshSource*) g_object_new (object_type, NULL);
#line 26 "../ssh/source.vala"
	return self;
#line 3345 "source.c"
}

SeahorseSshSource*
seahorse_ssh_source_new (void)
{
#line 26 "../ssh/source.vala"
	return seahorse_ssh_source_construct (SEAHORSE_SSH_TYPE_SOURCE);
#line 3353 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_label (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	gchar* _tmp0_;
#line 46 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 46 "../ssh/source.vala"
	_tmp0_ = g_strdup (_ ("OpenSSH keys"));
#line 46 "../ssh/source.vala"
	result = _tmp0_;
#line 46 "../ssh/source.vala"
	return result;
#line 3370 "source.c"
}

static void
seahorse_ssh_source_real_set_label (SeahorsePlace* base,
                                    const gchar* value)
{
	SeahorseSshSource* self;
#line 47 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 47 "../ssh/source.vala"
	g_object_notify_by_pspec ((GObject *) self, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_LABEL_PROPERTY]);
#line 3382 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_description (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 51 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 51 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 51 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf (_ ("OpenSSH: %s"), _tmp0_);
#line 51 "../ssh/source.vala"
	result = _tmp1_;
#line 51 "../ssh/source.vala"
	return result;
#line 3402 "source.c"
}

static gchar*
seahorse_ssh_source_real_get_uri (SeahorsePlace* base)
{
	gchar* result;
	SeahorseSshSource* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 55 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 55 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 55 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf (_ ("openssh://%s"), _tmp0_);
#line 55 "../ssh/source.vala"
	result = _tmp1_;
#line 55 "../ssh/source.vala"
	return result;
#line 3422 "source.c"
}

static SeahorsePlaceCategory
seahorse_ssh_source_real_get_category (SeahorsePlace* base)
{
	SeahorsePlaceCategory result;
	SeahorseSshSource* self;
#line 59 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 59 "../ssh/source.vala"
	result = SEAHORSE_PLACE_CATEGORY_KEYS;
#line 59 "../ssh/source.vala"
	return result;
#line 3436 "source.c"
}

static GActionGroup*
seahorse_ssh_source_real_get_actions (SeahorsePlace* base)
{
	GActionGroup* result;
	SeahorseSshSource* self;
#line 63 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 63 "../ssh/source.vala"
	result = NULL;
#line 63 "../ssh/source.vala"
	return result;
#line 3450 "source.c"
}

static const gchar*
seahorse_ssh_source_real_get_action_prefix (SeahorsePlace* base)
{
	const gchar* result;
	SeahorseSshSource* self;
#line 67 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 67 "../ssh/source.vala"
	result = NULL;
#line 67 "../ssh/source.vala"
	return result;
#line 3464 "source.c"
}

static GMenuModel*
seahorse_ssh_source_real_get_menu_model (SeahorsePlace* base)
{
	GMenuModel* result;
	SeahorseSshSource* self;
#line 71 "../ssh/source.vala"
	self = (SeahorseSshSource*) base;
#line 71 "../ssh/source.vala"
	result = NULL;
#line 71 "../ssh/source.vala"
	return result;
#line 3478 "source.c"
}

const gchar*
seahorse_ssh_source_get_base_directory (SeahorseSshSource* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 78 "../ssh/source.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 78 "../ssh/source.vala"
	_tmp0_ = self->priv->ssh_homedir;
#line 78 "../ssh/source.vala"
	result = _tmp0_;
#line 78 "../ssh/source.vala"
	return result;
#line 3494 "source.c"
}

static GObject *
seahorse_ssh_source_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SeahorseSshSource * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 81 "../ssh/source.vala"
	parent_class = G_OBJECT_CLASS (seahorse_ssh_source_parent_class);
#line 81 "../ssh/source.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 81 "../ssh/source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 82 "../ssh/source.vala"
	_tmp0_ = g_get_home_dir ();
#line 82 "../ssh/source.vala"
	_tmp1_ = g_strdup_printf ("%s/.ssh", _tmp0_);
#line 82 "../ssh/source.vala"
	_g_free0 (self->priv->ssh_homedir);
#line 82 "../ssh/source.vala"
	self->priv->ssh_homedir = _tmp1_;
#line 85 "../ssh/source.vala"
	_tmp2_ = self->priv->ssh_homedir;
#line 85 "../ssh/source.vala"
	if (!g_file_test (_tmp2_, G_FILE_TEST_EXISTS)) {
#line 3526 "source.c"
		const gchar* _tmp3_;
#line 86 "../ssh/source.vala"
		_tmp3_ = self->priv->ssh_homedir;
#line 86 "../ssh/source.vala"
		if (g_mkdir (_tmp3_, 0700) != 0) {
#line 3532 "source.c"
			const gchar* _tmp4_;
#line 87 "../ssh/source.vala"
			_tmp4_ = self->priv->ssh_homedir;
#line 87 "../ssh/source.vala"
			g_warning ("source.vala:87: couldn't create .ssh directory: %s", _tmp4_);
#line 88 "../ssh/source.vala"
			return obj;
#line 3540 "source.c"
		}
	}
#line 92 "../ssh/source.vala"
	seahorse_ssh_source_monitor_ssh_homedir (self);
#line 81 "../ssh/source.vala"
	return obj;
#line 3547 "source.c"
}

static void
seahorse_ssh_source_class_init (SeahorseSshSourceClass * klass,
                                gpointer klass_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_parent_class = g_type_class_peek_parent (klass);
#line 26 "../ssh/source.vala"
	g_type_class_adjust_private_offset (klass, &SeahorseSshSource_private_offset);
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_seahorse_ssh_source_get_property;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_seahorse_ssh_source_set_property;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->constructor = seahorse_ssh_source_constructor;
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (klass)->finalize = seahorse_ssh_source_finalize;
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_LABEL_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_URI_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY] = g_param_spec_enum ("category", "category", "category", SEAHORSE_PLACE_TYPE_CATEGORY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", g_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY] = g_param_spec_string ("action-prefix", "action-prefix", "action-prefix", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY] = g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3580 "source.c"
	/**
	     * The directory containing the SSH keys.
	     */
#line 26 "../ssh/source.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY, seahorse_ssh_source_properties[SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY] = g_param_spec_string ("base-directory", "base-directory", "base-directory", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3586 "source.c"
}

static void
seahorse_ssh_source_g_list_model_interface_init (GListModelInterface * iface,
                                                 gpointer iface_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_g_list_model_parent_iface = g_type_interface_peek_parent (iface);
#line 26 "../ssh/source.vala"
	iface->get_item_type = (GType (*) (GListModel*)) seahorse_ssh_source_real_get_item_type;
#line 26 "../ssh/source.vala"
	iface->get_n_items = (guint (*) (GListModel*)) seahorse_ssh_source_real_get_n_items;
#line 26 "../ssh/source.vala"
	iface->get_item = (GObject* (*) (GListModel*, guint)) seahorse_ssh_source_real_get_item;
#line 3601 "source.c"
}

static void
seahorse_ssh_source_seahorse_place_interface_init (SeahorsePlaceIface * iface,
                                                   gpointer iface_data)
{
#line 26 "../ssh/source.vala"
	seahorse_ssh_source_seahorse_place_parent_iface = g_type_interface_peek_parent (iface);
#line 26 "../ssh/source.vala"
	iface->load = (void (*) (SeahorsePlace*, GCancellable*, GAsyncReadyCallback, gpointer)) seahorse_ssh_source_real_load;
#line 26 "../ssh/source.vala"
	iface->load_finish = (gboolean (*) (SeahorsePlace*, GAsyncResult*, GError**)) seahorse_ssh_source_load_finish;
#line 26 "../ssh/source.vala"
	iface->get_label = seahorse_ssh_source_real_get_label;
#line 26 "../ssh/source.vala"
	iface->set_label = seahorse_ssh_source_real_set_label;
#line 26 "../ssh/source.vala"
	iface->get_description = seahorse_ssh_source_real_get_description;
#line 26 "../ssh/source.vala"
	iface->get_uri = seahorse_ssh_source_real_get_uri;
#line 26 "../ssh/source.vala"
	iface->get_category = seahorse_ssh_source_real_get_category;
#line 26 "../ssh/source.vala"
	iface->get_actions = seahorse_ssh_source_real_get_actions;
#line 26 "../ssh/source.vala"
	iface->get_action_prefix = seahorse_ssh_source_real_get_action_prefix;
#line 26 "../ssh/source.vala"
	iface->get_menu_model = seahorse_ssh_source_real_get_menu_model;
#line 3630 "source.c"
}

static void
seahorse_ssh_source_instance_init (SeahorseSshSource * self,
                                   gpointer klass)
{
	GPtrArray* _tmp0_;
#line 26 "../ssh/source.vala"
	self->priv = seahorse_ssh_source_get_instance_private (self);
#line 38 "../ssh/source.vala"
	self->priv->scheduled_refresh_source = (guint) 0;
#line 40 "../ssh/source.vala"
	self->priv->monitor_handle = NULL;
#line 43 "../ssh/source.vala"
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 43 "../ssh/source.vala"
	self->priv->keys = _tmp0_;
#line 3648 "source.c"
}

static void
seahorse_ssh_source_finalize (GObject * obj)
{
	SeahorseSshSource * self;
#line 26 "../ssh/source.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 36 "../ssh/source.vala"
	_g_free0 (self->priv->ssh_homedir);
#line 40 "../ssh/source.vala"
	_g_object_unref0 (self->priv->monitor_handle);
#line 43 "../ssh/source.vala"
	_g_ptr_array_unref0 (self->priv->keys);
#line 26 "../ssh/source.vala"
	G_OBJECT_CLASS (seahorse_ssh_source_parent_class)->finalize (obj);
#line 3665 "source.c"
}

/**
 * The {@link Place} where SSH keys are stored. By default that is ~/.ssh.
 * Basically, this becomes an interface to the SSH home directory.
 */
 G_GNUC_NO_INLINE static GType
seahorse_ssh_source_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SeahorseSshSourceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) seahorse_ssh_source_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SeahorseSshSource), 0, (GInstanceInitFunc) seahorse_ssh_source_instance_init, NULL };
	static const GInterfaceInfo g_list_model_info = { (GInterfaceInitFunc) seahorse_ssh_source_g_list_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo seahorse_place_info = { (GInterfaceInitFunc) seahorse_ssh_source_seahorse_place_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType seahorse_ssh_source_type_id;
	seahorse_ssh_source_type_id = g_type_register_static (G_TYPE_OBJECT, "SeahorseSshSource", &g_define_type_info, 0);
	g_type_add_interface_static (seahorse_ssh_source_type_id, g_list_model_get_type (), &g_list_model_info);
	g_type_add_interface_static (seahorse_ssh_source_type_id, SEAHORSE_TYPE_PLACE, &seahorse_place_info);
	SeahorseSshSource_private_offset = g_type_add_instance_private (seahorse_ssh_source_type_id, sizeof (SeahorseSshSourcePrivate));
	return seahorse_ssh_source_type_id;
}

GType
seahorse_ssh_source_get_type (void)
{
	static gsize seahorse_ssh_source_type_id__once = 0;
	if (g_once_init_enter (&seahorse_ssh_source_type_id__once)) {
		GType seahorse_ssh_source_type_id;
		seahorse_ssh_source_type_id = seahorse_ssh_source_get_type_once ();
		g_once_init_leave (&seahorse_ssh_source_type_id__once, seahorse_ssh_source_type_id);
	}
	return seahorse_ssh_source_type_id__once;
}

static void
_vala_seahorse_ssh_source_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	SeahorseSshSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 26 "../ssh/source.vala"
	switch (property_id) {
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_LABEL_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_label ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_DESCRIPTION_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_description ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_URI_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_string (value, seahorse_place_get_uri ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_CATEGORY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_enum (value, seahorse_place_get_category ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ACTIONS_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_actions ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_ACTION_PREFIX_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_string (value, seahorse_place_get_action_prefix ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_MENU_MODEL_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_take_object (value, seahorse_place_get_menu_model ((SeahorsePlace*) self));
#line 26 "../ssh/source.vala"
		break;
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_BASE_DIRECTORY_PROPERTY:
#line 26 "../ssh/source.vala"
		g_value_set_string (value, seahorse_ssh_source_get_base_directory (self));
#line 26 "../ssh/source.vala"
		break;
#line 3756 "source.c"
		default:
#line 26 "../ssh/source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../ssh/source.vala"
		break;
#line 3762 "source.c"
	}
}

static void
_vala_seahorse_ssh_source_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	SeahorseSshSource * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SEAHORSE_SSH_TYPE_SOURCE, SeahorseSshSource);
#line 26 "../ssh/source.vala"
	switch (property_id) {
#line 26 "../ssh/source.vala"
		case SEAHORSE_SSH_SOURCE_LABEL_PROPERTY:
#line 26 "../ssh/source.vala"
		seahorse_place_set_label ((SeahorsePlace*) self, g_value_get_string (value));
#line 26 "../ssh/source.vala"
		break;
#line 3782 "source.c"
		default:
#line 26 "../ssh/source.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../ssh/source.vala"
		break;
#line 3788 "source.c"
	}
}

